Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Captcha/Captcha.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.Captcha = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from Captcha.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace Captcha.
     * @public
     */

    goog.module('Captcha.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy.asserts');

    goog.require('soy.idom');

    var $templateAlias1 = _metalSoy["default"].getTemplate('FieldBase.incrementaldom', 'render');
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  html: function(),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {function()} */

      soy.asserts.assertType(goog.isFunction(opt_data.html), 'html', opt_data.html, 'function()');

      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var spritemap = soy.asserts.assertType(opt_data.spritemap == null || goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|null|string|undefined');

      var param8 = function param8() {
        $content(opt_data, null, opt_ijData);
      };

      $templateAlias1({
        contentRenderer: param8,
        name: name,
        spritemap: spritemap,
        visible: true
      }, null, opt_ijData);
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  html: function(),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'Captcha.render';
    }
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  html: function()
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $content(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var name = soy.asserts.assertType(opt_data.name == null || goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {function()} */

      var html = soy.asserts.assertType(goog.isFunction(opt_data.html), 'html', opt_data.html, 'function()');
      html();
      incrementalDom.elementOpenStart('input');
      incrementalDom.attr('id', name);
      incrementalDom.attr('type', 'hidden');
      incrementalDom.elementOpenEnd();
      incrementalDom.elementClose('input');
    }

    exports.content = $content;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  html: function()
     * }}
     */

    $content.Params;

    if (goog.DEBUG) {
      $content.soyTemplateName = 'Captcha.content';
    }

    exports.render.params = ["name", "html", "spritemap"];
    exports.render.types = {
      "name": "string",
      "html": "html",
      "spritemap": "string"
    };
    exports.content.params = ["name", "html"];
    exports.content.types = {
      "name": "string",
      "html": "html"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var Captcha = /*#__PURE__*/function (_Component) {
    _inherits(Captcha, _Component);

    function Captcha() {
      _classCallCheck(this, Captcha);

      return _possibleConstructorReturn(this, _getPrototypeOf(Captcha).apply(this, arguments));
    }

    return Captcha;
  }(_metalComponent["default"]);

  exports.Captcha = Captcha;

  _metalSoy["default"].register(Captcha, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=Captcha.soy.js.map
});
//# sourceMappingURL=Captcha.soy.js.map