Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Checkbox/Checkbox.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.Checkbox = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from Checkbox.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace Checkbox.
     * @public
     */

    goog.module('Checkbox.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');

    var $templateAlias1 = _metalSoy["default"].getTemplate('FieldBase.incrementaldom', 'render');
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  handleInputChangeEvent: (*|null|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  predefinedValue: (?),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showAsSwitcher: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  value: (?),
     *  visible: (boolean|null|undefined),
     *  valid: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      var $$temp;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {boolean|null|undefined} */

      var displayErrors = soy.asserts.assertType(opt_data.displayErrors == null || goog.isBoolean(opt_data.displayErrors) || opt_data.displayErrors === 1 || opt_data.displayErrors === 0, 'displayErrors', opt_data.displayErrors, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var errorMessage = soy.asserts.assertType(opt_data.errorMessage == null || goog.isString(opt_data.errorMessage) || opt_data.errorMessage instanceof goog.soy.data.SanitizedContent, 'errorMessage', opt_data.errorMessage, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {*|null|undefined} */

      var handleInputChangeEvent = opt_data.handleInputChangeEvent;
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var id = soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var label = soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {?} */

      var predefinedValue = opt_data.predefinedValue;
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var repeatable = soy.asserts.assertType(opt_data.repeatable == null || goog.isBoolean(opt_data.repeatable) || opt_data.repeatable === 1 || opt_data.repeatable === 0, 'repeatable', opt_data.repeatable, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var required = soy.asserts.assertType(opt_data.required == null || goog.isBoolean(opt_data.required) || opt_data.required === 1 || opt_data.required === 0, 'required', opt_data.required, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showAsSwitcher = soy.asserts.assertType(opt_data.showAsSwitcher == null || goog.isBoolean(opt_data.showAsSwitcher) || opt_data.showAsSwitcher === 1 || opt_data.showAsSwitcher === 0, 'showAsSwitcher', opt_data.showAsSwitcher, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showLabel = soy.asserts.assertType(opt_data.showLabel == null || goog.isBoolean(opt_data.showLabel) || opt_data.showLabel === 1 || opt_data.showLabel === 0, 'showLabel', opt_data.showLabel, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var spritemap = soy.asserts.assertType(opt_data.spritemap == null || goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tip = soy.asserts.assertType(opt_data.tip == null || goog.isString(opt_data.tip) || opt_data.tip instanceof goog.soy.data.SanitizedContent, 'tip', opt_data.tip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {?} */

      var value = opt_data.value;
      /** @type {boolean|null|undefined} */

      var visible = soy.asserts.assertType(opt_data.visible == null || goog.isBoolean(opt_data.visible) || opt_data.visible === 1 || opt_data.visible === 0, 'visible', opt_data.visible, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var valid = soy.asserts.assertType(opt_data.valid == null || goog.isBoolean(opt_data.valid) || opt_data.valid === 1 || opt_data.valid === 0, 'valid', opt_data.valid, 'boolean|null|undefined');
      var isChecked__soy60 = value != null ? value : predefinedValue;

      var param63 = function param63() {
        $content({
          checked: isChecked__soy60,
          disabled: readOnly,
          handleInputChangeEvent: handleInputChangeEvent,
          label: label,
          name: name,
          required: required,
          showAsSwitcher: showAsSwitcher,
          showLabel: ($$temp = showLabel) == null ? true : $$temp,
          spritemap: spritemap
        }, null, opt_ijData);
      };

      $templateAlias1({
        contentRenderer: param63,
        displayErrors: displayErrors,
        errorMessage: errorMessage,
        id: id,
        label: label,
        name: name,
        repeatable: repeatable,
        required: required,
        showLabel: false,
        spritemap: spritemap,
        tip: tip,
        valid: valid,
        visible: visible
      }, null, opt_ijData);
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  handleInputChangeEvent: (*|null|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  predefinedValue: (?),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showAsSwitcher: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  value: (?),
     *  visible: (boolean|null|undefined),
     *  valid: (boolean|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'Checkbox.render';
    }
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  checked: (boolean|null|undefined),
     *  disabled: (boolean|null|undefined),
     *  handleInputChangeEvent: (*|null|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  required: (boolean|null|undefined),
     *  showAsSwitcher: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $content(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {boolean|null|undefined} */

      var checked = soy.asserts.assertType(opt_data.checked == null || goog.isBoolean(opt_data.checked) || opt_data.checked === 1 || opt_data.checked === 0, 'checked', opt_data.checked, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var disabled = soy.asserts.assertType(opt_data.disabled == null || goog.isBoolean(opt_data.disabled) || opt_data.disabled === 1 || opt_data.disabled === 0, 'disabled', opt_data.disabled, 'boolean|null|undefined');
      /** @type {*|null|undefined} */

      var handleInputChangeEvent = opt_data.handleInputChangeEvent;
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var label = soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var required = soy.asserts.assertType(opt_data.required == null || goog.isBoolean(opt_data.required) || opt_data.required === 1 || opt_data.required === 0, 'required', opt_data.required, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showAsSwitcher = soy.asserts.assertType(opt_data.showAsSwitcher == null || goog.isBoolean(opt_data.showAsSwitcher) || opt_data.showAsSwitcher === 1 || opt_data.showAsSwitcher === 0, 'showAsSwitcher', opt_data.showAsSwitcher, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showLabel = soy.asserts.assertType(opt_data.showLabel == null || goog.isBoolean(opt_data.showLabel) || opt_data.showLabel === 1 || opt_data.showLabel === 0, 'showLabel', opt_data.showLabel, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var spritemap = soy.asserts.assertType(opt_data.spritemap == null || goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|null|string|undefined');

      if (showAsSwitcher) {
        incrementalDom.elementOpenStart('label');
        incrementalDom.attr('class', 'ddm-toggle-switch toggle-switch');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('input');

        if (checked) {
          incrementalDom.attr('checked', '');
        }

        incrementalDom.attr('class', 'toggle-switch-check');
        incrementalDom.attr('data-onchange', handleInputChangeEvent);

        if (disabled) {
          incrementalDom.attr('disabled', '');
        }

        incrementalDom.attr('name', name);
        incrementalDom.attr('type', 'checkbox');
        incrementalDom.attr('value', 'true');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementClose('input');
        incrementalDom.elementOpenStart('span');
        incrementalDom.attr('aria-hidden', 'true');
        incrementalDom.attr('class', 'toggle-switch-bar');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('span');
        incrementalDom.attr('class', 'toggle-switch-handle');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementClose('span');

        if (showLabel || required) {
          incrementalDom.elementOpenStart('span');
          incrementalDom.attr('class', 'toggle-switch-text toggle-switch-text-right');
          incrementalDom.elementOpenEnd();

          if (showLabel) {
            soyIdom.print(label);
            incrementalDom.text(' ');
          }

          if (required) {
            incrementalDom.elementOpenStart('svg');
            incrementalDom.attr('aria-hidden', 'true');
            incrementalDom.attr('class', 'lexicon-icon lexicon-icon-asterisk reference-mark');
            incrementalDom.elementOpenEnd();
            incrementalDom.elementOpenStart('use');
            incrementalDom.attr('xlink:href', spritemap + '#asterisk');
            incrementalDom.elementOpenEnd();
            incrementalDom.elementClose('use');
            incrementalDom.elementClose('svg');
          }

          incrementalDom.elementClose('span');
        }

        incrementalDom.elementClose('span');
        incrementalDom.elementClose('label');
      } else {
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'custom-control custom-checkbox');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpen('label');

        var inputAttributes__soy133 = function inputAttributes__soy133() {
          if (checked) {
            incrementalDom.attr('checked', 'checked');
          }

          incrementalDom.attr('class', 'custom-control-input');
          incrementalDom.attr('data-onchange', handleInputChangeEvent);

          if (disabled) {
            incrementalDom.attr('disabled', 'disabled');
          }

          incrementalDom.attr('name', name);
          incrementalDom.attr('type', 'checkbox');
          incrementalDom.attr('value', 'true');
        };

        incrementalDom.elementOpenStart('input');
        inputAttributes__soy133();
        incrementalDom.elementOpenEnd();
        incrementalDom.elementClose('input');

        if (showLabel) {
          incrementalDom.elementOpenStart('span');
          incrementalDom.attr('class', 'custom-control-label');
          incrementalDom.elementOpenEnd();
          incrementalDom.elementOpenStart('span');
          incrementalDom.attr('class', 'custom-control-label-text');
          incrementalDom.elementOpenEnd();
          soyIdom.print(label);
          incrementalDom.text(' ');
          incrementalDom.elementClose('span');
          incrementalDom.elementClose('span');

          if (required) {
            incrementalDom.elementOpenStart('svg');
            incrementalDom.attr('aria-hidden', 'true');
            incrementalDom.attr('class', 'lexicon-icon lexicon-icon-asterisk reference-mark');
            incrementalDom.elementOpenEnd();
            incrementalDom.elementOpenStart('use');
            incrementalDom.attr('xlink:href', spritemap + '#asterisk');
            incrementalDom.elementOpenEnd();
            incrementalDom.elementClose('use');
            incrementalDom.elementClose('svg');
          }
        }

        incrementalDom.elementClose('label');
        incrementalDom.elementClose('div');
      }
    }

    exports.content = $content;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  checked: (boolean|null|undefined),
     *  disabled: (boolean|null|undefined),
     *  handleInputChangeEvent: (*|null|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  required: (boolean|null|undefined),
     *  showAsSwitcher: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }}
     */

    $content.Params;

    if (goog.DEBUG) {
      $content.soyTemplateName = 'Checkbox.content';
    }

    exports.render.params = ["name", "displayErrors", "errorMessage", "handleInputChangeEvent", "id", "label", "predefinedValue", "readOnly", "repeatable", "required", "showAsSwitcher", "showLabel", "spritemap", "tip", "value", "visible", "valid"];
    exports.render.types = {
      "name": "string",
      "displayErrors": "bool",
      "errorMessage": "string",
      "handleInputChangeEvent": "any",
      "id": "string",
      "label": "string",
      "predefinedValue": "?",
      "readOnly": "bool",
      "repeatable": "bool",
      "required": "bool",
      "showAsSwitcher": "bool",
      "showLabel": "bool",
      "spritemap": "string",
      "tip": "string",
      "value": "?",
      "visible": "bool",
      "valid": "bool"
    };
    exports.content.params = ["name", "checked", "disabled", "handleInputChangeEvent", "label", "required", "showAsSwitcher", "showLabel", "spritemap"];
    exports.content.types = {
      "name": "string",
      "checked": "bool",
      "disabled": "bool",
      "handleInputChangeEvent": "any",
      "label": "string",
      "required": "bool",
      "showAsSwitcher": "bool",
      "showLabel": "bool",
      "spritemap": "string"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var Checkbox = /*#__PURE__*/function (_Component) {
    _inherits(Checkbox, _Component);

    function Checkbox() {
      _classCallCheck(this, Checkbox);

      return _possibleConstructorReturn(this, _getPrototypeOf(Checkbox).apply(this, arguments));
    }

    return Checkbox;
  }(_metalComponent["default"]);

  exports.Checkbox = Checkbox;

  _metalSoy["default"].register(Checkbox, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=Checkbox.soy.js.map
});
//# sourceMappingURL=Checkbox.soy.js.map