Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/CheckboxMultiple/CheckboxMultiple.es", ['module', 'exports', 'require', '../FieldBase/FieldBase.es', './CheckboxMultipleRegister.soy', 'frontend-taglib-clay$clay-checkbox', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', '../util/setters.es', './CheckboxMultiple.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("../FieldBase/FieldBase.es");

  require("./CheckboxMultipleRegister.soy");

  require("frontend-taglib-clay$clay-checkbox");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _setters = require("../util/setters.es");

  var _CheckboxMultiple = _interopRequireDefault(require("./CheckboxMultiple.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  /**
   * CheckboxMultiple.
   * @extends Component
   */
  var CheckboxMultiple = /*#__PURE__*/function (_Component) {
    _inherits(CheckboxMultiple, _Component);

    function CheckboxMultiple() {
      _classCallCheck(this, CheckboxMultiple);

      return _possibleConstructorReturn(this, _getPrototypeOf(CheckboxMultiple).apply(this, arguments));
    }

    _createClass(CheckboxMultiple, [{
      key: "_handleFieldBlurred",
      value: function _handleFieldBlurred(event) {
        this.emit('fieldBlurred', {
          fieldInstance: this,
          originalEvent: event,
          value: event.target.value
        });
      }
    }, {
      key: "_handleFieldChanged",
      value: function _handleFieldChanged(event) {
        var _this = this;

        var target = event.target;
        var value = this.value.filter(function (currentValue) {
          return currentValue !== target.value;
        });

        if (target.checked) {
          value.push(target.value);
        }

        this.setState({
          value: value
        }, function () {
          _this.emit('fieldEdited', {
            fieldInstance: _this,
            originalEvent: event,
            value: value
          });
        });
      }
    }, {
      key: "_handleFieldFocused",
      value: function _handleFieldFocused(event) {
        this.emit('fieldFocused', {
          fieldInstance: this,
          originalEvent: event
        });
      }
    }]);

    return CheckboxMultiple;
  }(_metalComponent["default"]);

  _metalSoy["default"].register(CheckboxMultiple, _CheckboxMultiple["default"]);

  CheckboxMultiple.STATE = {
    /**
     * @default 'string'
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    dataType: _metalState.Config.string().value('boolean'),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?bool}
     */
    evaluable: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(string|undefined)}
     */
    fieldName: _metalState.Config.string(),

    /**
     * @default false
     * @instance
     * @memberof Checkbox
     * @type {?bool}
     */
    inline: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof Checkbox
     * @type {?(string|undefined)}
     */
    label: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Checkbox
     * @type {?(string|undefined)}
     */
    options: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
      label: _metalState.Config.string(),
      name: _metalState.Config.string(),
      value: _metalState.Config.string()
    })).value([{
      label: 'Option 1'
    }, {
      label: 'Option 2'
    }]),

    /**
     * @default undefined
     * @instance
     * @memberof Select
     * @type {?string}
     */
    predefinedValue: _metalState.Config.oneOfType([_metalState.Config.array(), _metalState.Config.object()]).setter(_setters.setJSONArrayValue).value([]),

    /**
     * @default false
     * @instance
     * @memberof Checkbox
     * @type {?bool}
     */
    readOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(bool|undefined)}
     */
    repeatable: _metalState.Config.bool(),

    /**
     * @default false
     * @instance
     * @memberof Checkbox
     * @type {?bool}
     */
    required: _metalState.Config.bool().value(false),

    /**
     * @default true
     * @instance
     * @memberof Checkbox
     * @type {?bool}
     */
    showAsSwitcher: _metalState.Config.bool().value(true),

    /**
     * @default true
     * @instance
     * @memberof Checkbox
     * @type {?bool}
     */
    showLabel: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof Checkbox
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(string|undefined)}
     */
    tip: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    type: _metalState.Config.string().value('checkbox'),

    /**
     * @default undefined
     * @instance
     * @memberof Checkbox
     * @type {?(bool)}
     */
    value: _metalState.Config.oneOfType([_metalState.Config.array(), _metalState.Config.object()]).setter(_setters.setJSONArrayValue)
  };
  var _default = CheckboxMultiple;
  exports["default"] = _default;
  //# sourceMappingURL=CheckboxMultiple.es.js.map
});
//# sourceMappingURL=CheckboxMultiple.es.js.map