Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/CheckboxMultiple/CheckboxMultiple.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.CheckboxMultiple = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from CheckboxMultiple.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace CheckboxMultiple.
     * @public
     */

    goog.module('CheckboxMultiple.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');

    var $templateAlias1 = _metalSoy["default"].getTemplate('FieldBase.incrementaldom', 'render');
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  value: (?),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  inline: (boolean|null|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  options: (!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined),
     *  predefinedValue: (!Array|null|undefined),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showAsSwitcher: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  type: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  visible: (boolean|null|undefined),
     *  valid: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {?} */

      var value = opt_data.value;
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleFieldChanged = opt_data._handleFieldChanged;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;
      /** @type {boolean|null|undefined} */

      var displayErrors = soy.asserts.assertType(opt_data.displayErrors == null || goog.isBoolean(opt_data.displayErrors) || opt_data.displayErrors === 1 || opt_data.displayErrors === 0, 'displayErrors', opt_data.displayErrors, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var errorMessage = soy.asserts.assertType(opt_data.errorMessage == null || goog.isString(opt_data.errorMessage) || opt_data.errorMessage instanceof goog.soy.data.SanitizedContent, 'errorMessage', opt_data.errorMessage, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var id = soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var inline = soy.asserts.assertType(opt_data.inline == null || goog.isBoolean(opt_data.inline) || opt_data.inline === 1 || opt_data.inline === 0, 'inline', opt_data.inline, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var label = soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined} */

      var options = soy.asserts.assertType(opt_data.options == null || goog.isArray(opt_data.options), 'options', opt_data.options, '!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined');
      /** @type {!Array|null|undefined} */

      var predefinedValue = soy.asserts.assertType(opt_data.predefinedValue == null || goog.isArray(opt_data.predefinedValue), 'predefinedValue', opt_data.predefinedValue, '!Array|null|undefined');
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var repeatable = soy.asserts.assertType(opt_data.repeatable == null || goog.isBoolean(opt_data.repeatable) || opt_data.repeatable === 1 || opt_data.repeatable === 0, 'repeatable', opt_data.repeatable, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var required = soy.asserts.assertType(opt_data.required == null || goog.isBoolean(opt_data.required) || opt_data.required === 1 || opt_data.required === 0, 'required', opt_data.required, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showAsSwitcher = soy.asserts.assertType(opt_data.showAsSwitcher == null || goog.isBoolean(opt_data.showAsSwitcher) || opt_data.showAsSwitcher === 1 || opt_data.showAsSwitcher === 0, 'showAsSwitcher', opt_data.showAsSwitcher, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showLabel = soy.asserts.assertType(opt_data.showLabel == null || goog.isBoolean(opt_data.showLabel) || opt_data.showLabel === 1 || opt_data.showLabel === 0, 'showLabel', opt_data.showLabel, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var spritemap = soy.asserts.assertType(opt_data.spritemap == null || goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tip = soy.asserts.assertType(opt_data.tip == null || goog.isString(opt_data.tip) || opt_data.tip instanceof goog.soy.data.SanitizedContent, 'tip', opt_data.tip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var type = soy.asserts.assertType(opt_data.type == null || goog.isString(opt_data.type) || opt_data.type instanceof goog.soy.data.SanitizedContent, 'type', opt_data.type, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var visible = soy.asserts.assertType(opt_data.visible == null || goog.isBoolean(opt_data.visible) || opt_data.visible === 1 || opt_data.visible === 0, 'visible', opt_data.visible, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var valid = soy.asserts.assertType(opt_data.valid == null || goog.isBoolean(opt_data.valid) || opt_data.valid === 1 || opt_data.valid === 0, 'valid', opt_data.valid, 'boolean|null|undefined');

      var param349 = function param349() {
        $content({
          _handleFieldBlurred: _handleFieldBlurred,
          _handleFieldChanged: _handleFieldChanged,
          _handleFieldFocused: _handleFieldFocused,
          disabled: readOnly,
          inline: inline,
          name: name,
          options: options,
          predefinedValue: predefinedValue,
          showAsSwitcher: showAsSwitcher,
          value: value
        }, null, opt_ijData);
      };

      $templateAlias1({
        contentRenderer: param349,
        displayErrors: displayErrors,
        errorMessage: errorMessage,
        id: id,
        label: label,
        name: name,
        ref: 'base',
        repeatable: repeatable,
        required: required,
        showLabel: showLabel,
        spritemap: spritemap,
        tip: tip,
        type: type,
        valid: valid,
        visible: visible
      }, null, opt_ijData);
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  value: (?),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  inline: (boolean|null|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  options: (!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined),
     *  predefinedValue: (!Array|null|undefined),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showAsSwitcher: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  type: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  visible: (boolean|null|undefined),
     *  valid: (boolean|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'CheckboxMultiple.render';
    }
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  value: (?),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  disabled: (boolean|null|undefined),
     *  inline: (boolean|null|undefined),
     *  options: (!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined),
     *  predefinedValue: (!Array|null|undefined),
     *  showAsSwitcher: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $content(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {?} */

      var value = opt_data.value;
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleFieldChanged = opt_data._handleFieldChanged;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;
      /** @type {boolean|null|undefined} */

      var disabled = soy.asserts.assertType(opt_data.disabled == null || goog.isBoolean(opt_data.disabled) || opt_data.disabled === 1 || opt_data.disabled === 0, 'disabled', opt_data.disabled, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var inline = soy.asserts.assertType(opt_data.inline == null || goog.isBoolean(opt_data.inline) || opt_data.inline === 1 || opt_data.inline === 0, 'inline', opt_data.inline, 'boolean|null|undefined');
      /** @type {!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined} */

      var options = soy.asserts.assertType(opt_data.options == null || goog.isArray(opt_data.options), 'options', opt_data.options, '!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined');
      /** @type {!Array|null|undefined} */

      var predefinedValue = soy.asserts.assertType(opt_data.predefinedValue == null || goog.isArray(opt_data.predefinedValue), 'predefinedValue', opt_data.predefinedValue, '!Array|null|undefined');
      /** @type {boolean|null|undefined} */

      var showAsSwitcher = soy.asserts.assertType(opt_data.showAsSwitcher == null || goog.isBoolean(opt_data.showAsSwitcher) || opt_data.showAsSwitcher === 1 || opt_data.showAsSwitcher === 0, 'showAsSwitcher', opt_data.showAsSwitcher, 'boolean|null|undefined');
      var displayValue__soy390 = value && value.length > 0 ? value : predefinedValue;
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'lfr-ddm-checkbox-multiple');
      incrementalDom.elementOpenEnd();

      if (options) {
        var option470List = options;
        var option470ListLen = option470List.length;

        for (var option470Index = 0; option470Index < option470ListLen; option470Index++) {
          var option470Data = option470List[option470Index];
          var checked__soy396 = '';

          if (displayValue__soy390) {
            var currentValue406List = displayValue__soy390;
            var currentValue406ListLen = currentValue406List.length;

            for (var currentValue406Index = 0; currentValue406Index < currentValue406ListLen; currentValue406Index++) {
              var currentValue406Data = currentValue406List[currentValue406Index];
              checked__soy396 += currentValue406Data == option470Data.value ? 'checked' : '';
            }
          }

          if (showAsSwitcher) {
            incrementalDom.elementOpenStart('div');
            incrementalDom.attr('class', 'lfr-ddm-form-field-checkbox-switch  ' + (inline ? ' lfr-ddm-form-field-checkbox-switch-inline ' : ''));
            incrementalDom.elementOpenEnd();
            incrementalDom.elementOpenStart('label');
            incrementalDom.attr('class', 'simple-toggle-switch toggle-switch');
            incrementalDom.elementOpenEnd();

            var attributes__soy418 = function attributes__soy418() {
              incrementalDom.attr('class', 'toggle-switch-check');
              incrementalDom.attr('data-index', option470Index);
              incrementalDom.attr('data-onblur', _handleFieldBlurred);
              incrementalDom.attr('data-onchange', _handleFieldChanged);
              incrementalDom.attr('data-onfocus', _handleFieldFocused);

              if (checked__soy396 == 'checked') {
                incrementalDom.attr('checked', '');
              }

              if (disabled) {
                incrementalDom.attr('disabled', '');
              }

              incrementalDom.attr('name', name);
              incrementalDom.attr('ref', 'input' + option470Index);
              incrementalDom.attr('type', 'checkbox');
              incrementalDom.attr('value', option470Data.value);
            };

            incrementalDom.elementOpenStart('input');
            attributes__soy418();
            incrementalDom.elementOpenEnd();
            incrementalDom.elementClose('input');
            incrementalDom.elementOpenStart('span');
            incrementalDom.attr('aria-hidden', 'true');
            incrementalDom.attr('class', 'toggle-switch-bar');
            incrementalDom.elementOpenEnd();
            incrementalDom.elementOpenStart('span');
            incrementalDom.attr('class', 'toggle-switch-handle');
            incrementalDom.elementOpenEnd();
            incrementalDom.elementClose('span');
            incrementalDom.elementClose('span');
            incrementalDom.elementOpenStart('span');
            incrementalDom.attr('class', 'toggle-switch-label');
            incrementalDom.elementOpenEnd();
            soyIdom.print(option470Data.label);
            incrementalDom.elementClose('span');
            incrementalDom.elementClose('label');
            incrementalDom.elementClose('div');
          } else {
            var attributes__soy449 = function attributes__soy449() {
              incrementalDom.attr('class', 'custom-control custom-checkbox' + (inline ? ' custom-control-inline' : ''));
            };

            incrementalDom.elementOpenStart('div');
            attributes__soy449();
            incrementalDom.elementOpenEnd();
            $input({
              _handleFieldBlurred: _handleFieldBlurred,
              _handleFieldChanged: _handleFieldChanged,
              _handleFieldFocused: _handleFieldFocused,
              checked: checked__soy396 == 'checked' ? true : false,
              disabled: disabled,
              label: option470Data.label,
              name: name,
              showLabel: true,
              value: option470Data.value
            }, null, opt_ijData);
            incrementalDom.elementClose('div');
          }
        }
      }

      incrementalDom.elementClose('div');
    }

    exports.content = $content;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  value: (?),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  disabled: (boolean|null|undefined),
     *  inline: (boolean|null|undefined),
     *  options: (!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined),
     *  predefinedValue: (!Array|null|undefined),
     *  showAsSwitcher: (boolean|null|undefined)
     * }}
     */

    $content.Params;

    if (goog.DEBUG) {
      $content.soyTemplateName = 'CheckboxMultiple.content';
    }
    /**
     * @param {{
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  checked: (boolean|null|undefined),
     *  disabled: (boolean|null|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  labelContent: (function()|null|undefined),
     *  name: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  showLabel: (boolean|null|undefined),
     *  value: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $input(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      opt_data = opt_data || {};
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleFieldChanged = opt_data._handleFieldChanged;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;
      /** @type {boolean|null|undefined} */

      var checked = soy.asserts.assertType(opt_data.checked == null || goog.isBoolean(opt_data.checked) || opt_data.checked === 1 || opt_data.checked === 0, 'checked', opt_data.checked, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var disabled = soy.asserts.assertType(opt_data.disabled == null || goog.isBoolean(opt_data.disabled) || opt_data.disabled === 1 || opt_data.disabled === 0, 'disabled', opt_data.disabled, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var label = soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {function()|null|undefined} */

      var labelContent = soy.asserts.assertType(opt_data.labelContent == null || goog.isFunction(opt_data.labelContent), 'labelContent', opt_data.labelContent, 'function()|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var name = soy.asserts.assertType(opt_data.name == null || goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var showLabel = soy.asserts.assertType(opt_data.showLabel == null || goog.isBoolean(opt_data.showLabel) || opt_data.showLabel === 1 || opt_data.showLabel === 0, 'showLabel', opt_data.showLabel, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var value = soy.asserts.assertType(opt_data.value == null || goog.isString(opt_data.value) || opt_data.value instanceof goog.soy.data.SanitizedContent, 'value', opt_data.value, '!goog.soy.data.SanitizedContent|null|string|undefined');
      incrementalDom.elementOpen('label');

      incrementalDom.elementOpenStart('input');
      (function inputAttributes__soy487() {
        if (checked) {
          incrementalDom.attr('checked', 'checked');
        }

        if (disabled) {
          incrementalDom.attr('disabled', 'disabled');
        }

        incrementalDom.attr('class', 'custom-control-input');
        incrementalDom.attr('data-onblur', _handleFieldBlurred);
        incrementalDom.attr('data-onchange', _handleFieldChanged);
        incrementalDom.attr('data-onfocus', _handleFieldFocused);

        if (name) {
          incrementalDom.attr('name', name);
        }

        if (value) {
          incrementalDom.attr('value', value);
        }

        incrementalDom.attr('ref', 'input');
        incrementalDom.attr('type', 'checkbox');
      })();
      incrementalDom.elementOpenEnd();
      incrementalDom.elementClose('input');
      incrementalDom.elementOpenStart('span');
      incrementalDom.attr('class', 'custom-control-label');
      incrementalDom.elementOpenEnd();

      if (label) {
        var spanLabelClasses__soy521 = '';
        spanLabelClasses__soy521 += 'custom-control-label-text';
        spanLabelClasses__soy521 += !showLabel ? ' sr-only' : '';
        incrementalDom.elementOpenStart('span');
        incrementalDom.attr('class', spanLabelClasses__soy521);
        incrementalDom.elementOpenEnd();
        soyIdom.print(label);
        incrementalDom.elementClose('span');
      }

      incrementalDom.elementClose('span');

      if (labelContent) {
        labelContent();
      }

      incrementalDom.elementClose('label');
    }

    exports.input = $input;
    /**
     * @typedef {{
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  checked: (boolean|null|undefined),
     *  disabled: (boolean|null|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  labelContent: (function()|null|undefined),
     *  name: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  showLabel: (boolean|null|undefined),
     *  value: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }}
     */

    $input.Params;

    if (goog.DEBUG) {
      $input.soyTemplateName = 'CheckboxMultiple.input';
    }

    exports.render.params = ["name", "value", "_handleFieldBlurred", "_handleFieldChanged", "_handleFieldFocused", "displayErrors", "errorMessage", "id", "inline", "label", "options", "predefinedValue", "readOnly", "repeatable", "required", "showAsSwitcher", "showLabel", "spritemap", "tip", "type", "visible", "valid"];
    exports.render.types = {
      "name": "string",
      "value": "?",
      "_handleFieldBlurred": "any",
      "_handleFieldChanged": "any",
      "_handleFieldFocused": "any",
      "displayErrors": "bool",
      "errorMessage": "string",
      "id": "string",
      "inline": "bool",
      "label": "string",
      "options": "list<[\n\t\tlabel: string,\n\t\tvalue: string\n\t]>",
      "predefinedValue": "list<any>",
      "readOnly": "bool",
      "repeatable": "bool",
      "required": "bool",
      "showAsSwitcher": "bool",
      "showLabel": "bool",
      "spritemap": "string",
      "tip": "string",
      "type": "string",
      "visible": "bool",
      "valid": "bool"
    };
    exports.content.params = ["name", "value", "_handleFieldBlurred", "_handleFieldChanged", "_handleFieldFocused", "disabled", "inline", "options", "predefinedValue", "showAsSwitcher"];
    exports.content.types = {
      "name": "string",
      "value": "?",
      "_handleFieldBlurred": "any",
      "_handleFieldChanged": "any",
      "_handleFieldFocused": "any",
      "disabled": "bool",
      "inline": "bool",
      "options": "list<[\n\t\tlabel: string,\n\t\tvalue: string\n\t]>",
      "predefinedValue": "list<any>",
      "showAsSwitcher": "bool"
    };
    exports.input.params = ["_handleFieldBlurred", "_handleFieldChanged", "_handleFieldFocused", "checked", "disabled", "label", "labelContent", "name", "showLabel", "value"];
    exports.input.types = {
      "_handleFieldBlurred": "any",
      "_handleFieldChanged": "any",
      "_handleFieldFocused": "any",
      "checked": "bool",
      "disabled": "bool",
      "label": "string",
      "labelContent": "html",
      "name": "string",
      "showLabel": "bool",
      "value": "string"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var CheckboxMultiple = /*#__PURE__*/function (_Component) {
    _inherits(CheckboxMultiple, _Component);

    function CheckboxMultiple() {
      _classCallCheck(this, CheckboxMultiple);

      return _possibleConstructorReturn(this, _getPrototypeOf(CheckboxMultiple).apply(this, arguments));
    }

    return CheckboxMultiple;
  }(_metalComponent["default"]);

  exports.CheckboxMultiple = CheckboxMultiple;

  _metalSoy["default"].register(CheckboxMultiple, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=CheckboxMultiple.soy.js.map
});
//# sourceMappingURL=CheckboxMultiple.soy.js.map