Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Editor/Editor.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.Editor = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from Editor.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace Editor.
     * @public
     */

    goog.module('Editor.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');

    var $templateAlias1 = _metalSoy["default"].getTemplate('FieldBase.incrementaldom', 'render');
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tooltip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  value: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  visible: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {boolean|null|undefined} */

      var displayErrors = soy.asserts.assertType(opt_data.displayErrors == null || goog.isBoolean(opt_data.displayErrors) || opt_data.displayErrors === 1 || opt_data.displayErrors === 0, 'displayErrors', opt_data.displayErrors, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var errorMessage = soy.asserts.assertType(opt_data.errorMessage == null || goog.isString(opt_data.errorMessage) || opt_data.errorMessage instanceof goog.soy.data.SanitizedContent, 'errorMessage', opt_data.errorMessage, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var id = soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var label = soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      soy.asserts.assertType(opt_data.placeholder == null || goog.isString(opt_data.placeholder) || opt_data.placeholder instanceof goog.soy.data.SanitizedContent, 'placeholder', opt_data.placeholder, '!goog.soy.data.SanitizedContent|null|string|undefined');

      /** @type {boolean|null|undefined} */

      var repeatable = soy.asserts.assertType(opt_data.repeatable == null || goog.isBoolean(opt_data.repeatable) || opt_data.repeatable === 1 || opt_data.repeatable === 0, 'repeatable', opt_data.repeatable, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var required = soy.asserts.assertType(opt_data.required == null || goog.isBoolean(opt_data.required) || opt_data.required === 1 || opt_data.required === 0, 'required', opt_data.required, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showLabel = soy.asserts.assertType(opt_data.showLabel == null || goog.isBoolean(opt_data.showLabel) || opt_data.showLabel === 1 || opt_data.showLabel === 0, 'showLabel', opt_data.showLabel, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var spritemap = soy.asserts.assertType(opt_data.spritemap == null || goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tip = soy.asserts.assertType(opt_data.tip == null || goog.isString(opt_data.tip) || opt_data.tip instanceof goog.soy.data.SanitizedContent, 'tip', opt_data.tip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tooltip = soy.asserts.assertType(opt_data.tooltip == null || goog.isString(opt_data.tooltip) || opt_data.tooltip instanceof goog.soy.data.SanitizedContent, 'tooltip', opt_data.tooltip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var valid = soy.asserts.assertType(opt_data.valid == null || goog.isBoolean(opt_data.valid) || opt_data.valid === 1 || opt_data.valid === 0, 'valid', opt_data.valid, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      soy.asserts.assertType(opt_data.value == null || goog.isString(opt_data.value) || opt_data.value instanceof goog.soy.data.SanitizedContent, 'value', opt_data.value, '!goog.soy.data.SanitizedContent|null|string|undefined');

      /** @type {boolean|null|undefined} */

      var visible = soy.asserts.assertType(opt_data.visible == null || goog.isBoolean(opt_data.visible) || opt_data.visible === 1 || opt_data.visible === 0, 'visible', opt_data.visible, 'boolean|null|undefined');

      var param1372 = function param1372() {
        $content(opt_data, null, opt_ijData);
      };

      $templateAlias1({
        contentRenderer: param1372,
        displayErrors: displayErrors,
        errorMessage: errorMessage,
        id: id,
        label: label,
        name: name,
        repeatable: repeatable,
        required: required,
        showLabel: showLabel,
        spritemap: spritemap,
        tip: tip,
        tooltip: tooltip,
        valid: valid,
        visible: visible
      }, null, opt_ijData);
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tooltip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  value: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  visible: (boolean|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'Editor.render';
    }
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  value: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $content(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var placeholder = soy.asserts.assertType(opt_data.placeholder == null || goog.isString(opt_data.placeholder) || opt_data.placeholder instanceof goog.soy.data.SanitizedContent, 'placeholder', opt_data.placeholder, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var value = soy.asserts.assertType(opt_data.value == null || goog.isString(opt_data.value) || opt_data.value instanceof goog.soy.data.SanitizedContent, 'value', opt_data.value, '!goog.soy.data.SanitizedContent|null|string|undefined');
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'field-type-editor form-control input-group-container');
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'alloy-editor-container input-group');
      incrementalDom.attr('id', name + 'Container');
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'alloy-editor');
      incrementalDom.attr('contenteditable', 'false');
      incrementalDom.attr('data-placeholder', placeholder);
      incrementalDom.attr('id', name + 'EditorContainer');
      incrementalDom.attr('name', name + 'Editor');
      incrementalDom.elementOpenEnd();
      soyIdom.print(value);
      incrementalDom.elementClose('div');
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'alloy-editor-placeholder');
      incrementalDom.elementOpenEnd();
      soyIdom.print(placeholder);
      incrementalDom.elementClose('div');
      incrementalDom.elementClose('div');
      incrementalDom.elementClose('div');
    }

    exports.content = $content;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  value: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }}
     */

    $content.Params;

    if (goog.DEBUG) {
      $content.soyTemplateName = 'Editor.content';
    }

    exports.render.params = ["name", "displayErrors", "errorMessage", "id", "label", "placeholder", "repeatable", "required", "showLabel", "spritemap", "tip", "tooltip", "valid", "value", "visible"];
    exports.render.types = {
      "name": "string",
      "displayErrors": "bool",
      "errorMessage": "string",
      "id": "string",
      "label": "string",
      "placeholder": "string",
      "repeatable": "bool",
      "required": "bool",
      "showLabel": "bool",
      "spritemap": "string",
      "tip": "string",
      "tooltip": "string",
      "valid": "bool",
      "value": "string",
      "visible": "bool"
    };
    exports.content.params = ["name", "placeholder", "value"];
    exports.content.types = {
      "name": "string",
      "placeholder": "string",
      "value": "string"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var Editor = /*#__PURE__*/function (_Component) {
    _inherits(Editor, _Component);

    function Editor() {
      _classCallCheck(this, Editor);

      return _possibleConstructorReturn(this, _getPrototypeOf(Editor).apply(this, arguments));
    }

    return Editor;
  }(_metalComponent["default"]);

  exports.Editor = Editor;

  _metalSoy["default"].register(Editor, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=Editor.soy.js.map
});
//# sourceMappingURL=Editor.soy.js.map