Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Grid/Grid.es", ['module', 'exports', 'require', '../FieldBase/FieldBase.es', './GridRegister.soy', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', './Grid.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("../FieldBase/FieldBase.es");

  require("./GridRegister.soy");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _Grid = _interopRequireDefault(require("./Grid.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });keys.push.apply(keys, symbols);
    }return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var Grid = /*#__PURE__*/function (_Component) {
    _inherits(Grid, _Component);

    function Grid() {
      _classCallCheck(this, Grid);

      return _possibleConstructorReturn(this, _getPrototypeOf(Grid).apply(this, arguments));
    }

    _createClass(Grid, [{
      key: "prepareStateForRender",
      value: function prepareStateForRender(state) {
        return _objectSpread({}, state, {
          columnText: Liferay.Language.get('column'),
          rowText: Liferay.Language.get('row')
        });
      }
    }, {
      key: "_handleFieldBlurred",
      value: function _handleFieldBlurred(event) {
        this.emit('fieldBlurred', {
          fieldInstance: this,
          originalEvent: event
        });
      }
    }, {
      key: "_handleFieldChanged",
      value: function _handleFieldChanged(event) {
        var _this = this;

        var target = event.target;

        var value = _objectSpread({}, this.value, _defineProperty({}, target.name, target.value));

        this.setState({
          value: value
        }, function () {
          _this.emit('fieldEdited', {
            fieldInstance: _this,
            originalEvent: event,
            value: value
          });
        });
      }
    }, {
      key: "_handleFieldFocused",
      value: function _handleFieldFocused(event) {
        this.emit('fieldFocused', {
          fieldInstance: this,
          originalEvent: event
        });
      }
    }]);

    return Grid;
  }(_metalComponent["default"]);

  Grid.STATE = {
    /**
     * @default undefined
     * @memberof Grid
     * @type {?array<object>}
     */
    columns: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
      label: _metalState.Config.string(),
      value: _metalState.Config.string()
    })).value([{
      label: 'col1',
      value: 'fieldId'
    }]),

    /**
     * @default false
     * @memberof Grid
     * @type {?bool}
     */
    evaluable: _metalState.Config.bool().value(false),
    fieldName: _metalState.Config.string(),

    /**
     * @default undefined
     * @memberof Grid
     * @type {?(string|undefined)}
     */
    label: _metalState.Config.string(),

    /**
     * @default false
     * @memberof Grid
     * @type {?bool}
     */
    readOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @memberof Grid
     * @type {?(bool|undefined)}
     */
    repeatable: _metalState.Config.bool(),

    /**
     * @default false
     * @memberof Grid
     * @type {?(bool|undefined)}
     */
    required: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @memberof Grid
     * @type {?array<object>}
     */
    rows: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
      label: _metalState.Config.string(),
      value: _metalState.Config.string()
    })).value([{
      label: 'row',
      value: 'jehf'
    }]),

    /**
     * @default true
     * @memberof Grid
     * @type {?(bool|undefined)}
     */
    showLabel: _metalState.Config.bool().value(true),

    /**
     * @default undefined
     * @memberof Grid
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default undefined
     * @memberof Grid
     * @type {?(string|undefined)}
     */
    tip: _metalState.Config.string(),

    /**
     * @default grid
     * @memberof Grid
     * @type {?(string|undefined)}
     */
    type: _metalState.Config.string().value('grid'),

    /**
     * @default {}
     * @memberof Grid
     * @type {?(string|undefined)}
     */
    value: _metalState.Config.object().value({})
  };

  _metalSoy["default"].register(Grid, _Grid["default"]);

  var _default = Grid;
  exports["default"] = _default;
  //# sourceMappingURL=Grid.es.js.map
});
//# sourceMappingURL=Grid.es.js.map