Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/KeyValue/KeyValue.es", ['module', 'exports', 'require', '../FieldBase/FieldBase.es', '../Text/Text.es', './KeyValueRegister.soy', 'dynamic-data-mapping-form-renderer/js/util/fields.es', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', './KeyValue.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("../FieldBase/FieldBase.es");

  require("../Text/Text.es");

  require("./KeyValueRegister.soy");

  var _fields = require("dynamic-data-mapping-form-renderer/js/util/fields.es");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _KeyValue = _interopRequireDefault(require("./KeyValue.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  /**
   * KeyValue.
   * @extends Component
   */
  var KeyValue = /*#__PURE__*/function (_Component) {
    _inherits(KeyValue, _Component);

    function KeyValue() {
      _classCallCheck(this, KeyValue);

      return _possibleConstructorReturn(this, _getPrototypeOf(KeyValue).apply(this, arguments));
    }

    _createClass(KeyValue, [{
      key: "willReceiveState",
      value: function willReceiveState(changes) {
        if (!this.generateKeyword) {
          if (changes.keyword && changes.value) {
            this.setState({
              _keyword: changes.keyword.newVal,
              _value: changes.value.newVal
            });
          }
        }
      }
    }, {
      key: "_handleKeywordInputBlurred",
      value: function _handleKeywordInputBlurred(event) {
        this.emit('fieldKeywordBlurred', {
          fieldInstance: this,
          originalEvent: event,
          value: event.target.value
        });
      }
    }, {
      key: "_handleKeywordInputChanged",
      value: function _handleKeywordInputChanged(event) {
        var _this = this;

        var target = event.target;
        var value = target.value;
        value = (0, _fields.normalizeFieldName)(value);
        target.value = value;
        this.setState({
          generateKeyword: false,
          keyword: value
        }, function () {
          _this.emit('fieldKeywordEdited', {
            fieldInstance: _this,
            originalEvent: event,
            value: value
          });
        });
      }
    }, {
      key: "_handleValueInputBlurred",
      value: function _handleValueInputBlurred(_ref) {
        var originalEvent = _ref.originalEvent,
            value = _ref.value;
        this.emit('fieldBlurred', {
          fieldInstance: this,
          originalEvent: originalEvent,
          value: value
        });
      }
    }, {
      key: "_handleValueInputEdited",
      value: function _handleValueInputEdited(event) {
        var _this2 = this;

        var generateKeyword = this.generateKeyword;
        var keyword = this.keyword;
        var originalEvent = event.originalEvent,
            value = event.value;

        if (generateKeyword) {
          keyword = (0, _fields.normalizeFieldName)(value);
        }

        this.setState({
          _keyword: keyword,
          _value: value
        }, function () {
          if (generateKeyword) {
            _this2.emit('fieldKeywordEdited', {
              fieldInstance: _this2,
              originalEvent: originalEvent,
              value: keyword
            });
          }

          _this2.emit('fieldEdited', {
            fieldInstance: _this2,
            originalEvent: originalEvent,
            value: value
          });
        });
      }
    }, {
      key: "_handleValueInputFocused",
      value: function _handleValueInputFocused(_ref2) {
        var originalEvent = _ref2.originalEvent,
            value = _ref2.value;
        this.emit('fieldFocused', {
          fieldInstance: this,
          originalEvent: originalEvent,
          value: value
        });
      }
    }, {
      key: "_internalKeywordFn",
      value: function _internalKeywordFn() {
        var keyword = this.keyword;
        return keyword;
      }
    }, {
      key: "_internalValueFn",
      value: function _internalValueFn() {
        var value = this.value;
        return value;
      }
    }]);

    return KeyValue;
  }(_metalComponent["default"]);

  KeyValue.STATE = {
    _keyword: _metalState.Config.string().internal().valueFn('_internalKeywordFn'),
    _value: _metalState.Config.string().internal().valueFn('_internalValueFn'),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    fieldName: _metalState.Config.string(),

    /**
     * @default false
     * @instance
     * @memberof KeyValue
     * @type {?bool}
     */
    generateKeyword: _metalState.Config.bool().value(true),

    /**
     * @default undefined
     * @instance
     * @memberof KeyValue
     * @type {?(string|undefined)}
     */
    id: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof KeyValue
     * @type {?(string|undefined)}
     */
    keyword: _metalState.Config.string(),

    /**
     * @default false
     * @instance
     * @memberof KeyValue
     * @type {?boolean}
     */
    keywordReadOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof KeyValue
     * @type {?(string|undefined)}
     */
    label: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Select
     * @type {?string}
     */
    predefinedValue: _metalState.Config.string().value('Option 1'),

    /**
     * @default false
     * @instance
     * @memberof KeyValue
     * @type {?bool}
     */
    readOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(bool|undefined)}
     */
    repeatable: _metalState.Config.bool(),

    /**
     * @default false
     * @instance
     * @memberof KeyValue
     * @type {?bool}
     */
    required: _metalState.Config.bool().value(false),

    /**
     * @default true
     * @instance
     * @memberof KeyValue
     * @type {?bool}
     */
    showLabel: _metalState.Config.bool().value(true),

    /**
     * @default undefined
     * @instance
     * @memberof KeyValue
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(string|undefined)}
     */
    tip: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    type: _metalState.Config.string().value('key-value'),

    /**
     * @default undefined
     * @instance
     * @memberof KeyValue
     * @type {?(bool)}
     */
    value: _metalState.Config.string()
  };

  _metalSoy["default"].register(KeyValue, _KeyValue["default"]);

  var _default = KeyValue;
  exports["default"] = _default;
  //# sourceMappingURL=KeyValue.es.js.map
});
//# sourceMappingURL=KeyValue.es.js.map