Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Options/Options.es", ['module', 'exports', 'require', '../FieldBase/FieldBase.es', '../KeyValue/KeyValue.es', './OptionsRegister.soy', 'dynamic-data-mapping-form-renderer/js/util/fields.es', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-dom', 'frontend-js-metal-web$metal-drag-drop', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', './Options.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("../FieldBase/FieldBase.es");

  require("../KeyValue/KeyValue.es");

  require("./OptionsRegister.soy");

  var _fields = require("dynamic-data-mapping-form-renderer/js/util/fields.es");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalDom = _interopRequireDefault(require("frontend-js-metal-web$metal-dom"));

  var _metalDragDrop = require("frontend-js-metal-web$metal-drag-drop");

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _Options = _interopRequireDefault(require("./Options.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
  }

  function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
        arr2[i] = arr[i];
      }return arr2;
    }
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });keys.push.apply(keys, symbols);
    }return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _get(target, property, receiver) {
    if (typeof Reflect !== "undefined" && Reflect.get) {
      _get = Reflect.get;
    } else {
      _get = function _get(target, property, receiver) {
        var base = _superPropBase(target, property);if (!base) return;var desc = Object.getOwnPropertyDescriptor(base, property);if (desc.get) {
          return desc.get.call(receiver);
        }return desc.value;
      };
    }return _get(target, property, receiver || target);
  }

  function _superPropBase(object, property) {
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
      object = _getPrototypeOf(object);if (object === null) break;
    }return object;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  /**
   * Options.
   * @extends Component
   */
  var Options = /*#__PURE__*/function (_Component) {
    _inherits(Options, _Component);

    function Options() {
      _classCallCheck(this, Options);

      return _possibleConstructorReturn(this, _getPrototypeOf(Options).apply(this, arguments));
    }

    _createClass(Options, [{
      key: "attached",
      value: function attached() {
        var defaultOption = false;
        var defaultOptionLabel = Liferay.Language.get('option').toLowerCase();
        var options = this.getCurrentLocaleValue();

        if (options.length == 1 && options[0].label.toLowerCase() == defaultOptionLabel) {
          defaultOption = true;
        }

        this.setState({
          defaultOption: defaultOption
        });

        this._createDragDrop();
      }
    }, {
      key: "deleteOption",
      value: function deleteOption(deletedIndex) {
        var value = this.value;
        Object.keys(value).forEach(function (languageId) {
          value = _objectSpread({}, value, _defineProperty({}, languageId, value[languageId].filter(function (option, currentIndex) {
            return currentIndex !== deletedIndex;
          })));
        });

        this._handleFieldEdited({}, value);
      }
    }, {
      key: "disposeDragAndDrop",
      value: function disposeDragAndDrop() {
        if (this._dragAndDrop) {
          this._dragAndDrop.dispose();
        }
      }
    }, {
      key: "disposeInternal",
      value: function disposeInternal() {
        _get(_getPrototypeOf(Options.prototype), "disposeInternal", this).call(this);

        this.disposeDragAndDrop();
      }
    }, {
      key: "findOptionByValue",
      value: function findOptionByValue(options, name) {
        var limit = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : options.length;
        return options.find(function (_ref, index) {
          var value = _ref.value;
          return index < limit && value === name;
        });
      }
    }, {
      key: "getCurrentLocaleValue",
      value: function getCurrentLocaleValue() {
        var localizedValue = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.value;
        var defaultLanguageId = this.defaultLanguageId,
            editingLanguageId = this.editingLanguageId;

        if (localizedValue && localizedValue[editingLanguageId]) {
          return localizedValue[editingLanguageId];
        } else if (localizedValue && localizedValue[defaultLanguageId]) {
          return localizedValue[defaultLanguageId];
        }

        return [];
      }
    }, {
      key: "getFieldIndex",
      value: function getFieldIndex(element) {
        return parseInt(_metalDom["default"].closest(element, '.ddm-field-options').dataset.index, 10);
      }
    }, {
      key: "getItems",
      value: function getItems() {
        var _this = this;

        var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

        var items = _toConsumableArray(options);

        var newItems = items.map(function (option) {
          return _objectSpread({}, option, {
            generateKeyword: _this.shouldGenerateOptionValue(items, option)
          });
        });
        var defaultLanguageId = this.defaultLanguageId,
            editingLanguageId = this.editingLanguageId;

        if (defaultLanguageId === editingLanguageId) {
          newItems.push({
            label: '',
            value: ''
          });
        }

        return newItems;
      }
    }, {
      key: "moveOption",
      value: function moveOption(sourceIndex, targetIndex) {
        var value = this.value;
        Object.keys(value).forEach(function (languageId) {
          var options = _toConsumableArray(value[languageId]);

          if (sourceIndex < options.length) {
            options.splice(targetIndex, 0, _objectSpread({}, options[sourceIndex]));
            value = _objectSpread({}, value, _defineProperty({}, languageId, options.filter(function (option, index) {
              return sourceIndex > targetIndex ? index != sourceIndex + 1 : index != sourceIndex;
            })));
          }
        });

        this._handleFieldEdited({}, value);
      }
    }, {
      key: "normalizeOption",
      value: function normalizeOption(options, option, editedIndex, editedProperty) {
        var label = option.label,
            value = option.value;
        var desiredValue = editedProperty === 'label' ? label : value ? value : label;
        var optionIndex = options.indexOf(option);

        if (!this.shouldGenerateOptionValue(options, option)) {
          return option;
        }

        if (!desiredValue) {
          desiredValue = Liferay.Language.get('option');
        }

        var baseNormalizedValue = (0, _fields.normalizeFieldName)(desiredValue);
        var normalizedValue = baseNormalizedValue;
        var counter = 0;

        do {
          if (counter > 0) {
            normalizedValue = baseNormalizedValue + counter;
          }

          counter++;
        } while (this.findOptionByValue(options, normalizedValue, optionIndex));

        normalizedValue = (0, _fields.normalizeFieldName)(normalizedValue);
        return _objectSpread({}, option, {
          value: normalizedValue
        });
      }
    }, {
      key: "normalizeOptions",
      value: function normalizeOptions(options, editedIndex, editedProperty) {
        var _this2 = this;

        var normalizedOptions = _toConsumableArray(options);

        normalizedOptions.forEach(function (option, index) {
          if (editedIndex !== index) {
            return;
          }

          normalizedOptions[index] = _this2.normalizeOption(normalizedOptions, normalizedOptions[index], editedIndex, editedProperty);
        });
        return normalizedOptions;
      }
    }, {
      key: "prepareStateForRender",
      value: function prepareStateForRender(state) {
        var editingLanguageId = this.editingLanguageId;
        var value = state.value;
        return _objectSpread({}, state, {
          items: this.getItems(value[editingLanguageId])
        });
      }
    }, {
      key: "shouldGenerateOptionValue",
      value: function shouldGenerateOptionValue(options, option) {
        var defaultLanguageId = this.defaultLanguageId,
            editingLanguageId = this.editingLanguageId;

        if (defaultLanguageId !== editingLanguageId) {
          return false;
        }

        if (option.value === '') {
          return true;
        }

        var optionIndex = options.indexOf(option);
        var duplicated = options.some(function (_ref2, index) {
          var value = _ref2.value;
          return value === option.value && index !== optionIndex;
        });

        if (duplicated) {
          return true;
        }

        if (option.edited) {
          return false;
        }

        if (new RegExp("^".concat(Liferay.Language.get('option'), "\\d*$")).test(option.value)) {
          return true;
        }

        if (new RegExp("^".concat(option.value.replace(/\d+$/, ''), "\\d*")).test((0, _fields.normalizeFieldName)(option.label))) {
          return true;
        }

        return true;
      }
    }, {
      key: "syncEditingLanguageId",
      value: function syncEditingLanguageId(editingLanguageId) {
        var defaultLanguageId = this.defaultLanguageId;

        if (defaultLanguageId !== editingLanguageId && !this.value[editingLanguageId]) {
          this.setState({
            value: _objectSpread({}, this.value, _defineProperty({}, editingLanguageId, this.value[defaultLanguageId].filter(function (_ref3) {
              var value = _ref3.value;
              return !!value;
            })))
          });
        }
      }
    }, {
      key: "syncValue",
      value: function syncValue(value) {
        this.setState({
          items: this.getCurrentLocaleValue(value)
        });
      }
    }, {
      key: "_createDragDrop",
      value: function _createDragDrop() {
        this._dragAndDrop = new _metalDragDrop.DragDrop({
          container: this.element,
          dragPlaceholder: _metalDragDrop.Drag.Placeholder.CLONE,
          handles: '.ddm-options-drag:not(.disabled)',
          sources: '.ddm-field-options',
          targets: '.ddm-options-target',
          useShim: false
        });

        this._dragAndDrop.on(_metalDragDrop.DragDrop.Events.END, this._handleDragDropEvent.bind(this));

        this._dragAndDrop.on(_metalDragDrop.DragDrop.Events.DRAG, this._handleDragEvent.bind(this));
      }
    }, {
      key: "_getOptionIndex",
      value: function _getOptionIndex(_ref4) {
        var name = _ref4.name;
        return parseInt(name.replace(/[^\d]/gi, ''), 10);
      }
    }, {
      key: "_handleDragDropEvent",
      value: function _handleDragDropEvent(_ref5) {
        var source = _ref5.source,
            target = _ref5.target;
        var lastSource = document.querySelector('.ddm-source-dragging');
        var sourceIndex = parseInt(source.dataset.index, 10);

        if (lastSource) {
          lastSource.classList.remove('ddm-source-dragging');
        }

        if (target) {
          var targetIndex = parseInt(target.dataset.index, 10);
          this.moveOption(sourceIndex, targetIndex);
        }
      }
    }, {
      key: "_handleDragEvent",
      value: function _handleDragEvent(_ref6) {
        var source = _ref6.source;
        source.classList.add('ddm-source-dragging');
      }
    }, {
      key: "_handleFieldEdited",
      value: function _handleFieldEdited(_ref7, value) {
        var optionIndex = _ref7.optionIndex,
            originalEvent = _ref7.originalEvent;
        this.emit('fieldEdited', {
          fieldInstance: this,
          optionIndex: optionIndex,
          originalEvent: originalEvent,
          value: value
        });
      }
    }, {
      key: "_handleOptionDeleted",
      value: function _handleOptionDeleted(event) {
        var delegateTarget = event.delegateTarget;
        var deletedIndex = this.getFieldIndex(delegateTarget);
        this.deleteOption(deletedIndex);
      }
    }, {
      key: "_handleOptionEdited",
      value: function _handleOptionEdited(event, property) {
        var _this3 = this;

        var defaultLanguageId = this.defaultLanguageId,
            editingLanguageId = this.editingLanguageId;
        var fieldInstance = event.fieldInstance,
            value = event.value;
        var options = this.getCurrentLocaleValue();

        var optionIndex = this._getOptionIndex(fieldInstance);

        if (optionIndex < options.length) {
          options = options.map(function (option, index) {
            return index === optionIndex ? _objectSpread({}, option, _defineProperty({
              edited: option.edited || editingLanguageId !== defaultLanguageId
            }, property, value)) : option;
          });
        } else {
          options = [].concat(_toConsumableArray(options), [{
            label: property === 'label' ? value : '',
            value: property === 'value' ? value : ''
          }]);
        }

        options = this.normalizeOptions(options, optionIndex, property);

        var newValue = _objectSpread({}, this.value, _defineProperty({}, editingLanguageId, options));

        if (defaultLanguageId === editingLanguageId) {
          var copyLanguageLabels = function copyLanguageLabels(languageId, options) {
            return options.map(function (_ref8, index) {
              var label = _ref8.label,
                  value = _ref8.value;
              var option = newValue[languageId][index];

              if (option && option.edited) {
                label = option.label;
              }

              return _objectSpread({}, option, {
                label: label,
                value: value
              });
            });
          };

          Object.keys(this.value).forEach(function (languageId) {
            if (defaultLanguageId === languageId) {
              return;
            }

            newValue = _objectSpread({}, newValue, _defineProperty({}, languageId, copyLanguageLabels(languageId, options)));
          });
        }

        this.setState({
          value: newValue
        }, function () {
          return _this3._handleFieldEdited(_objectSpread({}, event, {
            optionIndex: optionIndex
          }), newValue);
        });
      }
    }, {
      key: "_handleOptionFocused",
      value: function _handleOptionFocused(_ref9) {
        var target = _ref9.originalEvent.target;

        if (this.defaultOption) {
          target.value = '';
          this.setState({
            defaultOption: false
          });
        }
      }
    }, {
      key: "_handleOptionLabelEdited",
      value: function _handleOptionLabelEdited(event) {
        this._handleOptionEdited(event, 'label');
      }
    }, {
      key: "_handleOptionValueBlurred",
      value: function _handleOptionValueBlurred(_ref10) {
        var fieldInstance = _ref10.fieldInstance;

        this._handleOptionEdited({
          fieldInstance: fieldInstance,
          value: fieldInstance.keyword
        }, 'value');
      }
    }, {
      key: "_setValue",
      value: function _setValue() {
        var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var defaultLanguageId = this.defaultLanguageId;

        var formattedValue = _objectSpread({}, value);

        Object.keys(value).forEach(function (languageId) {
          if (defaultLanguageId !== languageId) {
            formattedValue[languageId] = formattedValue[languageId].filter(function (_ref11) {
              var value = _ref11.value;
              return !!value;
            });
          }
        });
        return formattedValue;
      }
    }]);

    return Options;
  }(_metalComponent["default"]);

  Options.STATE = {
    /**
     * @default undefined
     * @instance
     * @memberof Options
     * @type {?string}
     */
    defaultLanguageId: _metalState.Config.string().value(themeDisplay.getLanguageId()),

    /**
     * @default false
     * @instance
     * @memberof Options
     * @type {?bool}
     */
    defaultOption: _metalState.Config.bool().internal().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof Options
     * @type {?string}
     */
    editingLanguageId: _metalState.Config.string().value(themeDisplay.getLanguageId()),

    /**
     * @default 'boolean'
     * @instance
     * @memberof Options
     * @type {?(boolean|undefined)}
     */
    evaluable: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof Options
     * @type {?string}
     */
    fieldName: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Options
     * @type {?(string|undefined)}
     */
    items: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
      disabled: _metalState.Config.bool().value(false),
      label: _metalState.Config.string(),
      name: _metalState.Config.string(),
      value: _metalState.Config.string()
    })).internal(),

    /**
     * @default undefined
     * @instance
     * @memberof Options
     * @type {?(string|undefined)}
     */
    label: _metalState.Config.string(),

    /**
     * @default enter-an-option
     * @instance
     * @memberof Options
     * @type {?(string)}
     */
    placeholder: _metalState.Config.string().value(Liferay.Language.get('enter-an-option')),

    /**
     * @default false
     * @instance
     * @memberof Options
     * @type {?bool}
     */
    readOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(bool|undefined)}
     */
    repeatable: _metalState.Config.bool(),

    /**
     * @default false
     * @instance
     * @memberof Options
     * @type {?bool}
     */
    required: _metalState.Config.bool().value(false),

    /**
     * @default true
     * @instance
     * @memberof Options
     * @type {?bool}
     */
    showLabel: _metalState.Config.bool().value(true),

    /**
     * @default undefined
     * @instance
     * @memberof Options
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Options
     * @type {?(string|undefined)}
     */
    tip: _metalState.Config.string(),

    /**
     * @default options
     * @instance
     * @memberof Options
     * @type {?(string|undefined)}
     */
    type: _metalState.Config.string().value('options'),

    /**
     * @default {}
     * @instance
     * @memberof Options
     * @type {?string}
     */
    value: _metalState.Config.object().setter('_setValue').value({})
  };

  _metalSoy["default"].register(Options, _Options["default"]);

  var _default = Options;
  exports["default"] = _default;
  //# sourceMappingURL=Options.es.js.map
});
//# sourceMappingURL=Options.es.js.map