Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Radio/Radio.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.Radio = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from Radio.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace Radio.
     * @public
     */

    goog.module('Radio.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy');

    goog.require('soy.asserts');

    goog.require('soy.idom');

    var $templateAlias2 = _metalSoy["default"].getTemplate('ClayRadio.incrementaldom', 'render');

    var $templateAlias1 = _metalSoy["default"].getTemplate('FieldBase.incrementaldom', 'render');
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleValueChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  inline: (boolean|null|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  options: (!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined),
     *  predefinedValue: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  type: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  value: (?),
     *  visible: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleValueChanged = opt_data._handleValueChanged;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;
      /** @type {boolean|null|undefined} */

      var displayErrors = soy.asserts.assertType(opt_data.displayErrors == null || goog.isBoolean(opt_data.displayErrors) || opt_data.displayErrors === 1 || opt_data.displayErrors === 0, 'displayErrors', opt_data.displayErrors, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var errorMessage = soy.asserts.assertType(opt_data.errorMessage == null || goog.isString(opt_data.errorMessage) || opt_data.errorMessage instanceof goog.soy.data.SanitizedContent, 'errorMessage', opt_data.errorMessage, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var id = soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var inline = soy.asserts.assertType(opt_data.inline == null || goog.isBoolean(opt_data.inline) || opt_data.inline === 1 || opt_data.inline === 0, 'inline', opt_data.inline, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var label = soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined} */

      var options = soy.asserts.assertType(opt_data.options == null || goog.isArray(opt_data.options), 'options', opt_data.options, '!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var predefinedValue = soy.asserts.assertType(opt_data.predefinedValue == null || goog.isString(opt_data.predefinedValue) || opt_data.predefinedValue instanceof goog.soy.data.SanitizedContent, 'predefinedValue', opt_data.predefinedValue, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var repeatable = soy.asserts.assertType(opt_data.repeatable == null || goog.isBoolean(opt_data.repeatable) || opt_data.repeatable === 1 || opt_data.repeatable === 0, 'repeatable', opt_data.repeatable, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var required = soy.asserts.assertType(opt_data.required == null || goog.isBoolean(opt_data.required) || opt_data.required === 1 || opt_data.required === 0, 'required', opt_data.required, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showLabel = soy.asserts.assertType(opt_data.showLabel == null || goog.isBoolean(opt_data.showLabel) || opt_data.showLabel === 1 || opt_data.showLabel === 0, 'showLabel', opt_data.showLabel, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var spritemap = soy.asserts.assertType(opt_data.spritemap == null || goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tip = soy.asserts.assertType(opt_data.tip == null || goog.isString(opt_data.tip) || opt_data.tip instanceof goog.soy.data.SanitizedContent, 'tip', opt_data.tip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var type = soy.asserts.assertType(opt_data.type == null || goog.isString(opt_data.type) || opt_data.type instanceof goog.soy.data.SanitizedContent, 'type', opt_data.type, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var valid = soy.asserts.assertType(opt_data.valid == null || goog.isBoolean(opt_data.valid) || opt_data.valid === 1 || opt_data.valid === 0, 'valid', opt_data.valid, 'boolean|null|undefined');
      /** @type {?} */

      var value = opt_data.value;
      /** @type {boolean|null|undefined} */

      var visible = soy.asserts.assertType(opt_data.visible == null || goog.isBoolean(opt_data.visible) || opt_data.visible === 1 || opt_data.visible === 0, 'visible', opt_data.visible, 'boolean|null|undefined');

      var param3296 = function param3296() {
        $content({
          _handleFieldBlurred: _handleFieldBlurred,
          _handleFieldFocused: _handleFieldFocused,
          _handleValueChanged: _handleValueChanged,
          disabled: readOnly,
          inline: inline,
          name: name,
          options: options,
          predefinedValue: predefinedValue,
          value: value
        }, null, opt_ijData);
      };

      $templateAlias1({
        contentRenderer: param3296,
        displayErrors: displayErrors,
        errorMessage: errorMessage,
        id: id,
        label: label,
        name: name,
        readOnly: readOnly,
        repeatable: repeatable,
        required: required,
        showLabel: showLabel,
        spritemap: spritemap,
        tip: tip,
        type: type,
        valid: valid,
        visible: visible
      }, null, opt_ijData);
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleValueChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  inline: (boolean|null|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  options: (!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined),
     *  predefinedValue: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  type: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  value: (?),
     *  visible: (boolean|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'Radio.render';
    }
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  _handleValueChanged: (*|null|undefined),
     *  disabled: (boolean|null|undefined),
     *  inline: (boolean|null|undefined),
     *  options: (!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined),
     *  predefinedValue: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  value: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $content(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      var $$temp;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;
      /** @type {*|null|undefined} */

      var _handleValueChanged = opt_data._handleValueChanged;
      /** @type {boolean|null|undefined} */

      var disabled = soy.asserts.assertType(opt_data.disabled == null || goog.isBoolean(opt_data.disabled) || opt_data.disabled === 1 || opt_data.disabled === 0, 'disabled', opt_data.disabled, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var inline = soy.asserts.assertType(opt_data.inline == null || goog.isBoolean(opt_data.inline) || opt_data.inline === 1 || opt_data.inline === 0, 'inline', opt_data.inline, 'boolean|null|undefined');
      /** @type {!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined} */

      var options = soy.asserts.assertType(opt_data.options == null || goog.isArray(opt_data.options), 'options', opt_data.options, '!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var predefinedValue = soy.asserts.assertType(opt_data.predefinedValue == null || goog.isString(opt_data.predefinedValue) || opt_data.predefinedValue instanceof goog.soy.data.SanitizedContent, 'predefinedValue', opt_data.predefinedValue, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var value = soy.asserts.assertType(opt_data.value == null || goog.isString(opt_data.value) || opt_data.value instanceof goog.soy.data.SanitizedContent, 'value', opt_data.value, '!goog.soy.data.SanitizedContent|null|string|undefined');

      if (options) {
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'ddm-radio');
        incrementalDom.attr('data-onblur', _handleFieldBlurred);
        incrementalDom.attr('data-onfocus', _handleFieldFocused);
        incrementalDom.elementOpenEnd();
        var radioValue__soy3342 = ($$temp = value) == null ? ($$temp = predefinedValue) == null ? '' : $$temp : $$temp;
        var radio3352List = options;
        var radio3352ListLen = radio3352List.length;

        for (var radio3352Index = 0; radio3352Index < radio3352ListLen; radio3352Index++) {
          var radio3352Data = radio3352List[radio3352Index];
          $templateAlias2(soy.$$assignDefaults({
            checked: radioValue__soy3342 == radio3352Data.value ? true : false,
            disabled: disabled,
            events: {
              change: _handleValueChanged
            },
            inline: inline,
            name: name
          }, radio3352Data), null, opt_ijData);
        }

        incrementalDom.elementClose('div');
      }
    }

    exports.content = $content;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  _handleValueChanged: (*|null|undefined),
     *  disabled: (boolean|null|undefined),
     *  inline: (boolean|null|undefined),
     *  options: (!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined),
     *  predefinedValue: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  value: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }}
     */

    $content.Params;

    if (goog.DEBUG) {
      $content.soyTemplateName = 'Radio.content';
    }

    exports.render.params = ["name", "_handleFieldBlurred", "_handleValueChanged", "_handleFieldFocused", "displayErrors", "errorMessage", "id", "inline", "label", "options", "predefinedValue", "readOnly", "repeatable", "required", "showLabel", "spritemap", "tip", "type", "valid", "value", "visible"];
    exports.render.types = {
      "name": "string",
      "_handleFieldBlurred": "any",
      "_handleValueChanged": "any",
      "_handleFieldFocused": "any",
      "displayErrors": "bool",
      "errorMessage": "string",
      "id": "string",
      "inline": "bool",
      "label": "string",
      "options": "list<[\n\t\tlabel: string,\n\t\tvalue: string\n\t]>",
      "predefinedValue": "string",
      "readOnly": "bool",
      "repeatable": "bool",
      "required": "bool",
      "showLabel": "bool",
      "spritemap": "string",
      "tip": "string",
      "type": "string",
      "valid": "bool",
      "value": "?",
      "visible": "bool"
    };
    exports.content.params = ["name", "_handleFieldBlurred", "_handleFieldFocused", "_handleValueChanged", "disabled", "inline", "options", "predefinedValue", "value"];
    exports.content.types = {
      "name": "string",
      "_handleFieldBlurred": "any",
      "_handleFieldFocused": "any",
      "_handleValueChanged": "any",
      "disabled": "bool",
      "inline": "bool",
      "options": "list<[\n\t\tlabel: string,\n\t\tvalue: string\n\t]>",
      "predefinedValue": "string",
      "value": "string"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var Radio = /*#__PURE__*/function (_Component) {
    _inherits(Radio, _Component);

    function Radio() {
      _classCallCheck(this, Radio);

      return _possibleConstructorReturn(this, _getPrototypeOf(Radio).apply(this, arguments));
    }

    return Radio;
  }(_metalComponent["default"]);

  exports.Radio = Radio;

  _metalSoy["default"].register(Radio, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=Radio.soy.js.map
});
//# sourceMappingURL=Radio.soy.js.map