Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Text/Text.es", ['module', 'exports', 'require', '../FieldBase/FieldBase.es', './TextRegister.soy', 'frontend-taglib-clay$clay-autocomplete', 'dynamic-data-mapping-form-renderer/js/util/fields.es', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-dom', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', './Text.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("../FieldBase/FieldBase.es");

  require("./TextRegister.soy");

  require("frontend-taglib-clay$clay-autocomplete");

  var _fields = require("dynamic-data-mapping-form-renderer/js/util/fields.es");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalDom = _interopRequireDefault(require("frontend-js-metal-web$metal-dom"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _Text = _interopRequireDefault(require("./Text.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });keys.push.apply(keys, symbols);
    }return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var Text = /*#__PURE__*/function (_Component) {
    _inherits(Text, _Component);

    function Text() {
      _classCallCheck(this, Text);

      return _possibleConstructorReturn(this, _getPrototypeOf(Text).apply(this, arguments));
    }

    _createClass(Text, [{
      key: "attached",
      value: function attached() {
        var portalElement = _metalDom["default"].toElement('#clay_dropdown_portal');

        if (portalElement) {
          _metalDom["default"].addClasses(portalElement, 'show');
        }
      }
    }, {
      key: "dispatchEvent",
      value: function dispatchEvent(event, name, value) {
        if (this.isMultilineTextRenderedByIE(event)) {
          value = this.value;
        }

        this.emit(name, {
          fieldInstance: this,
          originalEvent: event,
          value: value
        });
      }
    }, {
      key: "getAutocompleteOptions",
      value: function getAutocompleteOptions() {
        var options = this.options;

        if (!options) {
          return [];
        }

        return options.map(function (option) {
          return option.label;
        });
      }
    }, {
      key: "isMultilineTextRenderedByIE",
      value: function isMultilineTextRenderedByIE(event) {
        return this.displayStyle === 'multiline' && event.target.nodeName === 'TEXTAREA' && Liferay.Browser.isIe();
      }
    }, {
      key: "prepareStateForRender",
      value: function prepareStateForRender(state) {
        var options = this.options;
        return _objectSpread({}, state, {
          options: this.getAutocompleteOptions(options),
          value: this._getValue()
        });
      }
    }, {
      key: "rendered",
      value: function rendered() {
        var element = this.element;
        var target = element.querySelector('.ddm-field-text');

        if (this.isMultilineTextRenderedByIE({
          target: target
        })) {
          if (this.value === '') {
            var currentTargetValue = target.value;
            target.value = ' ';
            target.value = currentTargetValue;
            target.blur();
          }
        }
      }
    }, {
      key: "shouldUpdate",
      value: function shouldUpdate(changes) {
        return Object.keys(changes || {}).some(function (key) {
          if (key === 'events') {
            return false;
          }

          if (!Liferay.Util.isEqual(changes[key].newVal, changes[key].prevVal)) {
            return true;
          }
        });
      }
    }, {
      key: "_getValue",
      value: function _getValue() {
        var store = this.context.store;

        if (!store.viewMode && this.predefinedValue !== '' && this.value === '') {
          return this.predefinedValue;
        }

        return this.value;
      }
    }, {
      key: "_handleAutocompleteFieldChanged",
      value: function _handleAutocompleteFieldChanged(event) {
        var _this = this;

        var value = event.data.value;
        this.setState({
          value: value
        }, function () {
          return _this.dispatchEvent(event, 'fieldEdited', value);
        });
      }
    }, {
      key: "_handleAutocompleteFieldFocused",
      value: function _handleAutocompleteFieldFocused(event) {
        this.dispatchEvent('fieldFocused', event, event.target.inputValue);
      }
    }, {
      key: "_handleAutocompleteFilteredItemsChanged",
      value: function _handleAutocompleteFilteredItemsChanged(filteredItemsReceived) {
        var filteredItems = this.filteredItems;

        if (filteredItemsReceived.newVal.length != filteredItems.length) {
          this.setState({
            filteredItems: filteredItemsReceived.newVal
          });
        }
      }
    }, {
      key: "_handleAutocompleteSelected",
      value: function _handleAutocompleteSelected(event) {
        var _this2 = this;

        var value = event.data.item.value;
        this.setState({
          filteredItems: [],
          value: value
        }, function () {
          _this2.dispatchEvent(event, 'fieldEdited', value);
        });
      }
    }, {
      key: "_handleFieldBlurred",
      value: function _handleFieldBlurred(event) {
        if (this.isMultilineTextRenderedByIE(event)) {
          event.target.value = this.value;
        }

        this.dispatchEvent(event, 'fieldBlurred', event.target.value);
      }
    }, {
      key: "_handleFieldChanged",
      value: function _handleFieldChanged(event) {
        var _this3 = this;

        var target = event.target;
        var value = target.value;
        var fieldName = this.fieldName;

        if (this.isMultilineTextRenderedByIE(event)) {
          if (this.value === '' && value === '') {
            var currentTargetValue = target.value;
            target.value = ' ';
            target.value = currentTargetValue;
            target.blur();
            return;
          } else if (this.value != '' && value === '' && target.innerText != '') {
            value = target.innerText;
          }
        }

        if (fieldName === 'name') {
          value = (0, _fields.normalizeFieldName)(value);
          target.value = value;
        }

        if (this.timeout) {
          clearTimeout(this.timeout);
        }

        if (Liferay.Browser.isEdge()) {
          this.cursor = event.target.selectionStart;
        }

        this.timeout = setTimeout(function () {
          _this3.setState({
            value: value
          }, function () {
            _this3.dispatchEvent(event, 'fieldEdited', value);

            if (_this3.cursor) {
              event.target.selectionStart = _this3.cursor;
            }
          });
        }, 300);
      }
    }, {
      key: "_handleFieldFocused",
      value: function _handleFieldFocused(event) {
        if (this.isMultilineTextRenderedByIE(event)) {
          event.target.value = this.value;
        }

        this.dispatchEvent(event, 'fieldFocused', event.target.value);
      }
    }]);

    return Text;
  }(_metalComponent["default"]);

  Text.STATE = {
    /**
     * @default 0
     * @instance
     * @memberof Text
     * @type {number}
     */
    _cursorPosition: _metalState.Config.number().value(0),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    autocompleteEnabled: _metalState.Config.bool(),

    /**
     * @default 'string'
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    dataType: _metalState.Config.string().value('string'),

    /**
     * @default false
     * @instance
     * @memberof Text
     * @type {?(boolean|undefined)}
     */
    displayErrors: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    displayStyle: _metalState.Config.string().value('singleline'),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    errorMessage: _metalState.Config.string(),

    /**
     * @default false
     * @instance
     * @memberof Text
     * @type {?bool}
     */
    evaluable: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    fieldName: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    filteredItems: _metalState.Config.array().value([]).internal(),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    label: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    name: _metalState.Config.string().required(),

    /**
     * @default []
     * @memberof Text
     * @type {?array<object>}
    .setter('_loadOptionsFn').
     */
    options: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
      active: _metalState.Config.bool().value(false),
      disabled: _metalState.Config.bool().value(false),
      id: _metalState.Config.string(),
      inline: _metalState.Config.bool().value(false),
      label: _metalState.Config.string(),
      name: _metalState.Config.string(),
      showLabel: _metalState.Config.bool().value(true),
      value: _metalState.Config.string()
    })).value([]),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    placeholder: _metalState.Config.string().value(''),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    predefinedValue: _metalState.Config.string().value(''),

    /**
     * @default false
     * @instance
     * @memberof Text
     * @type {?bool}
     */
    readOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(bool|undefined)}
     */
    repeatable: _metalState.Config.bool(),

    /**
     * @default false
     * @instance
     * @memberof Text
     * @type {?(bool|undefined)}
     */
    required: _metalState.Config.bool().value(false),

    /**
     * @default true
     * @instance
     * @memberof Text
     * @type {?(bool|undefined)}
     */
    showLabel: _metalState.Config.bool().value(true),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    tip: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(string|undefined)}
     */
    tooltip: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    type: _metalState.Config.string().value('text'),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    value: _metalState.Config.string().value('')
  };

  _metalSoy["default"].register(Text, _Text["default"]);

  var _default = Text;
  exports["default"] = _default;
  //# sourceMappingURL=Text.es.js.map
});
//# sourceMappingURL=Text.es.js.map