Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Validation/Validation.es", ['module', 'exports', 'require', '../Checkbox/Checkbox.es', '../FieldBase/FieldBase.es', '../Numeric/Numeric.es', '../Select/Select.es', '../Text/Text.es', './ValidationRegister.soy', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', '../util/strings.es', '../util/validations.es', './Validation.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("../Checkbox/Checkbox.es");

  require("../FieldBase/FieldBase.es");

  require("../Numeric/Numeric.es");

  require("../Select/Select.es");

  require("../Text/Text.es");

  require("./ValidationRegister.soy");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _strings = require("../util/strings.es");

  var _validations = _interopRequireDefault(require("../util/validations.es"));

  var _Validation = _interopRequireDefault(require("./Validation.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });keys.push.apply(keys, symbols);
    }return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var Validation = /*#__PURE__*/function (_Component) {
    _inherits(Validation, _Component);

    function Validation() {
      _classCallCheck(this, Validation);

      return _possibleConstructorReturn(this, _getPrototypeOf(Validation).apply(this, arguments));
    }

    _createClass(Validation, [{
      key: "prepareStateForRender",
      value: function prepareStateForRender(state) {
        var defaultLanguageId = this.defaultLanguageId,
            editingLanguageId = this.editingLanguageId;

        var parsedState = this._getStateFromValue(state.value);

        if (parsedState.enableValidation) {
          this.context = _objectSpread({}, this.context, {
            validation: parsedState
          });
        }

        return _objectSpread({}, state, {}, parsedState, {
          dataType: state.validation && state.validation.dataType ? state.validation.dataType : state.dataType,
          localizationMode: editingLanguageId !== defaultLanguageId
        });
      }
    }, {
      key: "willReceiveState",
      value: function willReceiveState(_ref) {
        var dataType = _ref.dataType,
            validation = _ref.validation;

        if (dataType && dataType.newVal !== dataType.prevVal || validation && validation.newVal.dataType !== validation.prevVal.dataType) {
          this.setState({
            dataType: this._dataTypeValueFn(),
            validations: this._validationsValueFn()
          });
        }
      }
    }, {
      key: "_dataTypeValueFn",
      value: function _dataTypeValueFn() {
        return this.validation.dataType ? this.validation.dataType : this.dataType;
      }
    }, {
      key: "_emitFieldEdited",
      value: function _emitFieldEdited(value) {
        this.emit('fieldEdited', {
          fieldInstance: this,
          originalEvent: null,
          value: value
        });
      }
    }, {
      key: "_enableValidationValueFn",
      value: function _enableValidationValueFn() {
        var value = this.value;
        return !!value.expression;
      }
    }, {
      key: "_getSelectedValidation",
      value: function _getSelectedValidation() {
        var selectedValidationValue = this.refs.selectedValidation.value;

        if (Array.isArray(selectedValidationValue)) {
          selectedValidationValue = selectedValidationValue[0];
        }

        var selectedValidation = this.validations.find(function (_ref2) {
          var name = _ref2.name;
          return name === selectedValidationValue;
        });

        if (!selectedValidation) {
          selectedValidation = this.validations[0];
        }

        return selectedValidation;
      }
    }, {
      key: "_getStateFromValue",
      value: function _getStateFromValue(value) {
        var expression = value.expression;
        var parameterMessage = '';
        var selectedValidation;
        var enableValidation = !!expression.value;

        if (enableValidation) {
          selectedValidation = this._parseValidationFromExpression(expression);

          if (selectedValidation) {
            parameterMessage = selectedValidation.parameterMessage;
          } else {
            selectedValidation = {
              name: this.validations[0].name,
              parameterMessage: this.validations[0].parameterMessage,
              value: this.validations[0].template
            };
          }
        }

        var defaultLanguageId = this.defaultLanguageId,
            editingLanguageId = this.editingLanguageId;
        var errorMessage = this.value.errorMessage[editingLanguageId] !== undefined ? this.value.errorMessage[editingLanguageId] : this.value.errorMessage[defaultLanguageId];
        var parameter = this.value.parameter[editingLanguageId] !== undefined ? this.value.parameter[editingLanguageId] : this.value.parameter[defaultLanguageId];
        return {
          enableValidation: enableValidation,
          errorMessage: errorMessage,
          expression: expression,
          parameter: parameter,
          parameterMessage: parameterMessage,
          selectedValidation: selectedValidation
        };
      }
    }, {
      key: "_getValue",
      value: function _getValue() {
        var _this = this;

        var expression = {};
        var editingLanguageId = this.editingLanguageId,
            name = this.validation.fieldName;
        var errorMessage = '';
        var parameter = '';

        if (this.refs.errorMessage) {
          errorMessage = this.refs.errorMessage.value;
        }

        if (this.refs.parameter) {
          parameter = this.refs.parameter.value;
        }

        var enableValidation = this.refs.enableValidation.value;

        var selectedValidation = this._getSelectedValidation();

        if (enableValidation && !this.value.expression && this.context.validation) {
          selectedValidation = this.validations.find(function (validation) {
            return validation.name === _this.context.validation.expression.name;
          });
          parameter = this.context.validation.parameterMessage;
        }

        if (enableValidation) {
          expression = {
            name: selectedValidation.name,
            value: (0, _strings.subWords)(selectedValidation.template, {
              name: name
            })
          };
        }

        return {
          enableValidation: enableValidation,
          errorMessage: _objectSpread({}, this.value.errorMessage, _defineProperty({}, editingLanguageId, errorMessage)),
          expression: expression,
          parameter: _objectSpread({}, this.value.parameter, _defineProperty({}, editingLanguageId, parameter))
        };
      }
    }, {
      key: "_normalizeValidationsOptions",
      value: function _normalizeValidationsOptions(validations) {
        return validations.map(function (validation) {
          return _objectSpread({}, validation, {
            checked: false,
            value: validation.name
          });
        });
      }
    }, {
      key: "_parseValidationFromExpression",
      value: function _parseValidationFromExpression(expression) {
        var validations = this.validations;
        var validation;

        if (!expression && this.context.validation) {
          expression = this.context.validation.expression;
        }

        if (expression) {
          validation = validations.find(function (validation) {
            return validation.name === expression.name;
          });
        }

        return validation;
      }
    }, {
      key: "_updateValue",
      value: function _updateValue() {
        var _this2 = this;

        var value = this._getValue();

        this.setState({
          value: value
        }, function () {
          return _this2._emitFieldEdited(value);
        });
      }
    }, {
      key: "_validationsValueFn",
      value: function _validationsValueFn() {
        var dataType = this.dataType;
        dataType = dataType == 'string' ? dataType : 'numeric';
        return this._normalizeValidationsOptions(_validations["default"][dataType]);
      }
    }]);

    return Validation;
  }(_metalComponent["default"]);

  Validation.STATE = {
    /**
     * @default undefined
     * @instance
     * @memberof Validation
     * @type {?(string|undefined)}
     */
    dataType: _metalState.Config.string().valueFn('_dataTypeValueFn'),

    /**
     * @default undefined
     * @instance
     * @memberof Options
     * @type {?string}
     */
    defaultLanguageId: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Options
     * @type {?string}
     */
    editingLanguageId: _metalState.Config.string(),

    /**
     * @default false
     * @instance
     * @memberof Validation
     * @type {bool}
     */
    enableValidation: _metalState.Config.bool().internal().valueFn('_enableValidationValueFn'),

    /**
     * @default undefined
     * @instance
     * @memberof Validation
     * @type {?}
     */
    expression: _metalState.Config.object(),

    /**
     * @default undefined
     * @instance
     * @memberof Validation
     * @type {?(string|undefined)}
     */
    fieldName: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Validation
     * @type {?(string|undefined)}
     */
    id: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Validation
     * @type {?(string|undefined)}
     */
    label: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Validation
     * @type {?(string|undefined)}
     */
    name: _metalState.Config.string().required(),

    /**
     * @default ''
     * @instance
     * @memberof Validation
     * @type {String}
     */
    parameterMessage: _metalState.Config.string().internal().value(''),

    /**
     * @default false
     * @instance
     * @memberof Validation
     * @type {?bool}
     */
    readOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof Validation
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Validation
     * @type {?(string|undefined)}
     */
    type: _metalState.Config.string().value('validation'),

    /**
     * @default undefined
     * @instance
     * @memberof Validation
     * @type {?(object|undefined)}
     */
    validation: _metalState.Config.object(),

    /**
     * @default array
     * @instance
     * @memberof Validation
     * @type {array}
     */
    validations: _metalState.Config.array().valueFn('_validationsValueFn'),

    /**
     * @default undefined
     * @instance
     * @memberof Validation
     * @type {?(string|undefined)}
     */
    value: _metalState.Config.shapeOf({
      errorMessage: _metalState.Config.object(),
      expression: _metalState.Config.object(),
      parameter: _metalState.Config.object()
    }).value({})
  };

  _metalSoy["default"].register(Validation, _Validation["default"]);

  var _default = Validation;
  exports["default"] = _default;
  //# sourceMappingURL=Validation.es.js.map
});
//# sourceMappingURL=Validation.es.js.map