Liferay.Loader.define("dynamic-data-mapping-form-builder@2.0.87/js/components/FieldTypeBox/FieldTypeBox.es", ['module', 'exports', 'require'], function (module, exports, require) {
    var define = undefined;
    Object.defineProperty(exports, "__esModule", {
        value: true
    });
    exports["default"] = void 0;

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var FieldTypeBox = function FieldTypeBox(_ref) {
        var _fieldType_$concat;

        var fieldType = _ref.fieldType,
            spritemap = _ref.spritemap;
        var description = fieldType.description,
            icon = fieldType.icon,
            label = fieldType.label,
            name = fieldType.name;
        IncrementalDOM.elementOpen("div", _fieldType_$concat = "fieldType_".concat(name), ["class", "ddm-drag-item list-group-item list-group-item-flex", "key", _fieldType_$concat], "data-field-type-name", name, "ref", "fieldType_".concat(name));
        IncrementalDOM.elementOpen("div", null, null, "class", "autofit-col");
        IncrementalDOM.elementOpen("span", null, null, "class", "sticker sticker-secondary");
        IncrementalDOM.elementOpen("span", null, null, "class", "inline-item");
        IncrementalDOM.elementOpen("svg", null, null, "class", "lexicon-icon lexicon-icon-".concat(icon), "aria-hidden", "true");
        IncrementalDOM.elementVoid("use", null, null, "xlink:href", "".concat(spritemap, "#").concat(icon));
        IncrementalDOM.elementClose("svg");
        IncrementalDOM.elementClose("span");
        IncrementalDOM.elementClose("span");
        IncrementalDOM.elementClose("div");
        IncrementalDOM.elementOpen("div", null, null, "class", "autofit-col autofit-col-expand");
        IncrementalDOM.elementOpen("h4", null, null, "class", "list-group-title text-truncate");
        IncrementalDOM.elementOpen("span");
        iDOMHelpers.renderArbitrary(label);
        IncrementalDOM.elementClose("span");
        IncrementalDOM.elementClose("h4");
        iDOMHelpers.renderArbitrary(description && (IncrementalDOM.elementOpen("p", null, null, "class", "list-group-subtitle text-truncate"), iDOMHelpers.renderArbitrary(description), IncrementalDOM.elementClose("p")));
        IncrementalDOM.elementClose("div");
        return IncrementalDOM.elementClose("div");
    };

    var _default = FieldTypeBox;
    exports["default"] = _default;
    //# sourceMappingURL=FieldTypeBox.es.js.map
});
//# sourceMappingURL=FieldTypeBox.es.js.map