Liferay.Loader.define("dynamic-data-mapping-form-builder@2.0.87/js/components/FormBuilder/withEditablePageHeader.es", ['module', 'exports', 'require', './EditablePageHeader.soy', 'dynamic-data-mapping-form-renderer/js/util/visitors.es', 'frontend-js-metal-web$metal-events', 'frontend-js-metal-web$metal-jsx', '../../util/strings.es', './props.es'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("./EditablePageHeader.soy");

  var _visitors = require("dynamic-data-mapping-form-renderer/js/util/visitors.es");

  var _metalEvents = require("frontend-js-metal-web$metal-events");

  var _metalJsx = _interopRequireDefault(require("frontend-js-metal-web$metal-jsx"));

  var _strings = require("../../util/strings.es");

  var _props = _interopRequireDefault(require("./props.es"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });keys.push.apply(keys, symbols);
    }return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var withEditablePageHeader = function withEditablePageHeader(ChildComponent) {
    var EditablePageHeader = /*#__PURE__*/function (_Component) {
      _inherits(EditablePageHeader, _Component);

      function EditablePageHeader() {
        _classCallCheck(this, EditablePageHeader);

        return _possibleConstructorReturn(this, _getPrototypeOf(EditablePageHeader).apply(this, arguments));
      }

      _createClass(EditablePageHeader, [{
        key: "attached",
        value: function attached() {
          this._eventHandler = new _metalEvents.EventHandler();

          this._eventHandler.add(this.delegate('input', '.form-builder-page-header-title', this._handlePageTitleChanged.bind(this)), this.delegate('input', '.form-builder-page-header-description', this._handlePageDescriptionChanged.bind(this)));
        }
      }, {
        key: "disposed",
        value: function disposed() {
          this._eventHandler.removeAllListeners();
        }
      }, {
        key: "getPages",
        value: function getPages() {
          var pages = this.props.pages;
          var total = pages.length;
          var visitor = new _visitors.PagesVisitor(pages);
          return visitor.mapPages(function (page, pageIndex) {
            return _objectSpread({}, page, {
              headerRenderer: 'editable',
              pageIndex: pageIndex,
              placeholder: (0, _strings.sub)(Liferay.Language.get('untitled-page-x-of-x'), [pageIndex + 1, total]),
              total: total
            });
          });
        }
      }, {
        key: "render",
        value: function render() {
          IncrementalDOM.elementOpen("div");
          IncrementalDOM.elementOpenStart(ChildComponent);
          iDOMHelpers.forOwn(this.props, iDOMHelpers.attr);
          IncrementalDOM.attr("pages", this.getPages());
          IncrementalDOM.elementOpenEnd(ChildComponent);
          IncrementalDOM.elementClose(ChildComponent);
          return IncrementalDOM.elementClose("div");
        }
      }, {
        key: "_handlePageDescriptionChanged",
        value: function _handlePageDescriptionChanged(event) {
          var _this$props = this.props,
              activePage = _this$props.activePage,
              editingLanguageId = _this$props.editingLanguageId,
              pages = _this$props.pages;
          var delegateTarget = event.delegateTarget;
          var dispatch = this.context.dispatch;
          var value = delegateTarget.value;
          var visitor = new _visitors.PagesVisitor(pages);
          dispatch('pagesUpdated', visitor.mapPages(function (page, pageIndex) {
            if (pageIndex === activePage) {
              page = _objectSpread({}, page, {
                description: value,
                localizedDescription: _objectSpread({}, page.localizedDescription, _defineProperty({}, editingLanguageId, value))
              });
            }

            return page;
          }));
        }
      }, {
        key: "_handlePageTitleChanged",
        value: function _handlePageTitleChanged(event) {
          var _this$props2 = this.props,
              activePage = _this$props2.activePage,
              editingLanguageId = _this$props2.editingLanguageId,
              pages = _this$props2.pages;
          var delegateTarget = event.delegateTarget;
          var dispatch = this.context.dispatch;
          var value = delegateTarget.value;
          var visitor = new _visitors.PagesVisitor(pages);
          dispatch('pagesUpdated', visitor.mapPages(function (page, pageIndex) {
            if (pageIndex === activePage) {
              page = _objectSpread({}, page, {
                localizedTitle: _objectSpread({}, page.localizedTitle, _defineProperty({}, editingLanguageId, value)),
                title: value
              });
            }

            return page;
          }));
        }
      }]);

      return EditablePageHeader;
    }(_metalJsx["default"]);

    EditablePageHeader.PROPS = _objectSpread({}, _props["default"]);
    return EditablePageHeader;
  };

  var _default = withEditablePageHeader;
  exports["default"] = _default;
  //# sourceMappingURL=withEditablePageHeader.es.js.map
});
//# sourceMappingURL=withEditablePageHeader.es.js.map