Liferay.Loader.define("dynamic-data-mapping-form-renderer@4.0.70/js/components/FormRenderer/FormRenderer.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.FormRenderer = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from FormRenderer.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace FormRenderer.
     * @public
     */

    goog.module('FormRenderer.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');

    var $templateAlias1 = _metalSoy["default"].getTemplate('PageRenderer.incrementaldom', 'render');
    /**
     * @param {{
     *  pages: (?),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleFieldEdited: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  activePage: (null|number|undefined),
     *  editable: (boolean|null|undefined),
     *  editingLanguageId: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  paginationMode: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  portletNamespace: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  showSubmitButton: (boolean|null|undefined),
     *  strings: (!Object<!goog.soy.data.SanitizedContent|string,!goog.soy.data.SanitizedContent|string>|null|undefined),
     *  submitLabel: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  invalidFormMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  forceAriaUpdate: (null|number|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      var $$temp;
      /** @type {?} */

      var pages = opt_data.pages;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var spritemap = soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleFieldClicked = opt_data._handleFieldClicked;
      /** @type {*|null|undefined} */

      var _handleFieldEdited = opt_data._handleFieldEdited;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;
      /** @type {null|number|undefined} */

      var activePage = soy.asserts.assertType(opt_data.activePage == null || goog.isNumber(opt_data.activePage), 'activePage', opt_data.activePage, 'null|number|undefined');
      /** @type {boolean|null|undefined} */

      var editable = soy.asserts.assertType(opt_data.editable == null || goog.isBoolean(opt_data.editable) || opt_data.editable === 1 || opt_data.editable === 0, 'editable', opt_data.editable, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var editingLanguageId = soy.asserts.assertType(opt_data.editingLanguageId == null || goog.isString(opt_data.editingLanguageId) || opt_data.editingLanguageId instanceof goog.soy.data.SanitizedContent, 'editingLanguageId', opt_data.editingLanguageId, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var paginationMode = soy.asserts.assertType(opt_data.paginationMode == null || goog.isString(opt_data.paginationMode) || opt_data.paginationMode instanceof goog.soy.data.SanitizedContent, 'paginationMode', opt_data.paginationMode, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var portletNamespace = soy.asserts.assertType(opt_data.portletNamespace == null || goog.isString(opt_data.portletNamespace) || opt_data.portletNamespace instanceof goog.soy.data.SanitizedContent, 'portletNamespace', opt_data.portletNamespace, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showSubmitButton = soy.asserts.assertType(opt_data.showSubmitButton == null || goog.isBoolean(opt_data.showSubmitButton) || opt_data.showSubmitButton === 1 || opt_data.showSubmitButton === 0, 'showSubmitButton', opt_data.showSubmitButton, 'boolean|null|undefined');
      /** @type {!Object<!goog.soy.data.SanitizedContent|string,!goog.soy.data.SanitizedContent|string>|null|undefined} */

      var strings = soy.asserts.assertType(opt_data.strings == null || goog.isObject(opt_data.strings), 'strings', opt_data.strings, '!Object<!goog.soy.data.SanitizedContent|string,!goog.soy.data.SanitizedContent|string>|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var submitLabel = soy.asserts.assertType(opt_data.submitLabel == null || goog.isString(opt_data.submitLabel) || opt_data.submitLabel instanceof goog.soy.data.SanitizedContent, 'submitLabel', opt_data.submitLabel, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var invalidFormMessage = soy.asserts.assertType(opt_data.invalidFormMessage == null || goog.isString(opt_data.invalidFormMessage) || opt_data.invalidFormMessage instanceof goog.soy.data.SanitizedContent, 'invalidFormMessage', opt_data.invalidFormMessage, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {null|number|undefined} */

      var forceAriaUpdate = soy.asserts.assertType(opt_data.forceAriaUpdate == null || goog.isNumber(opt_data.forceAriaUpdate), 'forceAriaUpdate', opt_data.forceAriaUpdate, 'null|number|undefined');
      var currentPaginationMode__soy21 = ($$temp = paginationMode) == null ? 'wizard' : $$temp;
      ($$temp = activePage) == null ? 0 : $$temp;

      var total__soy25 = pages.length;
      var classes__soy27 = '';
      classes__soy27 += 'lfr-ddm-form-container position-relative';
      classes__soy27 += !editable ? ' ddm-user-view-content' : '';
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', classes__soy27);
      incrementalDom.elementOpenEnd();

      if (invalidFormMessage) {
        incrementalDom.elementOpenStart('span');
        incrementalDom.attr('aria-atomic', 'true');
        incrementalDom.attr('aria-live', 'polite');
        incrementalDom.attr('class', 'sr-only');
        incrementalDom.elementOpenEnd();
        soyIdom.print(invalidFormMessage);
        incrementalDom.elementOpenStart('span');
        incrementalDom.attr('aria-hidden', 'true');
        incrementalDom.elementOpenEnd();
        soyIdom.print(forceAriaUpdate);
        incrementalDom.elementClose('span');
        incrementalDom.elementClose('span');
      }

      var page65List = pages;
      var page65ListLen = page65List.length;

      for (var page65Index = 0; page65Index < page65ListLen; page65Index++) {
        var page65Data = page65List[page65Index];
        $templateAlias1({
          activePage: activePage,
          editable: editable,
          editingLanguageId: editingLanguageId,
          events: {
            fieldBlurred: _handleFieldBlurred,
            fieldClicked: _handleFieldClicked,
            fieldEdited: _handleFieldEdited,
            fieldFocused: _handleFieldFocused
          },
          key: page65Index,
          page: page65Data,
          pageIndex: page65Index,
          pages: pages,
          paginationMode: currentPaginationMode__soy21,
          portletNamespace: portletNamespace,
          readOnly: readOnly,
          ref: 'pageRenderer' + page65Index,
          showSubmitButton: showSubmitButton != false,
          spritemap: spritemap,
          strings: strings,
          submitLabel: ($$temp = submitLabel) == null ? 'submit' : $$temp,
          total: total__soy25,
          invalidFormMessage: invalidFormMessage
        }, null, opt_ijData);
      }

      incrementalDom.elementClose('div');
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  pages: (?),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleFieldEdited: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  activePage: (null|number|undefined),
     *  editable: (boolean|null|undefined),
     *  editingLanguageId: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  paginationMode: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  portletNamespace: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  showSubmitButton: (boolean|null|undefined),
     *  strings: (!Object<!goog.soy.data.SanitizedContent|string,!goog.soy.data.SanitizedContent|string>|null|undefined),
     *  submitLabel: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  invalidFormMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  forceAriaUpdate: (null|number|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'FormRenderer.render';
    }

    exports.render.params = ["pages", "spritemap", "_handleFieldBlurred", "_handleFieldClicked", "_handleFieldEdited", "_handleFieldFocused", "activePage", "editable", "editingLanguageId", "paginationMode", "portletNamespace", "readOnly", "showSubmitButton", "strings", "submitLabel", "invalidFormMessage", "forceAriaUpdate"];
    exports.render.types = {
      "pages": "?",
      "spritemap": "string",
      "_handleFieldBlurred": "any",
      "_handleFieldClicked": "any",
      "_handleFieldEdited": "any",
      "_handleFieldFocused": "any",
      "activePage": "number",
      "editable": "bool",
      "editingLanguageId": "string",
      "paginationMode": "string",
      "portletNamespace": "string",
      "readOnly": "bool",
      "showSubmitButton": "bool",
      "strings": "map<string, string>",
      "submitLabel": "string",
      "invalidFormMessage": "string",
      "forceAriaUpdate": "number"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var FormRenderer = /*#__PURE__*/function (_Component) {
    _inherits(FormRenderer, _Component);

    function FormRenderer() {
      _classCallCheck(this, FormRenderer);

      return _possibleConstructorReturn(this, _getPrototypeOf(FormRenderer).apply(this, arguments));
    }

    return FormRenderer;
  }(_metalComponent["default"]);

  exports.FormRenderer = FormRenderer;

  _metalSoy["default"].register(FormRenderer, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=FormRenderer.soy.js.map
});
//# sourceMappingURL=FormRenderer.soy.js.map