Liferay.Loader.define("dynamic-data-mapping-form-builder@2.0.87/js/components/LayoutProvider/LayoutProvider.es", ['module', 'exports', 'require', 'frontend-taglib-clay$clay-modal', 'dynamic-data-mapping-form-renderer/js/components/FormRenderer/FormSupport.es', 'dynamic-data-mapping-form-renderer/js/store/actions/handlePaginationItemClicked.es', 'dynamic-data-mapping-form-renderer/js/util/visitors.es', 'frontend-js-metal-web$metal-dom', 'frontend-js-metal-web$metal-jsx', 'frontend-js-metal-web$metal-state', '../../util/config.es', '../../util/fieldSupport.es', '../../util/i18n.es', '../RuleBuilder/RulesSupport.es', './handlers/columnResizedHandler.es', './handlers/fieldAddedHandler.es', './handlers/fieldBlurredHandler.es', './handlers/fieldClickedHandler.es', './handlers/fieldDeletedHandler.es', './handlers/fieldDuplicatedHandler.es', './handlers/fieldEditedHandler.es', './handlers/fieldMovedHandler.es', './handlers/fieldSetAddedHandler.es', './handlers/focusedFieldEvaluationEndedHandler.es', './handlers/languageIdDeletedHandler.es', './handlers/sectionAddedHandler.es', './util/defaults.es', './util/fields.es'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  var _clayModal = _interopRequireDefault(require("frontend-taglib-clay$clay-modal"));

  var FormSupport = _interopRequireWildcard(require("dynamic-data-mapping-form-renderer/js/components/FormRenderer/FormSupport.es"));

  var _handlePaginationItemClicked2 = _interopRequireDefault(require("dynamic-data-mapping-form-renderer/js/store/actions/handlePaginationItemClicked.es"));

  var _visitors = require("dynamic-data-mapping-form-renderer/js/util/visitors.es");

  var _metalDom = _interopRequireDefault(require("frontend-js-metal-web$metal-dom"));

  var _metalJsx = _interopRequireDefault(require("frontend-js-metal-web$metal-jsx"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _config = require("../../util/config.es");

  var _fieldSupport = require("../../util/fieldSupport.es");

  var _i18n = require("../../util/i18n.es");

  var _RulesSupport = _interopRequireDefault(require("../RuleBuilder/RulesSupport.es"));

  var _columnResizedHandler = _interopRequireDefault(require("./handlers/columnResizedHandler.es"));

  var _fieldAddedHandler = _interopRequireDefault(require("./handlers/fieldAddedHandler.es"));

  var _fieldBlurredHandler = _interopRequireDefault(require("./handlers/fieldBlurredHandler.es"));

  var _fieldClickedHandler = _interopRequireDefault(require("./handlers/fieldClickedHandler.es"));

  var _fieldDeletedHandler = _interopRequireDefault(require("./handlers/fieldDeletedHandler.es"));

  var _fieldDuplicatedHandler = _interopRequireDefault(require("./handlers/fieldDuplicatedHandler.es"));

  var _fieldEditedHandler = _interopRequireDefault(require("./handlers/fieldEditedHandler.es"));

  var _fieldMovedHandler = _interopRequireDefault(require("./handlers/fieldMovedHandler.es"));

  var _fieldSetAddedHandler = _interopRequireDefault(require("./handlers/fieldSetAddedHandler.es"));

  var _focusedFieldEvaluationEndedHandler = _interopRequireDefault(require("./handlers/focusedFieldEvaluationEndedHandler.es"));

  var _languageIdDeletedHandler = _interopRequireDefault(require("./handlers/languageIdDeletedHandler.es"));

  var _sectionAddedHandler = _interopRequireDefault(require("./handlers/sectionAddedHandler.es"));

  var _defaults = require("./util/defaults.es");

  var _fields = require("./util/fields.es");

  function _getRequireWildcardCache() {
    if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
      return cache;
    };return cache;
  }

  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
      return { "default": obj };
    }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
      return cache.get(obj);
    }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }newObj["default"] = obj;if (cache) {
      cache.set(obj, newObj);
    }return newObj;
  }

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
  }

  function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
        arr2[i] = arr[i];
      }return arr2;
    }
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });keys.push.apply(keys, symbols);
    }return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  /**
   * LayoutProvider listens to your children's events to
   * control the `pages` and make manipulations.
   * @extends Component
   */
  var LayoutProvider = /*#__PURE__*/function (_Component) {
    _inherits(LayoutProvider, _Component);

    function LayoutProvider() {
      _classCallCheck(this, LayoutProvider);

      return _possibleConstructorReturn(this, _getPrototypeOf(LayoutProvider).apply(this, arguments));
    }

    _createClass(LayoutProvider, [{
      key: "createNewPage",
      value: function createNewPage() {
        var languageId = this.props.editingLanguageId;
        var page = {
          description: '',
          enabled: true,
          rows: [FormSupport.implAddRow(12, [])],
          showRequiredFieldsWarning: true,
          title: ''
        };
        (0, _i18n.setLocalizedValue)(page, languageId, 'title', '');
        (0, _i18n.setLocalizedValue)(page, languageId, 'description', '');
        return page;
      }
    }, {
      key: "dispatch",
      value: function dispatch(event, payload) {
        this.emit(event, payload);
      }
    }, {
      key: "getChildContext",
      value: function getChildContext() {
        return {
          dispatch: this.dispatch.bind(this),
          store: this
        };
      }
    }, {
      key: "getEvents",
      value: function getEvents() {
        return {
          activePageUpdated: this._handleActivePageUpdated.bind(this),
          columnResized: this._handleColumnResized.bind(this),
          fieldAdded: this._handleFieldAdded.bind(this),
          fieldBlurred: this._handleFieldBlurred.bind(this),
          fieldChangesCanceled: this._handleFieldChangesCanceled.bind(this),
          fieldClicked: this._handleFieldClicked.bind(this),
          fieldDeleted: this._handleFieldDeleted.bind(this),
          fieldDuplicated: this._handleFieldDuplicated.bind(this),
          fieldEdited: this._handleFieldEdited.bind(this),
          fieldMoved: this._handleFieldMoved.bind(this),
          fieldSetAdded: this._handleFieldSetAdded.bind(this),
          focusedFieldEvaluationEnded: this._handleFocusedFieldEvaluationEnded.bind(this),
          languageIdDeleted: this._handleLanguageIdDeleted.bind(this),
          pageAdded: this._handlePageAdded.bind(this),
          pageDeleted: this._handlePageDeleted.bind(this),
          pageReset: this._handlePageReset.bind(this),
          pagesUpdated: this._handlePagesUpdated.bind(this),
          paginationItemClicked: this._handlePaginationItemClicked.bind(this),
          paginationModeUpdated: this._handlePaginationModeUpdated.bind(this),
          paginationNextClicked: this._handlePaginationNextClicked.bind(this),
          paginationPreviousClicked: this._handlePaginationPreviousClicked.bind(this),
          ruleAdded: this._handleRuleAdded.bind(this),
          ruleDeleted: this._handleRuleDeleted.bind(this),
          ruleSaved: this._handleRuleSaved.bind(this),
          sectionAdded: this._handleSectionAdded.bind(this),
          sidebarFieldBlurred: this._handleSidebarFieldBlurred.bind(this),
          successPageChanged: this._handleSuccessPageChanged.bind(this)
        };
      }
    }, {
      key: "getFocusedField",
      value: function getFocusedField() {
        var _this$props = this.props,
            defaultLanguageId = _this$props.defaultLanguageId,
            editingLanguageId = _this$props.editingLanguageId;
        var focusedField = this.state.focusedField;

        if (focusedField && focusedField.settingsContext) {
          var settingsContext = _objectSpread({}, focusedField.settingsContext, {
            pages: this.getLocalizedPages(focusedField.settingsContext.pages)
          });

          focusedField = _objectSpread({}, focusedField, {}, (0, _fieldSupport.getFieldProperties)(settingsContext, defaultLanguageId, editingLanguageId), {
            settingsContext: settingsContext
          });
        }

        return focusedField;
      }
    }, {
      key: "getLocalizedPages",
      value: function getLocalizedPages(pages) {
        var _this$props2 = this.props,
            defaultLanguageId = _this$props2.defaultLanguageId,
            editingLanguageId = _this$props2.editingLanguageId;
        var settingsVisitor = new _visitors.PagesVisitor(pages);
        return settingsVisitor.mapFields(function (field) {
          var value = field.value;

          if (field.localizable) {
            var localizedValue = field.localizedValue[editingLanguageId];

            if (localizedValue === undefined) {
              localizedValue = field.localizedValue[defaultLanguageId];
            }

            if (localizedValue !== undefined) {
              value = localizedValue;
            }
          } else if (field.dataType === 'ddm-options' && value[editingLanguageId] === undefined) {
            value = _objectSpread({}, value, _defineProperty({}, editingLanguageId, value[defaultLanguageId]));
          }

          return _objectSpread({}, field, {
            defaultLanguageId: defaultLanguageId,
            editingLanguageId: editingLanguageId,
            localizedValue: _objectSpread({}, field.localizedValue, _defineProperty({}, editingLanguageId, value)),
            value: value
          });
        });
      }
    }, {
      key: "getPages",
      value: function getPages() {
        var _this = this;

        var _this$props3 = this.props,
            defaultLanguageId = _this$props3.defaultLanguageId,
            editingLanguageId = _this$props3.editingLanguageId;
        var focusedField = this.state.focusedField;
        var pages = this.state.pages;
        var visitor = new _visitors.PagesVisitor(pages);
        pages = visitor.mapFields(function (field) {
          var settingsContext = field.settingsContext;

          var newField = _objectSpread({}, (0, _fieldSupport.getFieldProperties)(settingsContext, defaultLanguageId, editingLanguageId), {
            selected: focusedField.fieldName === field.fieldName,
            settingsContext: _objectSpread({}, settingsContext, {
              availableLanguageIds: [editingLanguageId],
              defaultLanguageId: defaultLanguageId,
              pages: _this.getLocalizedPages(settingsContext.pages)
            })
          });

          if (field.type === 'select' && field.dataSourceType && field.dataSourceType.includes('data-provider')) {
            return _objectSpread({}, newField, {
              options: field.options
            });
          }

          return newField;
        }, true, true);
        visitor.setPages(pages);
        return visitor.mapPages(function (page) {
          var description = page.description,
              title = page.title;

          if (page.localizedDescription[editingLanguageId]) {
            description = page.localizedDescription[editingLanguageId];
          } else if (page.localizedDescription[defaultLanguageId]) {
            description = page.localizedDescription[defaultLanguageId];
          }

          if (page.localizedTitle[editingLanguageId]) {
            title = page.localizedTitle[editingLanguageId];
          } else if (page.localizedTitle[defaultLanguageId]) {
            title = page.localizedTitle[defaultLanguageId];
          }

          return _objectSpread({}, page, {
            description: description,
            title: title
          });
        });
      }
    }, {
      key: "getRules",
      value: function getRules() {
        var rules = this.state.rules;

        if (rules) {
          var visitor = new _visitors.RulesVisitor(rules);
          rules = visitor.mapConditions(function (condition) {
            if (condition.operands[0].type == 'list') {
              condition = _objectSpread({}, condition, {
                operands: [{
                  label: 'user',
                  repeatable: false,
                  type: 'user',
                  value: 'user'
                }, _objectSpread({}, condition.operands[0], {
                  label: condition.operands[0].value
                })]
              });
            }

            return condition;
          });
        }

        return rules;
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props4 = this.props,
            children = _this$props4.children,
            defaultLanguageId = _this$props4.defaultLanguageId,
            editingLanguageId = _this$props4.editingLanguageId,
            fieldActions = _this$props4.fieldActions,
            spritemap = _this$props4.spritemap;
        var _this$state = this.state,
            activePage = _this$state.activePage,
            paginationMode = _this$state.paginationMode,
            rules = _this$state.rules,
            successPageSettings = _this$state.successPageSettings;

        if (children.length) {
          for (var index = 0; index < children.length; index++) {
            var child = children[index];
            Object.assign(child.props, _objectSpread({}, this.otherProps(), {
              activePage: activePage,
              defaultLanguageId: defaultLanguageId,
              editingLanguageId: editingLanguageId,
              fieldActions: fieldActions,
              focusedField: this.getFocusedField(),
              pages: this.getPages(),
              paginationMode: paginationMode,
              rules: rules,
              spritemap: spritemap,
              successPageSettings: successPageSettings
            }));
          }
        }

        IncrementalDOM.elementOpen("div");
        IncrementalDOM.elementOpen("span");
        iDOMHelpers.renderArbitrary(children);
        IncrementalDOM.elementClose("span");
        IncrementalDOM.elementVoid(_clayModal["default"], null, null, "body", Liferay.Language.get('a-rule-is-applied-to-this-field'), "events", {
          clickButton: this._handleDeleteFieldModalButtonClicked.bind(this)
        }, "footerButtons", [{
          alignment: 'right',
          label: Liferay.Language.get('cancel'),
          style: 'secondary',
          type: 'close'
        }, {
          alignment: 'right',
          label: Liferay.Language.get('confirm'),
          style: 'primary',
          type: 'button'
        }], "spritemap", spritemap, "title", Liferay.Language.get('delete-field-with-rule-applied'), "elementClasses", 'lfr-ddm-forms-delete-rule', "ref", 'existingRuleModal', "size", 'lg');
        return IncrementalDOM.elementClose("div");
      }
    }, {
      key: "_fieldActionsValueFn",
      value: function _fieldActionsValueFn() {
        var _this2 = this;

        return [{
          action: function action(fieldName) {
            return _this2.dispatch('fieldDuplicated', {
              fieldName: fieldName
            });
          },
          label: Liferay.Language.get('duplicate')
        }, {
          action: function action(fieldName) {
            var pages = _this2.state.pages;
            var rules = _this2.state.rules;
            var indexes = (0, _fieldSupport.getFieldIndexes)(pages, fieldName);

            if (_RulesSupport["default"].findRuleByFieldName(fieldName, rules)) {
              _this2.refs.existingRuleModal.data = indexes;

              _this2.refs.existingRuleModal.show();
            } else {
              _this2.dispatch('fieldDeleted', indexes);
            }
          },
          label: Liferay.Language.get('delete')
        }];
      }
    }, {
      key: "_fieldNameGeneratorValueFn",
      value: function _fieldNameGeneratorValueFn() {
        var _this3 = this;

        return function (desiredName, currentName) {
          var pages = _this3.state.pages;
          return (0, _fields.generateFieldName)(pages, desiredName, currentName);
        };
      }
    }, {
      key: "_handleActivePageUpdated",
      value: function _handleActivePageUpdated(activePage) {
        this.setState({
          activePage: activePage
        });
      }
    }, {
      key: "_handleColumnResized",
      value: function _handleColumnResized(_ref) {
        var column = _ref.column,
            container = _ref.container,
            direction = _ref.direction,
            source = _ref.source;
        var state = this.state;
        this.setState((0, _columnResizedHandler["default"])(this.props, state, source, container, column, direction));
      }
    }, {
      key: "_handleFieldAdded",
      value: function _handleFieldAdded(event) {
        this.setState((0, _fieldAddedHandler["default"])(this.props, this.state, event));
      }
    }, {
      key: "_handleFieldBlurred",
      value: function _handleFieldBlurred(event) {
        this.setState((0, _fieldBlurredHandler["default"])(this.state, event));
      }
    }, {
      key: "_handleFieldChangesCanceled",
      value: function _handleFieldChangesCanceled() {
        var _this4 = this;

        var _this$state2 = this.state,
            focusedField = _this$state2.focusedField,
            pages = _this$state2.pages,
            previousFocusedField = _this$state2.previousFocusedField;
        var settingsContext = previousFocusedField.settingsContext;
        var visitor = new _visitors.PagesVisitor(settingsContext.pages);
        visitor.mapFields(function (_ref2) {
          var fieldName = _ref2.fieldName,
              value = _ref2.value;

          _this4._handleFieldEdited({
            propertyName: fieldName,
            propertyValue: value
          });
        });
        visitor.setPages(pages);
        this.setState({
          focusedField: previousFocusedField,
          pages: visitor.mapFields(function (field) {
            if (field.fieldName === focusedField.fieldName) {
              return _objectSpread({}, field, {
                settingsContext: settingsContext
              });
            }

            return field;
          })
        });
      }
    }, {
      key: "_handleDeleteFieldModalButtonClicked",
      value: function _handleDeleteFieldModalButtonClicked(event) {
        if (event.target.classList.contains('btn-primary')) {
          this.dispatch('fieldDeleted', this.refs.existingRuleModal.data);
        }
      }
    }, {
      key: "_handleFieldClicked",
      value: function _handleFieldClicked(event) {
        this.setState((0, _fieldClickedHandler["default"])(this.props, this.state, event));
      }
    }, {
      key: "_handleFieldDeleted",
      value: function _handleFieldDeleted(event) {
        this.setState((0, _fieldDeletedHandler["default"])(this.state, event));
      }
    }, {
      key: "_handleFieldDuplicated",
      value: function _handleFieldDuplicated(event) {
        this.setState((0, _fieldDuplicatedHandler["default"])(this.props, this.state, event));
      }
    }, {
      key: "_handleFieldEdited",
      value: function _handleFieldEdited(properties) {
        this.setState((0, _fieldEditedHandler["default"])(this.props, this.state, properties));
      }
    }, {
      key: "_handleFieldMoved",
      value: function _handleFieldMoved(event) {
        this.setState((0, _fieldMovedHandler["default"])(this.props, this.state, event));
      }
    }, {
      key: "_handleFieldSetAdded",
      value: function _handleFieldSetAdded(event) {
        this.setState((0, _fieldSetAddedHandler["default"])(this.props, this.state, event));
      }
    }, {
      key: "_handleFocusedFieldEvaluationEnded",
      value: function _handleFocusedFieldEvaluationEnded(_ref3) {
        var settingsContext = _ref3.settingsContext;
        this.setState((0, _focusedFieldEvaluationEndedHandler["default"])(this.props, this.state, settingsContext));
      }
    }, {
      key: "_handleLanguageIdDeleted",
      value: function _handleLanguageIdDeleted(_ref4) {
        var locale = _ref4.locale;
        var _this$state3 = this.state,
            focusedField = _this$state3.focusedField,
            pages = _this$state3.pages;
        this.setState((0, _languageIdDeletedHandler["default"])(focusedField, pages, locale));
      }
    }, {
      key: "_handlePageAdded",
      value: function _handlePageAdded() {
        var pages = this.state.pages;
        this.setState({
          activePage: pages.length,
          pages: [].concat(_toConsumableArray(pages), [this.createNewPage()])
        });
      }
    }, {
      key: "_handlePageDeleted",
      value: function _handlePageDeleted(pageIndex) {
        var pages = this.state.pages;
        this.setState({
          activePage: Math.max(0, pageIndex - 1),
          pages: pages.filter(function (page, index) {
            return index != pageIndex;
          })
        });
      }
    }, {
      key: "_handlePageReset",
      value: function _handlePageReset() {
        this.setState({
          pages: [this.createNewPage()]
        });
      }
    }, {
      key: "_handlePagesUpdated",
      value: function _handlePagesUpdated(pages) {
        this.setState({
          pages: _toConsumableArray(pages)
        });
      }
    }, {
      key: "_handlePaginationItemClicked",
      value: function _handlePaginationItemClicked(_ref5) {
        var pageIndex = _ref5.pageIndex;
        (0, _handlePaginationItemClicked2["default"])({
          pageIndex: pageIndex
        }, this.dispatch.bind(this));
      }
    }, {
      key: "_handlePaginationModeUpdated",
      value: function _handlePaginationModeUpdated() {
        var paginationMode = this.state.paginationMode;
        var newMode = 'paginated';

        if (paginationMode === newMode) {
          newMode = 'wizard';
        }

        this.setState({
          paginationMode: newMode
        });
      }
    }, {
      key: "_handlePaginationNextClicked",
      value: function _handlePaginationNextClicked() {
        var _this$state4 = this.state,
            activePage = _this$state4.activePage,
            pages = _this$state4.pages;
        var pageIndex = Math.min(activePage + 1, pages.length - 1);
        (0, _handlePaginationItemClicked2["default"])({
          pageIndex: pageIndex
        }, this.dispatch.bind(this));
      }
    }, {
      key: "_handlePaginationPreviousClicked",
      value: function _handlePaginationPreviousClicked() {
        var activePage = this.state.activePage;
        var pageIndex = Math.max(activePage - 1, 0);
        (0, _handlePaginationItemClicked2["default"])({
          pageIndex: pageIndex
        }, this.dispatch.bind(this));
      }
    }, {
      key: "_handleRuleAdded",
      value: function _handleRuleAdded(rule) {
        this.setState({
          rules: [].concat(_toConsumableArray(this.state.rules), [rule])
        });
        this.emit('rulesModified');
      }
    }, {
      key: "_handleRuleDeleted",
      value: function _handleRuleDeleted(_ref6) {
        var ruleId = _ref6.ruleId;
        var rules = this.state.rules;
        this.setState({
          rules: rules.filter(function (rule, index) {
            return index !== ruleId;
          })
        });
        this.emit('rulesModified');
      }
    }, {
      key: "_handleRuleSaved",
      value: function _handleRuleSaved(event) {
        var actions = event.actions,
            conditions = event.conditions,
            ruleEditedIndex = event.ruleEditedIndex;
        var logicalOperator = event['logical-operator'];
        var rules = this.state.rules;

        rules.splice(ruleEditedIndex, 1, {
          actions: actions,
          conditions: conditions,
          'logical-operator': logicalOperator
        });
        this.setState({
          rules: rules
        });
        this.emit('rulesModified');
      }
    }, {
      key: "_handleSectionAdded",
      value: function _handleSectionAdded(event) {
        this.setState((0, _sectionAddedHandler["default"])(this.props, this.state, event));
      }
    }, {
      key: "_handleSidebarFieldBlurred",
      value: function _handleSidebarFieldBlurred() {
        this.setState({
          focusedField: {}
        });
      }
    }, {
      key: "_handleSuccessPageChanged",
      value: function _handleSuccessPageChanged(successPageSettings) {
        this.setState({
          successPageSettings: successPageSettings
        });
      }
    }, {
      key: "_pagesValueFn",
      value: function _pagesValueFn() {
        var initialPages = this.props.initialPages;
        return initialPages;
      }
    }, {
      key: "_paginationModeValueFn",
      value: function _paginationModeValueFn() {
        return this.props.initialPaginationMode;
      }
    }, {
      key: "_rulesValueFn",
      value: function _rulesValueFn() {
        var rules = this.props.rules;
        return rules;
      }
    }, {
      key: "_setEvents",
      value: function _setEvents(value) {
        return _objectSpread({}, this.getEvents(), {}, value);
      }
    }, {
      key: "_setInitialPages",
      value: function _setInitialPages(initialPages) {
        var _this5 = this;

        var visitor = new _visitors.PagesVisitor(initialPages);
        return visitor.mapFields(function (field) {
          var settingsContext = field.settingsContext;
          return _objectSpread({}, field, {
            localizedValue: {},
            readOnly: true,
            settingsContext: _objectSpread({}, _this5._setInitialSettingsContext(settingsContext)),
            value: undefined,
            visible: true
          });
        });
      }
    }, {
      key: "_setInitialSettingsContext",
      value: function _setInitialSettingsContext(settingsContext) {
        var visitor = new _visitors.PagesVisitor(settingsContext.pages);
        return _objectSpread({}, settingsContext, {
          pages: visitor.mapFields(function (field) {
            if (field.type === 'options') {
              var getOptions = function getOptions(languageId, field) {
                return field.value[languageId].map(function (option) {
                  return _objectSpread({}, option, {
                    edited: true
                  });
                });
              };

              Object.keys(field.value).forEach(function (languageId) {
                field = _objectSpread({}, field, {
                  value: _objectSpread({}, field.value, _defineProperty({}, languageId, getOptions(languageId, field)))
                });
              });
            }

            return field;
          })
        });
      }
    }, {
      key: "_setPages",
      value: function _setPages(pages) {
        return pages.filter(function (_ref7) {
          var contentRenderer = _ref7.contentRenderer;
          return contentRenderer !== 'success';
        });
      }
    }, {
      key: "_shouldAutoGenerateNameValueFn",
      value: function _shouldAutoGenerateNameValueFn() {
        return _defaults.shouldAutoGenerateName;
      }
    }, {
      key: "_successPageSettingsValueFn",
      value: function _successPageSettingsValueFn() {
        return this.props.initialSuccessPageSettings;
      }
    }, {
      key: "_deleteFieldShowModal",
      value: function _deleteFieldShowModal() {
        var cancelChangesModal = this.refs.cancelChangesModal;
        cancelChangesModal.show();
      }
    }, {
      key: "_isOutsideModal",
      value: function _isOutsideModal(node) {
        return !_metalDom["default"].closest(node, '.close-modal');
      }
    }]);

    return LayoutProvider;
  }(_metalJsx["default"]);

  LayoutProvider.PROPS = {
    /**
     * @default undefined
     * @instance
     * @memberof LayoutProvider
     * @type {?string}
     */
    defaultLanguageId: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof LayoutProvider
     * @type {?string}
     */
    editingLanguageId: _metalState.Config.string(),

    /**
     * @default {}
     * @instance
     * @memberof LayoutProvider
     * @type {?object}
     */
    events: _metalState.Config.setter('_setEvents').value({}),

    /**
     * @default undefined
     * @instance
     * @memberof LayoutProvider
     * @type {?string}
     */
    fieldActions: _metalState.Config.array().valueFn('_fieldActionsValueFn'),

    /**
     * @default _fieldNameGeneratorValueFn
     * @instance
     * @memberof LayoutProvider
     * @type {?function}
     */
    fieldNameGenerator: _metalState.Config.func().valueFn('_fieldNameGeneratorValueFn'),

    /**
     * @default undefined
     * @instance
     * @memberof LayoutProvider
     * @type {?string}
     */
    fieldSetDefinitionURL: _metalState.Config.string(),

    /**
     * @default []
     * @instance
     * @memberof LayoutProvider
     * @type {?(array|undefined)}
     */
    fieldSets: _metalState.Config.array().value([]),

    /**
     * @default undefined
     * @instance
     * @memberof LayoutProvider
     * @type {?(array|undefined)}
     */
    initialPages: _metalState.Config.arrayOf(_config.pageStructure).setter('_setInitialPages').value([]),

    /**
     * @default 'wizard'
     * @instance
     * @memberof LayoutProvider
     * @type {?string}
     */
    initialPaginationMode: _metalState.Config.string().value('wizard'),

    /**
     * @instance
     * @memberof LayoutProvider
     * @type {object}
     */
    initialSuccessPageSettings: _metalState.Config.shapeOf({
      body: _metalState.Config.object(),
      enabled: _metalState.Config.bool(),
      title: _metalState.Config.object()
    }),

    /**
     * @default undefined
     * @instance
     * @memberof LayoutProvider
     * @type {?(array|undefined)}
     */
    rules: _metalState.Config.arrayOf(_config.ruleStructure),

    /**
     * @default undefined
     * @instance
     * @memberof LayoutProvider
     * @type {?(array|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof LayoutProvider
     * @type {?string}
     */
    view: _metalState.Config.string()
  };
  LayoutProvider.STATE = {
    /**
     * @instance
     * @memberof FormPage
     * @type {?number}
     */
    activePage: _metalState.Config.number().value(0),

    /**
     * @default {}
     * @instance
     * @memberof LayoutProvider
     * @type {?object}
     */
    focusedField: _metalState.Config.shapeOf({
      columnIndex: _metalState.Config.oneOfType([_metalState.Config.bool().value(false), _metalState.Config.number()]).required(),
      pageIndex: _metalState.Config.number().required(),
      rowIndex: _metalState.Config.number().required(),
      type: _metalState.Config.string().required()
    }).value({}),

    /**
     * @default undefined
     * @instance
     * @memberof LayoutProvider
     * @type {?array}
     */
    pages: _metalState.Config.arrayOf(_config.pageStructure).setter('_setPages').valueFn('_pagesValueFn'),

    /**
     * @instance
     * @memberof LayoutProvider
     * @type {string}
     */
    paginationMode: _metalState.Config.string().valueFn('_paginationModeValueFn'),

    /**
     * @default {}
     * @instance
     * @memberof LayoutProvider
     * @type {?object}
     */
    previousFocusedField: _metalState.Config.shapeOf({
      columnIndex: _metalState.Config.oneOfType([_metalState.Config.bool().value(false), _metalState.Config.number()]).required(),
      pageIndex: _metalState.Config.number().required(),
      rowIndex: _metalState.Config.number().required(),
      type: _metalState.Config.string().required()
    }).value({}),

    /**
     * @default undefined
     * @instance
     * @memberof LayoutProvider
     * @type {?(array|undefined)}
     */
    rules: _metalState.Config.arrayOf(_config.ruleStructure).valueFn('_rulesValueFn'),

    /**
     * @default undefined
     * @instance
     * @memberof LayoutProvider
     * @type {?(object|undefined)}
     */
    successPageSettings: _metalState.Config.object().valueFn('_successPageSettingsValueFn')
  };
  var _default = LayoutProvider;
  exports["default"] = _default;
  //# sourceMappingURL=LayoutProvider.es.js.map
});
//# sourceMappingURL=LayoutProvider.es.js.map