Liferay.Loader.define("dynamic-data-mapping-form-builder@2.0.87/js/components/LayoutProvider/handlers/fieldMovedHandler.es", ['module', 'exports', 'require', 'dynamic-data-mapping-form-renderer/js/components/FormRenderer/FormSupport.es', './fieldAddedHandler.es', './fieldDeletedHandler.es', './sectionAddedHandler.es'], function (module, exports, require) {
  var define = undefined;
  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  var FormSupport = _interopRequireWildcard(require("dynamic-data-mapping-form-renderer/js/components/FormRenderer/FormSupport.es"));

  var _fieldAddedHandler = require("./fieldAddedHandler.es");

  var _fieldDeletedHandler = _interopRequireDefault(require("./fieldDeletedHandler.es"));

  var _sectionAddedHandler = _interopRequireDefault(require("./sectionAddedHandler.es"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _getRequireWildcardCache() {
    if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
      return cache;
    };return cache;
  }

  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
      return { "default": obj };
    }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
      return cache.get(obj);
    }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
          Object.defineProperty(newObj, key, desc);
        } else {
          newObj[key] = obj[key];
        }
      }
    }newObj["default"] = obj;if (cache) {
      cache.set(obj, newObj);
    }return newObj;
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });keys.push.apply(keys, symbols);
    }return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  var _default = function _default(props, state, event) {
    var sourceFieldName = event.sourceFieldName,
        targetFieldName = event.targetFieldName,
        targetIndexes = event.targetIndexes,
        targetParentFieldName = event.targetParentFieldName;
    var deletedState = (0, _fieldDeletedHandler["default"])(props, state, {
      fieldName: sourceFieldName
    });
    var sourceField = FormSupport.findFieldByName(state.pages, sourceFieldName);

    if (targetFieldName) {
      return _objectSpread({}, (0, _sectionAddedHandler["default"])(props, _objectSpread({}, state, {
        pages: deletedState.pages
      }), {
        data: {
          fieldName: targetFieldName,
          parentFieldName: targetParentFieldName
        },
        indexes: targetIndexes,
        newField: sourceField
      }));
    }

    return _objectSpread({}, (0, _fieldAddedHandler.addField)(props, {
      indexes: targetIndexes,
      newField: sourceField,
      pages: deletedState.pages,
      parentFieldName: targetParentFieldName
    }));
  };

  exports["default"] = _default;
  //# sourceMappingURL=fieldMovedHandler.es.js.map
});
//# sourceMappingURL=fieldMovedHandler.es.js.map