Liferay.Loader.define("dynamic-data-mapping-form-builder@2.0.87/js/components/LayoutProvider/handlers/focusedFieldEvaluationEndedHandler.es", ['module', 'exports', 'require', 'dynamic-data-mapping-form-renderer/js/util/visitors.es', './fieldEditedHandler.es'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  var _visitors = require("dynamic-data-mapping-form-renderer/js/util/visitors.es");

  var _fieldEditedHandler = _interopRequireDefault(require("./fieldEditedHandler.es"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });keys.push.apply(keys, symbols);
    }return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  var handleFocusedFieldEvaluationEnded = function handleFocusedFieldEvaluationEnded(props, state, settingsContext) {
    var visitor = new _visitors.PagesVisitor(settingsContext.pages);
    var _state = state,
        focusedField = _state.focusedField;
    state = _objectSpread({}, state, {
      focusedField: _objectSpread({}, focusedField, {
        settingsContext: settingsContext
      })
    });
    visitor.mapFields(function (_ref) {
      var fieldName = _ref.fieldName,
          value = _ref.value;
      state = (0, _fieldEditedHandler["default"])(_objectSpread({}, props, {
        shouldAutoGenerateName: function shouldAutoGenerateName() {
          return false;
        }
      }), state, {
        propertyName: fieldName,
        propertyValue: value
      });
    });
    return state;
  };

  var _default = handleFocusedFieldEvaluationEnded;
  exports["default"] = _default;
  //# sourceMappingURL=focusedFieldEvaluationEndedHandler.es.js.map
});
//# sourceMappingURL=focusedFieldEvaluationEndedHandler.es.js.map