Liferay.Loader.define("dynamic-data-mapping-form-renderer@4.0.70/js/containers/Pagination/Pagination.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.DDMFormPagination = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from Pagination.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace DDM.Form.Pagination.
     * @hassoydeltemplate {DDM.Form.Pagination.item.idom}
     * @hassoydelcall {DDM.Form.Pagination.item.idom}
     * @public
     */

    goog.module('DDM.Form.Pagination.incrementaldom');

    goog.require('goog.string');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');
    /**
     * @param {{
     *  activePage: number,
     *  pages: (?),
     *  _handleItemClicked: (*|null|undefined),
     *  _handleNextClicked: (*|null|undefined),
     *  _handlePreviousClicked: (*|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      var $$temp;
      /** @type {number} */

      var activePage = soy.asserts.assertType(goog.isNumber(opt_data.activePage), 'activePage', opt_data.activePage, 'number');
      /** @type {?} */

      var pages = opt_data.pages;
      /** @type {*|null|undefined} */

      var _handleItemClicked = opt_data._handleItemClicked;
      /** @type {*|null|undefined} */

      var _handleNextClicked = opt_data._handleNextClicked;
      /** @type {*|null|undefined} */

      var _handlePreviousClicked = opt_data._handlePreviousClicked;
      incrementalDom.elementOpenStart('ul');
      incrementalDom.attr('class', 'ddm-pagination justify-content-center pagination');
      incrementalDom.elementOpenEnd();

      if (activePage > 0) {
        var classes__soy1173 = '';
        classes__soy1173 += 'page-item';
        classes__soy1173 += activePage == 0 ? ' visibility-hidden' : '';
        incrementalDom.elementOpenStart('li', 'previous');
        incrementalDom.attr('class', classes__soy1173);
        incrementalDom.attr('data-onclick', _handlePreviousClicked);
        incrementalDom.attr('key', 'previous');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('a');
        incrementalDom.attr('class', 'page-link');
        incrementalDom.attr('href', 'javascript:;');
        incrementalDom.attr('role', 'button');
        incrementalDom.elementOpenEnd();
        incrementalDom.text("\xAB");
        incrementalDom.elementOpenStart('span');
        incrementalDom.attr('class', 'sr-only');
        incrementalDom.elementOpenEnd();
        /** @desc  */

        var MSG_EXTERNAL_6095534740119293938 = Liferay.Language.get('previous');
        incrementalDom.text(goog.string.unescapeEntities(MSG_EXTERNAL_6095534740119293938));
        incrementalDom.elementClose('span');
        incrementalDom.elementClose('a');
        incrementalDom.elementClose('li');
      }

      var page1199List = pages;
      var page1199ListLen = page1199List.length;

      for (var page1199Index = 0; page1199Index < page1199ListLen; page1199Index++) {
        var page1199Data = page1199List[page1199Index];
        var itemRenderer__soy1190 = ($$temp = page1199Data.paginationItemRenderer) == null ? 'pagination' : $$temp;
        soy.$$getDelegateFn(soy.$$getDelTemplateId('DDM.Form.Pagination.item.idom'), itemRenderer__soy1190, false)({
          _handleItemClicked: _handleItemClicked,
          activePage: activePage,
          page: page1199Data,
          pageIndex: page1199Index,
          total: pages.length
        }, null, opt_ijData);
      }

      if (activePage < pages.length - 1) {
        var classes__soy1205 = '';
        classes__soy1205 += 'page-item';
        classes__soy1205 += activePage == pages.length - 1 || activePage == -1 ? ' visibility-hidden' : '';
        incrementalDom.elementOpenStart('li', 'next');
        incrementalDom.attr('class', classes__soy1205);
        incrementalDom.attr('data-onclick', _handleNextClicked);
        incrementalDom.attr('key', 'next');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('a');
        incrementalDom.attr('class', 'page-link');
        incrementalDom.attr('href', 'javascript:;');
        incrementalDom.attr('role', 'button');
        incrementalDom.elementOpenEnd();
        incrementalDom.text("\xBB");
        incrementalDom.elementOpenStart('span');
        incrementalDom.attr('class', 'sr-only');
        incrementalDom.elementOpenEnd();
        /** @desc  */

        var MSG_EXTERNAL_5736512712252459867 = Liferay.Language.get('next');
        incrementalDom.text(goog.string.unescapeEntities(MSG_EXTERNAL_5736512712252459867));
        incrementalDom.elementClose('span');
        incrementalDom.elementClose('a');
        incrementalDom.elementClose('li');
      }

      incrementalDom.elementClose('ul');
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  activePage: number,
     *  pages: (?),
     *  _handleItemClicked: (*|null|undefined),
     *  _handleNextClicked: (*|null|undefined),
     *  _handlePreviousClicked: (*|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'DDM.Form.Pagination.render';
    }
    /**
     * @param {{
     *  activePage: number,
     *  page: (?),
     *  pageIndex: number,
     *  total: number,
     *  _handleItemClicked: (*|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function __deltemplate_s1221_9622d459(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {number} */

      var activePage = soy.asserts.assertType(goog.isNumber(opt_data.activePage), 'activePage', opt_data.activePage, 'number');
      /** @type {?} */

      var page = opt_data.page;
      /** @type {number} */

      var pageIndex = soy.asserts.assertType(goog.isNumber(opt_data.pageIndex), 'pageIndex', opt_data.pageIndex, 'number');
      /** @type {number} */

      soy.asserts.assertType(goog.isNumber(opt_data.total), 'total', opt_data.total, 'number');

      /** @type {*|null|undefined} */

      var _handleItemClicked = opt_data._handleItemClicked;
      var step__soy1228 = pageIndex + 1;
      var classes__soy1230 = '';
      classes__soy1230 += 'page-item';
      classes__soy1230 += pageIndex == activePage ? ' active' : '';
      classes__soy1230 += !page.enabled ? ' disabled' : '';

      var itemAttributes__soy1241 = function itemAttributes__soy1241() {
        incrementalDom.attr('class', classes__soy1230);

        if (page.enabled) {
          incrementalDom.attr('data-onclick', _handleItemClicked);
        }

        incrementalDom.attr('data-page-index', pageIndex);
        incrementalDom.attr('key', 'page' + step__soy1228);
      };

      incrementalDom.elementOpenStart('li');
      itemAttributes__soy1241();
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpenStart('a');
      incrementalDom.attr('class', 'page-link');
      incrementalDom.attr('href', 'javascript:;');
      incrementalDom.elementOpenEnd();
      soyIdom.print(step__soy1228);
      incrementalDom.elementClose('a');
      incrementalDom.elementClose('li');
    }

    exports.__deltemplate_s1221_9622d459 = __deltemplate_s1221_9622d459;
    /**
     * @typedef {{
     *  activePage: number,
     *  page: (?),
     *  pageIndex: number,
     *  total: number,
     *  _handleItemClicked: (*|null|undefined)
     * }}
     */

    __deltemplate_s1221_9622d459.Params;

    if (goog.DEBUG) {
      __deltemplate_s1221_9622d459.soyTemplateName = 'DDM.Form.Pagination.__deltemplate_s1221_9622d459';
    }

    soy.$$registerDelegateFn(soy.$$getDelTemplateId('DDM.Form.Pagination.item.idom'), 'pagination', 0, __deltemplate_s1221_9622d459);
    exports.render.params = ["activePage", "pages", "_handleItemClicked", "_handleNextClicked", "_handlePreviousClicked"];
    exports.render.types = {
      "activePage": "number",
      "pages": "?",
      "_handleItemClicked": "any",
      "_handleNextClicked": "any",
      "_handlePreviousClicked": "any"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var DDMFormPagination = /*#__PURE__*/function (_Component) {
    _inherits(DDMFormPagination, _Component);

    function DDMFormPagination() {
      _classCallCheck(this, DDMFormPagination);

      return _possibleConstructorReturn(this, _getPrototypeOf(DDMFormPagination).apply(this, arguments));
    }

    return DDMFormPagination;
  }(_metalComponent["default"]);

  exports.DDMFormPagination = DDMFormPagination;

  _metalSoy["default"].register(DDMFormPagination, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=Pagination.soy.js.map
});
//# sourceMappingURL=Pagination.soy.js.map