Liferay.Loader.define("dynamic-data-mapping-form-renderer@4.0.70/js/containers/Tabs/Tabs.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.DDMFormTabs = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from Tabs.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace DDM.Form.Tabs.
     * @hassoydeltemplate {DDM.Form.Tabs.item.idom}
     * @hassoydelcall {DDM.Form.Tabs.item.idom}
     * @public
     */

    goog.module('DDM.Form.Tabs.incrementaldom');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');
    /**
     * @param {{
     *  activePage: number,
     *  pages: (?),
     *  _handleItemClicked: (*|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      var $$temp;
      /** @type {number} */

      var activePage = soy.asserts.assertType(goog.isNumber(opt_data.activePage), 'activePage', opt_data.activePage, 'number');
      /** @type {?} */

      var pages = opt_data.pages;
      /** @type {*|null|undefined} */

      var _handleItemClicked = opt_data._handleItemClicked;
      incrementalDom.elementOpenStart('nav');
      incrementalDom.attr('class', 'component-tbar ddm-form-tabs mb-3 tbar');
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('className', 'container-fluid');
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpenStart('ul');
      incrementalDom.attr('class', 'nav nav-underline');
      incrementalDom.attr('role', 'tablist');
      incrementalDom.elementOpenEnd();
      var page1578List = pages;
      var page1578ListLen = page1578List.length;

      for (var page1578Index = 0; page1578Index < page1578ListLen; page1578Index++) {
        var page1578Data = page1578List[page1578Index];
        var itemRenderer__soy1569 = ($$temp = page1578Data.tabbedItemRenderer) == null ? 'tabbed' : $$temp;
        soy.$$getDelegateFn(soy.$$getDelTemplateId('DDM.Form.Tabs.item.idom'), itemRenderer__soy1569, false)({
          _handleItemClicked: _handleItemClicked,
          activePage: activePage,
          page: page1578Data,
          pageIndex: page1578Index,
          total: pages.length
        }, null, opt_ijData);
      }

      incrementalDom.elementClose('ul');
      incrementalDom.elementClose('div');
      incrementalDom.elementClose('nav');
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  activePage: number,
     *  pages: (?),
     *  _handleItemClicked: (*|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'DDM.Form.Tabs.render';
    }
    /**
     * @param {{
     *  activePage: number,
     *  page: (?),
     *  pageIndex: number,
     *  total: number,
     *  _handleItemClicked: (*|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function __deltemplate_s1581_2f47a09f(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {number} */

      var activePage = soy.asserts.assertType(goog.isNumber(opt_data.activePage), 'activePage', opt_data.activePage, 'number');
      /** @type {?} */

      var page = opt_data.page;
      /** @type {number} */

      var pageIndex = soy.asserts.assertType(goog.isNumber(opt_data.pageIndex), 'pageIndex', opt_data.pageIndex, 'number');
      /** @type {number} */

      soy.asserts.assertType(goog.isNumber(opt_data.total), 'total', opt_data.total, 'number');

      /** @type {*|null|undefined} */

      var _handleItemClicked = opt_data._handleItemClicked;


      incrementalDom.elementOpenStart('li');
      (function itemAttributes__soy1590() {
        incrementalDom.attr('class', 'nav-item');

        if (page.enabled) {
          incrementalDom.attr('data-onclick', _handleItemClicked);
        }

        incrementalDom.attr('data-page-index', pageIndex);
        incrementalDom.attr('key', 'page' + (pageIndex + 1));
      })();
      incrementalDom.attr('class', 'nav-item');
      incrementalDom.attr('data-index', '0');
      incrementalDom.attr('ref', 'tab0');
      incrementalDom.elementOpenEnd();
      var classes__soy1605 = '';
      classes__soy1605 += 'nav-link';
      classes__soy1605 += pageIndex == activePage ? ' active' : '';
      classes__soy1605 += !page.enabled ? ' disabled' : '';
      incrementalDom.elementOpenStart('a');
      incrementalDom.attr('class', classes__soy1605);
      incrementalDom.attr('href', 'javascript:;');
      incrementalDom.attr('role', 'tab');
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpenStart('span');
      incrementalDom.attr('class', 'navbar-text-truncate');
      incrementalDom.elementOpenEnd();
      soyIdom.print(page.title);
      incrementalDom.elementClose('span');
      incrementalDom.elementClose('a');
      incrementalDom.elementClose('li');
    }

    exports.__deltemplate_s1581_2f47a09f = __deltemplate_s1581_2f47a09f;
    /**
     * @typedef {{
     *  activePage: number,
     *  page: (?),
     *  pageIndex: number,
     *  total: number,
     *  _handleItemClicked: (*|null|undefined)
     * }}
     */

    __deltemplate_s1581_2f47a09f.Params;

    if (goog.DEBUG) {
      __deltemplate_s1581_2f47a09f.soyTemplateName = 'DDM.Form.Tabs.__deltemplate_s1581_2f47a09f';
    }

    soy.$$registerDelegateFn(soy.$$getDelTemplateId('DDM.Form.Tabs.item.idom'), 'tabbed', 0, __deltemplate_s1581_2f47a09f);
    exports.render.params = ["activePage", "pages", "_handleItemClicked"];
    exports.render.types = {
      "activePage": "number",
      "pages": "?",
      "_handleItemClicked": "any"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var DDMFormTabs = /*#__PURE__*/function (_Component) {
    _inherits(DDMFormTabs, _Component);

    function DDMFormTabs() {
      _classCallCheck(this, DDMFormTabs);

      return _possibleConstructorReturn(this, _getPrototypeOf(DDMFormTabs).apply(this, arguments));
    }

    return DDMFormTabs;
  }(_metalComponent["default"]);

  exports.DDMFormTabs = DDMFormTabs;

  _metalSoy["default"].register(DDMFormTabs, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=Tabs.soy.js.map
});
//# sourceMappingURL=Tabs.soy.js.map