Liferay.Loader.define("dynamic-data-mapping-form-renderer@4.0.70/js/store/actions/handleFormSubmitted.es", ['module', 'exports', 'require', '../../util/evaluation.es', '../../util/visitors.es'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  var _evaluation = require("../../util/evaluation.es");

  var _visitors = require("../../util/visitors.es");

  /**
   * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
   *
   * This library is free software; you can redistribute it and/or modify it under
   * the terms of the GNU Lesser General Public License as published by the Free
   * Software Foundation; either version 2.1 of the License, or (at your option)
   * any later version.
   *
   * This library is distributed in the hope that it will be useful, but WITHOUT
   * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
   * details.
   */
  var _default = function _default(evaluatorContext) {
    return (0, _evaluation.evaluate)(null, evaluatorContext).then(function (evaluatedPages) {
      var validForm = true;
      var visitor = new _visitors.PagesVisitor(evaluatedPages);
      visitor.mapFields(function (_ref) {
        var valid = _ref.valid;

        if (!valid) {
          validForm = false;
        }
      });
      return Promise.resolve(validForm);
    });
  };

  exports["default"] = _default;
  //# sourceMappingURL=handleFormSubmitted.es.js.map
});
//# sourceMappingURL=handleFormSubmitted.es.js.map