<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/init.jsp" %>

<%
ExportImportToolbarDisplayContext exportImportToolbarDisplayContext = new ExportImportToolbarDisplayContext(request, liferayPortletResponse);
%>

<clay:management-toolbar
	actionDropdownItems="<%= exportImportToolbarDisplayContext.getActionDropdownItems() %>"
	creationMenu="<%= exportImportToolbarDisplayContext.getCreationMenu() %>"
	filterDropdownItems="<%= exportImportToolbarDisplayContext.getFilterDropdownItems() %>"
	searchContainerId="<%= exportImportToolbarDisplayContext.getSearchContainerId() %>"
	showCreationMenu="<%= !StagingUtil.isChangeTrackingEnabled(company.getCompanyId()) %>"
	showSearch="<%= false %>"
	sortingOrder="<%= exportImportToolbarDisplayContext.getSortingOrder() %>"
	sortingURL="<%= exportImportToolbarDisplayContext.getSortingURL() %>"
	viewTypeItems="<%= exportImportToolbarDisplayContext.getViewTypeItems() %>"
/>