Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Captcha/Captcha.es", ['module', 'exports', 'require', '../FieldBase/FieldBase.es', './CaptchaRegister.soy', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', './Captcha.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("../FieldBase/FieldBase.es");

  require("./CaptchaRegister.soy");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _Captcha = _interopRequireDefault(require("./Captcha.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  /**
   * Captcha.
   * @extends Component
   */
  var Captcha = /*#__PURE__*/function (_Component) {
    _inherits(Captcha, _Component);

    function Captcha() {
      _classCallCheck(this, Captcha);

      return _possibleConstructorReturn(this, _getPrototypeOf(Captcha).apply(this, arguments));
    }

    _createClass(Captcha, [{
      key: "rendered",
      value: function rendered() {
        var _this = this;

        if (window.grecaptcha) {
          window.grecaptcha.ready(function () {
            try {
              window.grecaptcha.reset(_this._getRecaptchaIndex());
            } catch (e) {
              console.warn('Could not reset reCAPTCHA.');
            }
          });
        }

        var namespace = this.name.substring(0, this.name.indexOf('ddm$$'));
        var refreshCaptcha = document.getElementById(namespace + 'refreshCaptcha');

        if (refreshCaptcha) {
          var captcha = document.getElementById(namespace + 'captcha');

          if (captcha && captcha.src) {
            var url = captcha.src;
            refreshCaptcha.addEventListener('click', function () {
              var TIMESTAMP_REGEX = /(t=).*?($)/;

              url = url.replace(TIMESTAMP_REGEX, '$1' + Date.now());
              captcha.setAttribute('src', url);
            });
          }
        }
      }
    }, {
      key: "shouldUpdate",
      value: function shouldUpdate() {
        return false;
      }
    }, {
      key: "_getRecaptchaIndex",
      value: function _getRecaptchaIndex() {
        var recaptchaElements = document.getElementsByClassName('g-recaptcha');

        for (var index = 0; index < recaptchaElements.length; index++) {
          var parentElement = recaptchaElements[index].parentElement;

          if (parentElement && parentElement.getAttribute('data-field-name') === this.name) {
            return index;
          }
        }

        return 0;
      }
    }]);

    return Captcha;
  }(_metalComponent["default"]);

  _metalSoy["default"].register(Captcha, _Captcha["default"]);

  Captcha.STATE = {
    /**
     * @default false
     * @memberof FieldBase
     * @type {?bool}
     */
    evaluable: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @memberof Captcha
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default 'captcha'
     * @memberof Text
     * @type {?(string|undefined)}
     */
    type: _metalState.Config.string().value('captcha')
  };
  var _default = Captcha;
  exports["default"] = _default;
  //# sourceMappingURL=Captcha.es.js.map
});
//# sourceMappingURL=Captcha.es.js.map