Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Checkbox/Checkbox.es", ['module', 'exports', 'require', '../FieldBase/FieldBase.es', './CheckboxRegister.soy', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', './Checkbox.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("../FieldBase/FieldBase.es");

  require("./CheckboxRegister.soy");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _Checkbox = _interopRequireDefault(require("./Checkbox.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  /**
   * Checkbox.
   * @extends Component
   */
  var Checkbox = /*#__PURE__*/function (_Component) {
    _inherits(Checkbox, _Component);

    function Checkbox() {
      _classCallCheck(this, Checkbox);

      return _possibleConstructorReturn(this, _getPrototypeOf(Checkbox).apply(this, arguments));
    }

    _createClass(Checkbox, [{
      key: "handleInputChangeEvent",
      value: function handleInputChangeEvent(event) {
        var value = event.delegateTarget.checked;
        this.setState({
          value: value
        });
        this.emit('fieldEdited', {
          fieldInstance: this,
          originalEvent: event,
          value: value
        });
      }
    }]);

    return Checkbox;
  }(_metalComponent["default"]);

  _metalSoy["default"].register(Checkbox, _Checkbox["default"]);

  Checkbox.STATE = {
    /**
     * @default 'string'
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    dataType: _metalState.Config.string().value('boolean'),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?bool}
     */
    evaluable: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(string|undefined)}
     */
    fieldName: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Checkbox
     * @type {?(string|undefined)}
     */
    label: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Select
     * @type {?string}
     */
    predefinedValue: _metalState.Config.bool().value(true),

    /**
     * @default false
     * @instance
     * @memberof Checkbox
     * @type {?bool}
     */
    readOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(bool|undefined)}
     */
    repeatable: _metalState.Config.bool(),

    /**
     * @default false
     * @instance
     * @memberof Checkbox
     * @type {?bool}
     */
    required: _metalState.Config.bool().value(false),

    /**
     * @default true
     * @instance
     * @memberof Checkbox
     * @type {?bool}
     */
    showAsSwitcher: _metalState.Config.bool().value(true),

    /**
     * @default true
     * @instance
     * @memberof Checkbox
     * @type {?bool}
     */
    showLabel: _metalState.Config.bool().value(true),

    /**
     * @default undefined
     * @instance
     * @memberof Checkbox
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(string|undefined)}
     */
    tip: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    type: _metalState.Config.string().value('checkbox'),

    /**
     * @default undefined
     * @instance
     * @memberof Checkbox
     * @type {?(bool)}
     */
    value: _metalState.Config.bool()
  };
  var _default = Checkbox;
  exports["default"] = _default;
  //# sourceMappingURL=Checkbox.es.js.map
});
//# sourceMappingURL=Checkbox.es.js.map