Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/DatePicker/DatePicker.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.DatePicker = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from DatePicker.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace DatePicker.
     * @public
     */

    goog.module('DatePicker.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');

    var $templateAlias2 = _metalSoy["default"].getTemplate('ClayButton.incrementaldom', 'render');

    var $templateAlias1 = _metalSoy["default"].getTemplate('FieldBase.incrementaldom', 'render');
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  years: !Array<?>,
     *  _daySelected: (*|null|undefined),
     *  _handleDayClicked: (*|null|undefined),
     *  _handleDayKeyDown: (*|null|undefined),
     *  _handleDayFocus: (*|null|undefined),
     *  _handleDotClicked: (*|null|undefined),
     *  _handleInput: (*|null|undefined),
     *  _handleInputBlurred: (*|null|undefined),
     *  _handleInputFocused: (*|null|undefined),
     *  _handleNavigateChange: (*|null|undefined),
     *  _handleNextMonth: (*|null|undefined),
     *  _handlePreviousMonth: (*|null|undefined),
     *  _handleToggle: (*|null|undefined),
     *  _month: (null|number|undefined),
     *  _weeks: (!Array<?>|null|undefined),
     *  _year: (null|number|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  displayStyle: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  elementClasses: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  expanded: (boolean|null|undefined),
     *  firstDayOfWeek: (null|number|undefined),
     *  formattedValue: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  months: (!Array<?>|null|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  predefinedValue: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tooltip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  value: (?),
     *  visible: (boolean|null|undefined),
     *  weekdaysShort: (!Array<!goog.soy.data.SanitizedContent|string>|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var spritemap = soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      /** @type {!Array<?>} */

      soy.asserts.assertType(goog.isArray(opt_data.years), 'years', opt_data.years, '!Array<?>');
      opt_data._daySelected;
      opt_data._handleDayClicked;
      opt_data._handleDayKeyDown;
      opt_data._handleDayFocus;
      opt_data._handleDotClicked;
      opt_data._handleInput;
      opt_data._handleInputBlurred;
      opt_data._handleInputFocused;
      opt_data._handleNavigateChange;
      opt_data._handleNextMonth;
      opt_data._handlePreviousMonth;
      opt_data._handleToggle;
      soy.asserts.assertType(opt_data._month == null || goog.isNumber(opt_data._month), '_month', opt_data._month, 'null|number|undefined');
      soy.asserts.assertType(opt_data._weeks == null || goog.isArray(opt_data._weeks), '_weeks', opt_data._weeks, '!Array<?>|null|undefined');
      soy.asserts.assertType(opt_data._year == null || goog.isNumber(opt_data._year), '_year', opt_data._year, 'null|number|undefined');

      /** @type {boolean|null|undefined} */

      var displayErrors = soy.asserts.assertType(opt_data.displayErrors == null || goog.isBoolean(opt_data.displayErrors) || opt_data.displayErrors === 1 || opt_data.displayErrors === 0, 'displayErrors', opt_data.displayErrors, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      soy.asserts.assertType(opt_data.displayStyle == null || goog.isString(opt_data.displayStyle) || opt_data.displayStyle instanceof goog.soy.data.SanitizedContent, 'displayStyle', opt_data.displayStyle, '!goog.soy.data.SanitizedContent|null|string|undefined');
      soy.asserts.assertType(opt_data.elementClasses == null || goog.isString(opt_data.elementClasses) || opt_data.elementClasses instanceof goog.soy.data.SanitizedContent, 'elementClasses', opt_data.elementClasses, '!goog.soy.data.SanitizedContent|null|string|undefined');

      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var errorMessage = soy.asserts.assertType(opt_data.errorMessage == null || goog.isString(opt_data.errorMessage) || opt_data.errorMessage instanceof goog.soy.data.SanitizedContent, 'errorMessage', opt_data.errorMessage, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      soy.asserts.assertType(opt_data.expanded == null || goog.isBoolean(opt_data.expanded) || opt_data.expanded === 1 || opt_data.expanded === 0, 'expanded', opt_data.expanded, 'boolean|null|undefined');
      soy.asserts.assertType(opt_data.firstDayOfWeek == null || goog.isNumber(opt_data.firstDayOfWeek), 'firstDayOfWeek', opt_data.firstDayOfWeek, 'null|number|undefined');
      soy.asserts.assertType(opt_data.formattedValue == null || goog.isString(opt_data.formattedValue) || opt_data.formattedValue instanceof goog.soy.data.SanitizedContent, 'formattedValue', opt_data.formattedValue, '!goog.soy.data.SanitizedContent|null|string|undefined');

      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var id = soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var label = soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!Array<?>|null|undefined} */

      soy.asserts.assertType(opt_data.months == null || goog.isArray(opt_data.months), 'months', opt_data.months, '!Array<?>|null|undefined');
      soy.asserts.assertType(opt_data.placeholder == null || goog.isString(opt_data.placeholder) || opt_data.placeholder instanceof goog.soy.data.SanitizedContent, 'placeholder', opt_data.placeholder, '!goog.soy.data.SanitizedContent|null|string|undefined');
      soy.asserts.assertType(opt_data.predefinedValue == null || goog.isString(opt_data.predefinedValue) || opt_data.predefinedValue instanceof goog.soy.data.SanitizedContent, 'predefinedValue', opt_data.predefinedValue, '!goog.soy.data.SanitizedContent|null|string|undefined');

      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var repeatable = soy.asserts.assertType(opt_data.repeatable == null || goog.isBoolean(opt_data.repeatable) || opt_data.repeatable === 1 || opt_data.repeatable === 0, 'repeatable', opt_data.repeatable, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var required = soy.asserts.assertType(opt_data.required == null || goog.isBoolean(opt_data.required) || opt_data.required === 1 || opt_data.required === 0, 'required', opt_data.required, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showLabel = soy.asserts.assertType(opt_data.showLabel == null || goog.isBoolean(opt_data.showLabel) || opt_data.showLabel === 1 || opt_data.showLabel === 0, 'showLabel', opt_data.showLabel, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tip = soy.asserts.assertType(opt_data.tip == null || goog.isString(opt_data.tip) || opt_data.tip instanceof goog.soy.data.SanitizedContent, 'tip', opt_data.tip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tooltip = soy.asserts.assertType(opt_data.tooltip == null || goog.isString(opt_data.tooltip) || opt_data.tooltip instanceof goog.soy.data.SanitizedContent, 'tooltip', opt_data.tooltip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var valid = soy.asserts.assertType(opt_data.valid == null || goog.isBoolean(opt_data.valid) || opt_data.valid === 1 || opt_data.valid === 0, 'valid', opt_data.valid, 'boolean|null|undefined');
      /** @type {?} */

      opt_data.value;

      /** @type {boolean|null|undefined} */

      var visible = soy.asserts.assertType(opt_data.visible == null || goog.isBoolean(opt_data.visible) || opt_data.visible === 1 || opt_data.visible === 0, 'visible', opt_data.visible, 'boolean|null|undefined');
      /** @type {!Array<!goog.soy.data.SanitizedContent|string>|null|undefined} */

      soy.asserts.assertType(opt_data.weekdaysShort == null || goog.isArray(opt_data.weekdaysShort), 'weekdaysShort', opt_data.weekdaysShort, '!Array<!goog.soy.data.SanitizedContent|string>|null|undefined');


      var param745 = function param745() {
        $content(opt_data, null, opt_ijData);
      };

      $templateAlias1({
        contentRenderer: param745,
        displayErrors: displayErrors,
        errorMessage: errorMessage,
        id: id,
        label: label,
        name: name,
        readOnly: readOnly,
        ref: 'base',
        repeatable: repeatable,
        required: required,
        showLabel: showLabel,
        spritemap: spritemap,
        tip: tip,
        tooltip: tooltip,
        valid: valid,
        visible: visible
      }, null, opt_ijData);
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  years: !Array<?>,
     *  _daySelected: (*|null|undefined),
     *  _handleDayClicked: (*|null|undefined),
     *  _handleDayKeyDown: (*|null|undefined),
     *  _handleDayFocus: (*|null|undefined),
     *  _handleDotClicked: (*|null|undefined),
     *  _handleInput: (*|null|undefined),
     *  _handleInputBlurred: (*|null|undefined),
     *  _handleInputFocused: (*|null|undefined),
     *  _handleNavigateChange: (*|null|undefined),
     *  _handleNextMonth: (*|null|undefined),
     *  _handlePreviousMonth: (*|null|undefined),
     *  _handleToggle: (*|null|undefined),
     *  _month: (null|number|undefined),
     *  _weeks: (!Array<?>|null|undefined),
     *  _year: (null|number|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  displayStyle: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  elementClasses: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  expanded: (boolean|null|undefined),
     *  firstDayOfWeek: (null|number|undefined),
     *  formattedValue: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  months: (!Array<?>|null|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  predefinedValue: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tooltip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  value: (?),
     *  visible: (boolean|null|undefined),
     *  weekdaysShort: (!Array<!goog.soy.data.SanitizedContent|string>|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'DatePicker.render';
    }
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  years: !Array<?>,
     *  _daySelected: (*|null|undefined),
     *  _handleDayClicked: (*|null|undefined),
     *  _handleDayKeyDown: (*|null|undefined),
     *  _handleDayFocus: (*|null|undefined),
     *  _handleDotClicked: (*|null|undefined),
     *  _handleInput: (*|null|undefined),
     *  _handleInputBlurred: (*|null|undefined),
     *  _handleInputFocused: (*|null|undefined),
     *  _handleNavigateChange: (*|null|undefined),
     *  _handleNextMonth: (*|null|undefined),
     *  _handlePreviousMonth: (*|null|undefined),
     *  _handleToggle: (*|null|undefined),
     *  _month: (null|number|undefined),
     *  _weeks: (!Array<?>|null|undefined),
     *  _year: (null|number|undefined),
     *  elementClasses: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  expanded: (boolean|null|undefined),
     *  firstDayOfWeek: (null|number|undefined),
     *  formattedValue: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  months: (!Array<?>|null|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  predefinedValue: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  value: (?),
     *  weekdaysShort: (!Array<!goog.soy.data.SanitizedContent|string>|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $content(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      var $$temp;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var spritemap = soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      /** @type {!Array<?>} */

      soy.asserts.assertType(goog.isArray(opt_data.years), 'years', opt_data.years, '!Array<?>');
      opt_data._daySelected;
      opt_data._handleDayClicked;
      opt_data._handleDayKeyDown;
      opt_data._handleDayFocus;
      opt_data._handleDotClicked;

      /** @type {*|null|undefined} */

      var _handleInput = opt_data._handleInput;
      /** @type {*|null|undefined} */

      var _handleInputBlurred = opt_data._handleInputBlurred;
      /** @type {*|null|undefined} */

      var _handleInputFocused = opt_data._handleInputFocused;
      /** @type {*|null|undefined} */

      opt_data._handleNavigateChange;
      opt_data._handleNextMonth;
      opt_data._handlePreviousMonth;

      /** @type {*|null|undefined} */

      var _handleToggle = opt_data._handleToggle;
      /** @type {null|number|undefined} */

      var _month = soy.asserts.assertType(opt_data._month == null || goog.isNumber(opt_data._month), '_month', opt_data._month, 'null|number|undefined');
      /** @type {!Array<?>|null|undefined} */

      var _weeks = soy.asserts.assertType(opt_data._weeks == null || goog.isArray(opt_data._weeks), '_weeks', opt_data._weeks, '!Array<?>|null|undefined');
      /** @type {null|number|undefined} */

      var _year = soy.asserts.assertType(opt_data._year == null || goog.isNumber(opt_data._year), '_year', opt_data._year, 'null|number|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var elementClasses = soy.asserts.assertType(opt_data.elementClasses == null || goog.isString(opt_data.elementClasses) || opt_data.elementClasses instanceof goog.soy.data.SanitizedContent, 'elementClasses', opt_data.elementClasses, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var expanded = soy.asserts.assertType(opt_data.expanded == null || goog.isBoolean(opt_data.expanded) || opt_data.expanded === 1 || opt_data.expanded === 0, 'expanded', opt_data.expanded, 'boolean|null|undefined');
      /** @type {null|number|undefined} */

      var firstDayOfWeek = soy.asserts.assertType(opt_data.firstDayOfWeek == null || goog.isNumber(opt_data.firstDayOfWeek), 'firstDayOfWeek', opt_data.firstDayOfWeek, 'null|number|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var formattedValue = soy.asserts.assertType(opt_data.formattedValue == null || goog.isString(opt_data.formattedValue) || opt_data.formattedValue instanceof goog.soy.data.SanitizedContent, 'formattedValue', opt_data.formattedValue, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var id = soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!Array<?>|null|undefined} */

      var months = soy.asserts.assertType(opt_data.months == null || goog.isArray(opt_data.months), 'months', opt_data.months, '!Array<?>|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var placeholder = soy.asserts.assertType(opt_data.placeholder == null || goog.isString(opt_data.placeholder) || opt_data.placeholder instanceof goog.soy.data.SanitizedContent, 'placeholder', opt_data.placeholder, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var predefinedValue = soy.asserts.assertType(opt_data.predefinedValue == null || goog.isString(opt_data.predefinedValue) || opt_data.predefinedValue instanceof goog.soy.data.SanitizedContent, 'predefinedValue', opt_data.predefinedValue, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {?} */

      var value = opt_data.value;
      /** @type {!Array<!goog.soy.data.SanitizedContent|string>|null|undefined} */

      var weekdaysShort = soy.asserts.assertType(opt_data.weekdaysShort == null || goog.isArray(opt_data.weekdaysShort), 'weekdaysShort', opt_data.weekdaysShort, '!Array<!goog.soy.data.SanitizedContent|string>|null|undefined');
      var msg_21552__soy21553 = '';
      /** @desc  */

      var MSG_EXTERNAL_7530356757124001949 = Liferay.Language.get('date-field-type-description');
      msg_21552__soy21553 += MSG_EXTERNAL_7530356757124001949;

      incrementalDom.elementOpenStart('div');
      (function attributes__soy826() {
        incrementalDom.attr('class', 'input-group' + (elementClasses ? ' ' + elementClasses : ''));

        if (id) {
          incrementalDom.attr('id', id);
        }
      })();
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'input-group-item');
      incrementalDom.elementOpenEnd();

      incrementalDom.elementOpenStart('input');
      (function visibleInputAttributes__soy843() {
        incrementalDom.attr('aria-labelledby', name + '_fieldDetails');
        incrementalDom.attr('class', 'form-control input-group-inset input-group-inset-after');
        incrementalDom.attr('data-onblur', _handleInputBlurred);
        incrementalDom.attr('data-onclick', _handleInputFocused);
        incrementalDom.attr('data-oninput', _handleInput);

        if (readOnly) {
          incrementalDom.attr('disabled', 'disabled');
        }

        if (placeholder) {
          incrementalDom.attr('placeholder', placeholder);
        }

        incrementalDom.attr('ref', 'inputElement');
        incrementalDom.attr('type', 'text');

        if (formattedValue) {
          incrementalDom.attr('value', formattedValue);
        } else if (predefinedValue) {
          incrementalDom.attr('value', predefinedValue);
        } else {
          incrementalDom.attr('value', '');
        }
      })();
      incrementalDom.elementOpenEnd();
      incrementalDom.elementClose('input');

      incrementalDom.elementOpenStart('input');
      (function hiddenInputAttributes__soy878() {
        incrementalDom.attr('aria-hidden', 'true');
        incrementalDom.attr('name', name);
        incrementalDom.attr('type', 'hidden');

        if (value) {
          incrementalDom.attr('value', value);
        } else {
          incrementalDom.attr('value', '');
        }
      })();
      incrementalDom.elementOpenEnd();
      incrementalDom.elementClose('input');
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'input-group-inset-item input-group-inset-item-after');
      incrementalDom.elementOpenEnd();
      var calendar__soy893 = '';
      calendar__soy893 += msg_21552__soy21553;
      $templateAlias2({
        ariaLabel: calendar__soy893,
        disabled: readOnly,
        elementClasses: 'd-none d-md-inline-block',
        events: {
          click: _handleToggle
        },
        icon: 'calendar',
        spritemap: spritemap,
        style: 'unstyled',
        type: 'button'
      }, null, opt_ijData);
      incrementalDom.elementClose('div');
      incrementalDom.elementClose('div');
      var classes__soy910 = '';
      classes__soy910 += 'dropdown-menu';
      classes__soy910 += expanded ? ' show' : '';
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', classes__soy910);
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'datepicker');
      incrementalDom.elementOpenEnd();

      if (months && _month != null && _year != null) {
        $header(opt_data, null, opt_ijData);
      }

      var firstDay__soy934 = ($$temp = firstDayOfWeek) == null ? 0 : $$temp;

      if (weekdaysShort) {
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'weekdays');
        incrementalDom.elementOpenEnd();

        for (var index939 = 0; index939 < 7; index939++) {
          var weekday__soy941 = (index939 + firstDay__soy934) % 7;
          incrementalDom.elementOpenStart('div');
          incrementalDom.attr('class', 'week');
          incrementalDom.elementOpenEnd();
          soyIdom.print(weekdaysShort[weekday__soy941]);
          incrementalDom.elementClose('div');
        }

        incrementalDom.elementClose('div');
      }

      if (_weeks) {
        $body(opt_data, null, opt_ijData);
      }

      incrementalDom.elementClose('div');
      incrementalDom.elementClose('div');
      incrementalDom.elementClose('div');
    }

    exports.content = $content;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  years: !Array<?>,
     *  _daySelected: (*|null|undefined),
     *  _handleDayClicked: (*|null|undefined),
     *  _handleDayKeyDown: (*|null|undefined),
     *  _handleDayFocus: (*|null|undefined),
     *  _handleDotClicked: (*|null|undefined),
     *  _handleInput: (*|null|undefined),
     *  _handleInputBlurred: (*|null|undefined),
     *  _handleInputFocused: (*|null|undefined),
     *  _handleNavigateChange: (*|null|undefined),
     *  _handleNextMonth: (*|null|undefined),
     *  _handlePreviousMonth: (*|null|undefined),
     *  _handleToggle: (*|null|undefined),
     *  _month: (null|number|undefined),
     *  _weeks: (!Array<?>|null|undefined),
     *  _year: (null|number|undefined),
     *  elementClasses: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  expanded: (boolean|null|undefined),
     *  firstDayOfWeek: (null|number|undefined),
     *  formattedValue: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  months: (!Array<?>|null|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  predefinedValue: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  value: (?),
     *  weekdaysShort: (!Array<!goog.soy.data.SanitizedContent|string>|null|undefined)
     * }}
     */

    $content.Params;

    if (goog.DEBUG) {
      $content.soyTemplateName = 'DatePicker.content';
    }
    /**
     * @param {{
     *  _month: number,
     *  _year: number,
     *  months: !Array<?>,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  years: !Array<?>,
     *  _handleDotClicked: (*|null|undefined),
     *  _handleNavigateChange: (*|null|undefined),
     *  _handleNextMonth: (*|null|undefined),
     *  _handlePreviousMonth: (*|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $header(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {number} */

      var _month = soy.asserts.assertType(goog.isNumber(opt_data._month), '_month', opt_data._month, 'number');
      /** @type {number} */

      var _year = soy.asserts.assertType(goog.isNumber(opt_data._year), '_year', opt_data._year, 'number');
      /** @type {!Array<?>} */

      var months = soy.asserts.assertType(goog.isArray(opt_data.months), 'months', opt_data.months, '!Array<?>');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var spritemap = soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      /** @type {!Array<?>} */

      var years = soy.asserts.assertType(goog.isArray(opt_data.years), 'years', opt_data.years, '!Array<?>');
      /** @type {*|null|undefined} */

      var _handleDotClicked = opt_data._handleDotClicked;
      /** @type {*|null|undefined} */

      var _handleNavigateChange = opt_data._handleNavigateChange;
      /** @type {*|null|undefined} */

      var _handleNextMonth = opt_data._handleNextMonth;
      /** @type {*|null|undefined} */

      var _handlePreviousMonth = opt_data._handlePreviousMonth;
      var msg_21561__soy21562 = '';
      /** @desc  */

      var MSG_EXTERNAL_5736512712252459867 = Liferay.Language.get('next');
      msg_21561__soy21562 += MSG_EXTERNAL_5736512712252459867;
      var msg_21558__soy21559 = '';
      /** @desc  */

      var MSG_EXTERNAL_1679805429316985311 = Liferay.Language.get('today');
      msg_21558__soy21559 += MSG_EXTERNAL_1679805429316985311;
      var msg_21555__soy21556 = '';
      /** @desc  */

      var MSG_EXTERNAL_6095534740119293938 = Liferay.Language.get('previous');
      msg_21555__soy21556 += MSG_EXTERNAL_6095534740119293938;
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'header');
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpenStart('form');
      incrementalDom.attr('class', 'form-caption');
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpenStart('select');
      incrementalDom.attr('class', 'form-control form-control-sm');
      incrementalDom.attr('name', 'month');
      incrementalDom.attr('onChange', _handleNavigateChange);
      incrementalDom.attr('value', _month);
      incrementalDom.elementOpenEnd();
      var month983List = months;
      var month983ListLen = month983List.length;

      for (var month983Index = 0; month983Index < month983ListLen; month983Index++) {
        var month983Data = month983List[month983Index];
        incrementalDom.elementOpenStart('option');

        if (month983Data == months[_month]) {
          incrementalDom.attr('selected', '');
        }

        incrementalDom.attr('value', month983Index);
        incrementalDom.elementOpenEnd();
        soyIdom.print(month983Data);
        incrementalDom.elementClose('option');
      }

      incrementalDom.elementClose('select');
      incrementalDom.elementOpenStart('select');
      incrementalDom.attr('class', 'form-control form-control-sm');
      incrementalDom.attr('name', 'year');
      incrementalDom.attr('onChange', _handleNavigateChange);
      incrementalDom.attr('value', _year);
      incrementalDom.elementOpenEnd();
      var year1003List = years;
      var year1003ListLen = year1003List.length;

      for (var year1003Index = 0; year1003Index < year1003ListLen; year1003Index++) {
        var year1003Data = year1003List[year1003Index];
        incrementalDom.elementOpenStart('option', year1003Data + year1003Index + (year1003Data == _year ? 'selected' : 'unselected'));
        incrementalDom.attr('key', year1003Data + year1003Index + (year1003Data == _year ? 'selected' : 'unselected'));

        if (year1003Data == _year) {
          incrementalDom.attr('selected', '');
        }

        incrementalDom.attr('value', year1003Data);
        incrementalDom.elementOpenEnd();
        soyIdom.print(year1003Data);
        incrementalDom.elementClose('option');
      }

      incrementalDom.elementClose('select');
      incrementalDom.elementClose('form');
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'navigation');
      incrementalDom.elementOpenEnd();
      var previous__soy1006 = '';
      previous__soy1006 += msg_21555__soy21556;
      var today__soy1013 = '';
      today__soy1013 += msg_21558__soy21559;
      var next__soy1020 = '';
      next__soy1020 += msg_21561__soy21562;
      $templateAlias2({
        events: {
          click: _handlePreviousMonth
        },
        ariaLabel: previous__soy1006,
        icon: 'angle-left',
        monospaced: true,
        size: 'sm',
        spritemap: spritemap,
        style: 'unstyled',
        type: 'button'
      }, null, opt_ijData);
      $templateAlias2({
        events: {
          click: _handleDotClicked
        },
        ariaLabel: today__soy1013,
        icon: 'live',
        monospaced: true,
        size: 'sm',
        spritemap: spritemap,
        style: 'unstyled',
        type: 'button'
      }, null, opt_ijData);
      $templateAlias2({
        events: {
          click: _handleNextMonth
        },
        ariaLabel: next__soy1020,
        icon: 'angle-right',
        monospaced: true,
        size: 'sm',
        spritemap: spritemap,
        style: 'unstyled',
        type: 'button'
      }, null, opt_ijData);
      incrementalDom.elementClose('div');
      incrementalDom.elementClose('div');
    }

    exports.header = $header;
    /**
     * @typedef {{
     *  _month: number,
     *  _year: number,
     *  months: !Array<?>,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  years: !Array<?>,
     *  _handleDotClicked: (*|null|undefined),
     *  _handleNavigateChange: (*|null|undefined),
     *  _handleNextMonth: (*|null|undefined),
     *  _handlePreviousMonth: (*|null|undefined)
     * }}
     */

    $header.Params;

    if (goog.DEBUG) {
      $header.soyTemplateName = 'DatePicker.header';
    }
    /**
     * @param {{
     *  _daySelected: *,
     *  _weeks: !Array<?>,
     *  _handleDayClicked: (*|null|undefined),
     *  _handleDayKeyDown: (*|null|undefined),
     *  _handleDayFocus: (*|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $body(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {*} */

      var _daySelected = opt_data._daySelected;
      /** @type {!Array<?>} */

      var _weeks = soy.asserts.assertType(goog.isArray(opt_data._weeks), '_weeks', opt_data._weeks, '!Array<?>');
      /** @type {*|null|undefined} */

      var _handleDayClicked = opt_data._handleDayClicked;
      /** @type {*|null|undefined} */

      var _handleDayKeyDown = opt_data._handleDayKeyDown;
      /** @type {*|null|undefined} */

      var _handleDayFocus = opt_data._handleDayFocus;
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'grid');
      incrementalDom.elementOpenEnd();
      var week1095List = _weeks;
      var week1095ListLen = week1095List.length;

      for (var week1095Index = 0; week1095Index < week1095ListLen; week1095Index++) {
        var week1095Data = week1095List[week1095Index];
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'rowgroup');
        incrementalDom.elementOpenEnd();
        var day1092List = week1095Data;
        var day1092ListLen = day1092List.length;

        for (var day1092Index = 0; day1092Index < day1092ListLen; day1092Index++) {
          var day1092Data = day1092List[day1092Index];

          var attributes__soy1067 = function attributes__soy1067() {
            incrementalDom.attr('aria-label', day1092Data.number);
            incrementalDom.attr('dateString', day1092Data.dateString);
            incrementalDom.attr('class', ' day' + (day1092Data.outside ? ' outside' : '') + (day1092Data.dateString == _daySelected ? ' active' : ''));
            incrementalDom.attr('tabindex', '0');
            incrementalDom.attr('onClick', _handleDayClicked);
            incrementalDom.attr('onFocus', _handleDayFocus);
            incrementalDom.attr('onKeyDown', _handleDayKeyDown);
          };

          incrementalDom.elementOpenStart('div');
          attributes__soy1067();
          incrementalDom.elementOpenEnd();
          soyIdom.print(day1092Data.number);
          incrementalDom.elementClose('div');
        }

        incrementalDom.elementClose('div');
      }

      incrementalDom.elementClose('div');
    }

    exports.body = $body;
    /**
     * @typedef {{
     *  _daySelected: *,
     *  _weeks: !Array<?>,
     *  _handleDayClicked: (*|null|undefined),
     *  _handleDayKeyDown: (*|null|undefined),
     *  _handleDayFocus: (*|null|undefined)
     * }}
     */

    $body.Params;

    if (goog.DEBUG) {
      $body.soyTemplateName = 'DatePicker.body';
    }

    exports.render.params = ["name", "spritemap", "years", "_daySelected", "_handleDayClicked", "_handleDayKeyDown", "_handleDayFocus", "_handleDotClicked", "_handleInput", "_handleInputBlurred", "_handleInputFocused", "_handleNavigateChange", "_handleNextMonth", "_handlePreviousMonth", "_handleToggle", "_month", "_weeks", "_year", "displayErrors", "displayStyle", "elementClasses", "errorMessage", "expanded", "firstDayOfWeek", "formattedValue", "id", "label", "months", "placeholder", "predefinedValue", "readOnly", "repeatable", "required", "showLabel", "tip", "tooltip", "valid", "value", "visible", "weekdaysShort"];
    exports.render.types = {
      "name": "string",
      "spritemap": "string",
      "years": "list<?>",
      "_daySelected": "any",
      "_handleDayClicked": "any",
      "_handleDayKeyDown": "any",
      "_handleDayFocus": "any",
      "_handleDotClicked": "any",
      "_handleInput": "any",
      "_handleInputBlurred": "any",
      "_handleInputFocused": "any",
      "_handleNavigateChange": "any",
      "_handleNextMonth": "any",
      "_handlePreviousMonth": "any",
      "_handleToggle": "any",
      "_month": "int",
      "_weeks": "list<?>",
      "_year": "int",
      "displayErrors": "bool",
      "displayStyle": "string",
      "elementClasses": "string",
      "errorMessage": "string",
      "expanded": "bool",
      "firstDayOfWeek": "int",
      "formattedValue": "string",
      "id": "string",
      "label": "string",
      "months": "list<?>",
      "placeholder": "string",
      "predefinedValue": "string",
      "readOnly": "bool",
      "repeatable": "bool",
      "required": "bool",
      "showLabel": "bool",
      "tip": "string",
      "tooltip": "string",
      "valid": "bool",
      "value": "?",
      "visible": "bool",
      "weekdaysShort": "list<string>"
    };
    exports.content.params = ["name", "spritemap", "years", "_daySelected", "_handleDayClicked", "_handleDayKeyDown", "_handleDayFocus", "_handleDotClicked", "_handleInput", "_handleInputBlurred", "_handleInputFocused", "_handleNavigateChange", "_handleNextMonth", "_handlePreviousMonth", "_handleToggle", "_month", "_weeks", "_year", "elementClasses", "expanded", "firstDayOfWeek", "formattedValue", "id", "months", "placeholder", "predefinedValue", "readOnly", "value", "weekdaysShort"];
    exports.content.types = {
      "name": "string",
      "spritemap": "string",
      "years": "list<?>",
      "_daySelected": "any",
      "_handleDayClicked": "any",
      "_handleDayKeyDown": "any",
      "_handleDayFocus": "any",
      "_handleDotClicked": "any",
      "_handleInput": "any",
      "_handleInputBlurred": "any",
      "_handleInputFocused": "any",
      "_handleNavigateChange": "any",
      "_handleNextMonth": "any",
      "_handlePreviousMonth": "any",
      "_handleToggle": "any",
      "_month": "int",
      "_weeks": "list<?>",
      "_year": "int",
      "elementClasses": "string",
      "expanded": "bool",
      "firstDayOfWeek": "int",
      "formattedValue": "string",
      "id": "string",
      "months": "list<?>",
      "placeholder": "string",
      "predefinedValue": "string",
      "readOnly": "bool",
      "value": "?",
      "weekdaysShort": "list<string>"
    };
    exports.header.params = ["_month", "_year", "months", "spritemap", "years", "_handleDotClicked", "_handleNavigateChange", "_handleNextMonth", "_handlePreviousMonth"];
    exports.header.types = {
      "_month": "int",
      "_year": "int",
      "months": "list<?>",
      "spritemap": "string",
      "years": "list<?>",
      "_handleDotClicked": "any",
      "_handleNavigateChange": "any",
      "_handleNextMonth": "any",
      "_handlePreviousMonth": "any"
    };
    exports.body.params = ["_daySelected", "_weeks", "_handleDayClicked", "_handleDayKeyDown", "_handleDayFocus"];
    exports.body.types = {
      "_daySelected": "any",
      "_weeks": "list<?>",
      "_handleDayClicked": "any",
      "_handleDayKeyDown": "any",
      "_handleDayFocus": "any"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var DatePicker = /*#__PURE__*/function (_Component) {
    _inherits(DatePicker, _Component);

    function DatePicker() {
      _classCallCheck(this, DatePicker);

      return _possibleConstructorReturn(this, _getPrototypeOf(DatePicker).apply(this, arguments));
    }

    return DatePicker;
  }(_metalComponent["default"]);

  exports.DatePicker = DatePicker;

  _metalSoy["default"].register(DatePicker, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=DatePicker.soy.js.map
});
//# sourceMappingURL=DatePicker.soy.js.map