Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/DocumentLibrary/DocumentLibrary.es", ['module', 'exports', 'require', '../FieldBase/FieldBase.es', './DocumentLibraryRegister.soy', 'frontend-js-web', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', './DocumentLibrary.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("../FieldBase/FieldBase.es");

  require("./DocumentLibraryRegister.soy");

  var _frontendJsWeb = require("frontend-js-web");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _DocumentLibrary = _interopRequireDefault(require("./DocumentLibrary.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });keys.push.apply(keys, symbols);
    }return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var DocumentLibrary = /*#__PURE__*/function (_Component) {
    _inherits(DocumentLibrary, _Component);

    function DocumentLibrary() {
      _classCallCheck(this, DocumentLibrary);

      return _possibleConstructorReturn(this, _getPrototypeOf(DocumentLibrary).apply(this, arguments));
    }

    _createClass(DocumentLibrary, [{
      key: "created",
      value: function created() {
        var _this = this;

        AUI().use('liferay-item-selector-dialog', function (A) {
          _this.A = A;
        });
      }
    }, {
      key: "prepareStateForRender",
      value: function prepareStateForRender(state) {
        var fileEntryTitle = state.fileEntryTitle,
            fileEntryURL = state.fileEntryURL,
            value = state.value;

        if (value) {
          if (_typeof(value) === 'object') {
            fileEntryTitle = value.title;

            if (value.url) {
              fileEntryURL = value.url;
            }

            value = JSON.stringify(value);
          } else if (typeof value === 'string') {
            var object = JSON.parse(value);
            fileEntryTitle = object.title;

            if (object.url) {
              fileEntryURL = object.url;
            }
          }
        }

        return _objectSpread({}, state, {
          clearButtonAriaLabel: Liferay.Language.get('unselect-file'),
          fileEntryTitle: fileEntryTitle,
          fileEntryURL: fileEntryURL,
          value: value
        });
      }
    }, {
      key: "getDocumentLibrarySelectorURL",
      value: function getDocumentLibrarySelectorURL() {
        var _this$initialConfig_ = this.initialConfig_,
            groupId = _this$initialConfig_.groupId,
            itemSelectorAuthToken = _this$initialConfig_.itemSelectorAuthToken;
        var folderId = this.folderId,
            portletNamespace = this.portletNamespace;
        var criterionJSON = {
          desiredItemSelectorReturnTypes: 'com.liferay.item.selector.criteria.FileEntryItemSelectorReturnType,com.liferay.item.selector.criteria.FileEntryItemSelectorReturnType'
        };
        var uploadCriterionJSON = {
          URL: this.getUploadURL(),
          desiredItemSelectorReturnTypes: 'com.liferay.item.selector.criteria.FileEntryItemSelectorReturnType,com.liferay.item.selector.criteria.FileEntryItemSelectorReturnType'
        };
        var documentLibrarySelectorParameters = {
          '0_json': JSON.stringify(criterionJSON),
          '1_json': JSON.stringify(criterionJSON),
          '2_json': JSON.stringify(uploadCriterionJSON),
          criteria: 'com.liferay.item.selector.criteria.file.criterion.FileItemSelectorCriterion',
          doAsGroupId: groupId,
          folderId: folderId,
          itemSelectedEventName: "".concat(portletNamespace, "selectDocumentLibrary"),
          p_p_auth: itemSelectorAuthToken,
          p_p_id: Liferay.PortletKeys.ITEM_SELECTOR,
          p_p_mode: 'view',
          p_p_state: 'pop_up',
          refererGroupId: groupId
        };
        var documentLibrarySelectorURL = (0, _frontendJsWeb.createPortletURL)(themeDisplay.getLayoutRelativeControlPanelURL(), documentLibrarySelectorParameters);
        return documentLibrarySelectorURL.toString();
      }
    }, {
      key: "getUploadURL",
      value: function getUploadURL() {
        var uploadParameters = {
          cmd: 'add_temp',
          'javax.portlet.action': '/document_library/upload_file_entry',
          p_auth: Liferay.authToken,
          p_p_id: Liferay.PortletKeys.DOCUMENT_LIBRARY
        };
        var uploadURL = (0, _frontendJsWeb.createActionURL)(themeDisplay.getLayoutRelativeURL(), uploadParameters);
        return uploadURL.toString();
      }
    }, {
      key: "_handleClearButtonClicked",
      value: function _handleClearButtonClicked() {
        var _this2 = this;

        this.setState({
          value: ''
        }, function () {
          _this2.emit('fieldEdited', {
            fieldInstance: _this2,
            value: ''
          });
        });
      }
    }, {
      key: "_handleFieldChanged",
      value: function _handleFieldChanged(event) {
        var _this3 = this;

        var selectedItem = event.newVal;

        if (selectedItem) {
          var value = selectedItem.value;
          this.setState({
            value: value
          }, function () {
            _this3.emit('fieldEdited', {
              fieldInstance: _this3,
              originalEvent: event,
              value: value
            });
          });
        }
      }
    }, {
      key: "_handleSelectButtonClicked",
      value: function _handleSelectButtonClicked() {
        var A = this.A,
            portletNamespace = this.portletNamespace;
        var itemSelectorDialog = new A.LiferayItemSelectorDialog({
          eventName: "".concat(portletNamespace, "selectDocumentLibrary"),
          on: {
            selectedItemChange: this._handleFieldChanged.bind(this),
            visibleChange: this._handleVisibleChange.bind(this)
          },
          url: this.getDocumentLibrarySelectorURL()
        });
        itemSelectorDialog.open();
      }
    }, {
      key: "_handleVisibleChange",
      value: function _handleVisibleChange(event) {
        if (event.newVal) {
          this.emit('fieldFocused', {
            fieldInstance: this,
            originalEvent: event
          });
        } else {
          this.emit('fieldBlurred', {
            fieldInstance: this,
            originalEvent: event
          });
        }
      }
    }]);

    return DocumentLibrary;
  }(_metalComponent["default"]);

  DocumentLibrary.STATE = {
    /**
     * @default 'string'
     * @memberof Text
     * @type {?(string|undefined)}
     */
    dataType: _metalState.Config.string().value('date'),

    /**
     * @default false
     * @memberof DocumentLibrary
     * @type {?bool}
     */
    evaluable: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @memberof DocumentLibrary
     * @type {?(string|undefined)}
     */
    fieldName: _metalState.Config.string(),

    /**
     * @default undefined
     * @memberof DocumentLibrary
     * @type {?(string|undefined)}
     */
    folderId: _metalState.Config.string(),

    /**
     * @default undefined
     * @memberof DocumentLibrary
     * @type {?(string|undefined)}
     */
    id: _metalState.Config.string(),

    /**
     * @default undefined
     * @memberof DocumentLibrary
     * @type {?(string|undefined)}
     */
    label: _metalState.Config.string(),

    /**
     * @default undefined
     * @memberof DocumentLibrary
     * @type {?(string|undefined)}
     */
    name: _metalState.Config.string().required(),

    /**
     * @default undefined
     * @memberof DocumentLibrary
     * @type {?(string|undefined)}
     */
    placeholder: _metalState.Config.string(),

    /**
     * @default false
     * @memberof DocumentLibrary
     * @type {?bool}
     */
    readOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @memberof FieldBase
     * @type {?(bool|undefined)}
     */
    repeatable: _metalState.Config.bool(),

    /**
     * @default false
     * @memberof DocumentLibrary
     * @type {?(bool|undefined)}
     */
    required: _metalState.Config.bool().value(false),

    /**
     * @default true
     * @memberof DocumentLibrary
     * @type {?(bool|undefined)}
     */
    showLabel: _metalState.Config.bool().value(true),

    /**
     * @default undefined
     * @memberof DocumentLibrary
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default undefined
     * @memberof DocumentLibrary
     * @type {?(string|undefined)}
     */
    tip: _metalState.Config.string(),

    /**
     * @default undefined
     * @memberof FieldBase
     * @type {?(string|undefined)}
     */
    tooltip: _metalState.Config.string(),

    /**
     * @default undefined
     * @memberof Text
     * @type {?(string|undefined)}
     */
    type: _metalState.Config.string().value('document_library'),

    /**
     * @default undefined
     * @memberof DocumentLibrary
     * @type {?(string|undefined)}
     */
    value: _metalState.Config.oneOfType([_metalState.Config.object(), _metalState.Config.string()])
  };

  _metalSoy["default"].register(DocumentLibrary, _DocumentLibrary["default"]);

  var _default = DocumentLibrary;
  exports["default"] = _default;
  //# sourceMappingURL=DocumentLibrary.es.js.map
});
//# sourceMappingURL=DocumentLibrary.es.js.map