Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Editor/Editor.es", ['module', 'exports', 'require', '../FieldBase/FieldBase.es', './EditorRegister.soy', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', './Editor.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("../FieldBase/FieldBase.es");

  require("./EditorRegister.soy");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _Editor = _interopRequireDefault(require("./Editor.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var Editor = /*#__PURE__*/function (_Component) {
    _inherits(Editor, _Component);

    function Editor() {
      _classCallCheck(this, Editor);

      return _possibleConstructorReturn(this, _getPrototypeOf(Editor).apply(this, arguments));
    }

    _createClass(Editor, [{
      key: "attached",
      value: function attached() {
        var _this = this;

        AUI().use('liferay-alloy-editor', function (A) {
          _this.A = A;

          _this._createEditor(A);
        });
      }
    }, {
      key: "disposed",
      value: function disposed() {
        if (this._alloyEditor) {
          this._alloyEditor.destroy();
        }
      }
    }, {
      key: "shouldUpdate",
      value: function shouldUpdate() {
        return false;
      }
    }, {
      key: "syncEditingLanguageId",
      value: function syncEditingLanguageId() {
        var value = this.value;
        this.syncValue(value, null, true);
      }
    }, {
      key: "syncValue",
      value: function syncValue(value, prevVal) {
        var force = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
        var _alloyEditor = this._alloyEditor;

        if (_alloyEditor && _alloyEditor.getHTML() !== value) {
          var nativeEditor = _alloyEditor.getNativeEditor();

          var hasFocus = nativeEditor.focusManager.hasFocus;

          if (force || !hasFocus) {
            nativeEditor.setData(value);
          }
        }
      }
    }, {
      key: "_createEditor",
      value: function _createEditor(A) {
        var name = this.name,
            readOnly = this.readOnly,
            value = this.value;
        var editorNode = this.element.querySelector('.alloy-editor');

        if (readOnly) {
          return;
        }

        editorNode.innerHTML = value;
        window[name] = {};
        this._alloyEditor = new A.LiferayAlloyEditor({
          contents: value,
          editorConfig: {
            extraPlugins: 'ae_placeholder,ae_selectionregion,ae_uicore',
            removePlugins: 'contextmenu,elementspath,floatingspace,image,link,liststyle,magiclineresize,table,tabletools,toolbar',
            spritemap: "".concat(themeDisplay.getPathThemeImages(), "/lexicon/icons.svg"),
            srcNode: A.one(editorNode),
            toolbars: {
              add: {
                buttons: ['hline', 'table']
              },
              styles: {
                selections: AlloyEditor.Selections,
                tabIndex: 1
              }
            }
          },
          namespace: name,
          onChangeMethod: this._onChangeEditor.bind(this),
          plugins: [],
          textMode: false
        }).render();

        this._alloyEditor.getNativeEditor().on('actionPerformed', this._onActionPerformed.bind(this));
      }
    }, {
      key: "_onActionPerformed",
      value: function _onActionPerformed(event) {
        var props = event.data.props;

        if (!props.command) {
          this._onChangeEditor(event);
        }
      }
    }, {
      key: "_onChangeEditor",
      value: function _onChangeEditor(event) {
        this.emit('fieldEdited', {
          fieldInstance: this,
          originalEvent: event,
          value: this._alloyEditor.getHTML()
        });
      }
    }]);

    return Editor;
  }(_metalComponent["default"]);

  Editor.STATE = {
    /**
     * @default undefined
     * @instance
     * @memberof Editor
     * @type {?string}
     */
    editingLanguageId: _metalState.Config.string(),

    /**
     * @default false
     * @instance
     * @memberof Editor
     * @type {?bool}
     */
    evaluable: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof Editor
     * @type {?(string|undefined)}
     */
    fieldName: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Editor
     * @type {?(string|undefined)}
     */
    id: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Editor
     * @type {?(string|undefined)}
     */
    label: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Editor
     * @type {?(string|undefined)}
     */
    name: _metalState.Config.string().required(),

    /**
     * @default undefined
     * @instance
     * @memberof Editor
     * @type {?(string|undefined)}
     */
    placeholder: _metalState.Config.string(),

    /**
     * @default false
     * @instance
     * @memberof Editor
     * @type {?bool}
     */
    readOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(bool|undefined)}
     */
    repeatable: _metalState.Config.bool(),

    /**
     * @default false
     * @instance
     * @memberof Editor
     * @type {?(bool|undefined)}
     */
    required: _metalState.Config.bool().value(false),

    /**
     * @default true
     * @instance
     * @memberof Editor
     * @type {?(bool|undefined)}
     */
    showLabel: _metalState.Config.bool().value(true),

    /**
     * @default undefined
     * @instance
     * @memberof Editor
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Editor
     * @type {?(string|undefined)}
     */
    tip: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(string|undefined)}
     */
    tooltip: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    type: _metalState.Config.string().value('editor'),

    /**
     * @default undefined
     * @instance
     * @memberof Editor
     * @type {?(string|undefined)}
     */
    value: _metalState.Config.string().value('')
  };

  _metalSoy["default"].register(Editor, _Editor["default"]);

  var _default = Editor;
  exports["default"] = _default;
  //# sourceMappingURL=Editor.es.js.map
});
//# sourceMappingURL=Editor.es.js.map