Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/FieldBase/FieldBase.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.FieldBase = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from FieldBase.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace FieldBase.
     * @public
     */

    goog.module('FieldBase.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');

    var $templateAlias1 = _metalSoy["default"].getTemplate('ClayButton.incrementaldom', 'render');

    var $templateAlias2 = _metalSoy["default"].getTemplate('ClayIcon.incrementaldom', 'render');

    var $templateAlias3 = _metalSoy["default"].getTemplate('Tooltip.incrementaldom', 'render');
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleAddRepeatedFieldButtonClicked: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleRemoveRepeatedFieldButtonClicked: (*|null|undefined),
     *  addDuplicateField: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  contentRenderer: (*|null|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  requiredText: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  removeDuplicateField: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  required: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  showRepeatableRemoveButton: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  text: (function()|null|undefined),
     *  tooltip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  type: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  visible: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {*|null|undefined} */

      var _handleAddRepeatedFieldButtonClicked = opt_data._handleAddRepeatedFieldButtonClicked;
      /** @type {*|null|undefined} */

      var _handleFieldClicked = opt_data._handleFieldClicked;
      /** @type {*|null|undefined} */

      var _handleRemoveRepeatedFieldButtonClicked = opt_data._handleRemoveRepeatedFieldButtonClicked;
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var addDuplicateField = soy.asserts.assertType(opt_data.addDuplicateField == null || goog.isString(opt_data.addDuplicateField) || opt_data.addDuplicateField instanceof goog.soy.data.SanitizedContent, 'addDuplicateField', opt_data.addDuplicateField, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {*|null|undefined} */

      var contentRenderer = opt_data.contentRenderer;
      /** @type {boolean|null|undefined} */

      var displayErrors = soy.asserts.assertType(opt_data.displayErrors == null || goog.isBoolean(opt_data.displayErrors) || opt_data.displayErrors === 1 || opt_data.displayErrors === 0, 'displayErrors', opt_data.displayErrors, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var errorMessage = soy.asserts.assertType(opt_data.errorMessage == null || goog.isString(opt_data.errorMessage) || opt_data.errorMessage instanceof goog.soy.data.SanitizedContent, 'errorMessage', opt_data.errorMessage, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var id = soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tip = soy.asserts.assertType(opt_data.tip == null || goog.isString(opt_data.tip) || opt_data.tip instanceof goog.soy.data.SanitizedContent, 'tip', opt_data.tip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var label = soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var requiredText = soy.asserts.assertType(opt_data.requiredText == null || goog.isString(opt_data.requiredText) || opt_data.requiredText instanceof goog.soy.data.SanitizedContent, 'requiredText', opt_data.requiredText, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var removeDuplicateField = soy.asserts.assertType(opt_data.removeDuplicateField == null || goog.isString(opt_data.removeDuplicateField) || opt_data.removeDuplicateField instanceof goog.soy.data.SanitizedContent, 'removeDuplicateField', opt_data.removeDuplicateField, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var required = soy.asserts.assertType(opt_data.required == null || goog.isBoolean(opt_data.required) || opt_data.required === 1 || opt_data.required === 0, 'required', opt_data.required, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var repeatable = soy.asserts.assertType(opt_data.repeatable == null || goog.isBoolean(opt_data.repeatable) || opt_data.repeatable === 1 || opt_data.repeatable === 0, 'repeatable', opt_data.repeatable, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showLabel = soy.asserts.assertType(opt_data.showLabel == null || goog.isBoolean(opt_data.showLabel) || opt_data.showLabel === 1 || opt_data.showLabel === 0, 'showLabel', opt_data.showLabel, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showRepeatableRemoveButton = soy.asserts.assertType(opt_data.showRepeatableRemoveButton == null || goog.isBoolean(opt_data.showRepeatableRemoveButton) || opt_data.showRepeatableRemoveButton === 1 || opt_data.showRepeatableRemoveButton === 0, 'showRepeatableRemoveButton', opt_data.showRepeatableRemoveButton, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var spritemap = soy.asserts.assertType(opt_data.spritemap == null || goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {function()|null|undefined} */

      var text = soy.asserts.assertType(opt_data.text == null || goog.isFunction(opt_data.text), 'text', opt_data.text, 'function()|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tooltip = soy.asserts.assertType(opt_data.tooltip == null || goog.isString(opt_data.tooltip) || opt_data.tooltip instanceof goog.soy.data.SanitizedContent, 'tooltip', opt_data.tooltip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var type = soy.asserts.assertType(opt_data.type == null || goog.isString(opt_data.type) || opt_data.type instanceof goog.soy.data.SanitizedContent, 'type', opt_data.type, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var valid = soy.asserts.assertType(opt_data.valid == null || goog.isBoolean(opt_data.valid) || opt_data.valid === 1 || opt_data.valid === 0, 'valid', opt_data.valid, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var visible = soy.asserts.assertType(opt_data.visible == null || goog.isBoolean(opt_data.visible) || opt_data.visible === 1 || opt_data.visible === 0, 'visible', opt_data.visible, 'boolean|null|undefined');
      var fieldCssClassAttribute__soy1494 = '';
      fieldCssClassAttribute__soy1494 += 'form-group';
      fieldCssClassAttribute__soy1494 += displayErrors && errorMessage && valid == false ? ' has-error' : '';
      fieldCssClassAttribute__soy1494 += visible == false ? ' hide' : '';
      var fieldDetailsId__soy1505 = name + '_fieldDetails';
      var renderlabel__soy1507 = label && showLabel || required || tooltip || repeatable;

      var divAttributes__soy1509 = function divAttributes__soy1509() {
        if (!renderlabel__soy1507) {
          incrementalDom.attr('tabindex', '0');
          incrementalDom.attr('aria-labelledby', fieldDetailsId__soy1505);
        }

        incrementalDom.attr('class', fieldCssClassAttribute__soy1494);
        incrementalDom.attr('data-field-name', name);
        incrementalDom.attr('data-onclick', _handleFieldClicked);
      };

      incrementalDom.elementOpenStart('div');
      divAttributes__soy1509();
      incrementalDom.elementOpenEnd();

      if (repeatable) {
        var msg_21567__soy21568 = '';
        /** @desc  */

        var MSG_EXTERNAL_2027700063752332946 = goog.getMsg(' {$addDuplicateField} ', {
          'addDuplicateField': addDuplicateField
        });
        msg_21567__soy21568 += MSG_EXTERNAL_2027700063752332946;
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'lfr-ddm-form-field-repeatable-toolbar');
        incrementalDom.elementOpenEnd();

        if (showRepeatableRemoveButton) {
          var msg_21564__soy21565 = '';
          /** @desc  */

          var MSG_EXTERNAL_7437379674674117067 = goog.getMsg(' {$removeDuplicateField} ', {
            'removeDuplicateField': removeDuplicateField
          });
          msg_21564__soy21565 += MSG_EXTERNAL_7437379674674117067;
          var delete__soy1532 = '';
          delete__soy1532 += msg_21564__soy21565;
          $templateAlias1({
            ariaLabel: delete__soy1532,
            disabled: readOnly,
            elementClasses: 'btn-xs ddm-form-field-repeatable-delete-button p-0',
            events: {
              click: _handleRemoveRepeatedFieldButtonClicked
            },
            icon: 'trash',
            spritemap: spritemap,
            type: 'button'
          }, null, opt_ijData);
        }

        var duplicate__soy1552 = '';
        duplicate__soy1552 += msg_21567__soy21568;
        $templateAlias1({
          ariaLabel: duplicate__soy1552,
          disabled: readOnly,
          elementClasses: 'btn-xs ddm-form-field-repeatable-add-button p-0',
          events: {
            click: _handleAddRepeatedFieldButtonClicked
          },
          icon: 'plus',
          spritemap: spritemap,
          type: 'button'
        }, null, opt_ijData);
        incrementalDom.elementClose('div');
      }

      var labelAttributes__soy1574 = function labelAttributes__soy1574() {
        if (type && (type == 'text' || type == 'numeric')) {
          if (id) {
            incrementalDom.attr('for', id);
          } else {
            incrementalDom.attr('for', name);
          }
        } else {
          incrementalDom.attr('tabindex', '0');
        }

        incrementalDom.attr('aria-labelledby', fieldDetailsId__soy1505);

        if (!showLabel && !required) {
          incrementalDom.attr('class', 'ddm-empty');
        } else {
          incrementalDom.attr('class', 'ddm-label');
        }
      };

      if (renderlabel__soy1507) {
        var fieldProperties__soy1604 = function fieldProperties__soy1604() {
          if (required && spritemap) {
            incrementalDom.elementOpenStart('span');
            incrementalDom.attr('class', 'reference-mark');
            incrementalDom.elementOpenEnd();
            $templateAlias2({
              spritemap: spritemap,
              symbol: 'asterisk'
            }, null, opt_ijData);
            incrementalDom.elementClose('span');
          }

          if (tooltip) {
            $templateAlias3({
              ariaLabel: tooltip,
              icon: 'question-circle-full',
              spritemap: spritemap,
              text: tooltip
            }, null, opt_ijData);
          }
        };

        if (type && (type == 'checkbox_multiple' || type == 'grid' || type == 'paragraph' || type == 'radio')) {
          incrementalDom.elementOpen('fieldset');
          incrementalDom.elementOpenStart('legend');
          incrementalDom.attr('aria-labelledby', fieldDetailsId__soy1505);
          incrementalDom.attr('class', 'lfr-ddm-legend');
          incrementalDom.attr('tabIndex', '0');
          incrementalDom.elementOpenEnd();

          if (label && showLabel) {
            soyIdom.print(label);
            incrementalDom.text(' ');
          }

          fieldProperties__soy1604();
          incrementalDom.elementClose('legend');
          soyIdom.print(contentRenderer);
          incrementalDom.elementClose('fieldset');
        } else {
          incrementalDom.elementOpenStart('label');
          labelAttributes__soy1574();
          incrementalDom.elementOpenEnd();

          if (label && showLabel) {
            soyIdom.print(label);
            incrementalDom.text(' ');
          }

          fieldProperties__soy1604();
          incrementalDom.elementClose('label');
          soyIdom.print(contentRenderer);
        }
      } else {
        soyIdom.print(contentRenderer);
      }

      var hasError__soy1662 = displayErrors && errorMessage != null && errorMessage != '' && !valid;

      if (label || tip || text || hasError__soy1662) {
        incrementalDom.elementOpenStart('span');
        incrementalDom.attr('id', fieldDetailsId__soy1505);
        incrementalDom.attr('class', 'sr-only');
        incrementalDom.elementOpenEnd();

        if (label) {
          incrementalDom.text(' ');
          soyIdom.print(label);
        }

        if (tip) {
          incrementalDom.text(' ');
          soyIdom.print(tip);
        }

        if (text) {
          incrementalDom.text(' ');
          text();
        }

        if (hasError__soy1662) {
          incrementalDom.text(' ');
          soyIdom.print(errorMessage);
        } else if (required) {
          incrementalDom.text(' ');
          soyIdom.print(requiredText);
        }

        incrementalDom.elementClose('span');
      }

      if (tip) {
        incrementalDom.elementOpenStart('span');
        incrementalDom.attr('class', 'form-text');
        incrementalDom.attr('aria-hidden', 'true');
        incrementalDom.elementOpenEnd();
        soyIdom.print(tip);
        incrementalDom.elementClose('span');
      }

      if (displayErrors && errorMessage && valid == false) {
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'form-feedback-group');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'form-feedback-item help-block');
        incrementalDom.attr('aria-hidden', 'true');
        incrementalDom.elementOpenEnd();
        soyIdom.print(errorMessage);
        incrementalDom.elementClose('div');
        incrementalDom.elementClose('div');
      }

      incrementalDom.elementClose('div');
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleAddRepeatedFieldButtonClicked: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleRemoveRepeatedFieldButtonClicked: (*|null|undefined),
     *  addDuplicateField: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  contentRenderer: (*|null|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  requiredText: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  removeDuplicateField: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  required: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  showRepeatableRemoveButton: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  text: (function()|null|undefined),
     *  tooltip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  type: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  visible: (boolean|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'FieldBase.render';
    }

    exports.render.params = ["name", "_handleAddRepeatedFieldButtonClicked", "_handleFieldClicked", "_handleRemoveRepeatedFieldButtonClicked", "addDuplicateField", "contentRenderer", "displayErrors", "errorMessage", "id", "tip", "label", "requiredText", "readOnly", "removeDuplicateField", "required", "repeatable", "showLabel", "showRepeatableRemoveButton", "spritemap", "text", "tooltip", "type", "valid", "visible"];
    exports.render.types = {
      "name": "string",
      "_handleAddRepeatedFieldButtonClicked": "any",
      "_handleFieldClicked": "any",
      "_handleRemoveRepeatedFieldButtonClicked": "any",
      "addDuplicateField": "string",
      "contentRenderer": "any",
      "displayErrors": "bool",
      "errorMessage": "string",
      "id": "string",
      "tip": "string",
      "label": "string",
      "requiredText": "string",
      "readOnly": "bool",
      "removeDuplicateField": "string",
      "required": "bool",
      "repeatable": "bool",
      "showLabel": "bool",
      "showRepeatableRemoveButton": "bool",
      "spritemap": "string",
      "text": "html",
      "tooltip": "string",
      "type": "string",
      "valid": "bool",
      "visible": "bool"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var FieldBase = /*#__PURE__*/function (_Component) {
    _inherits(FieldBase, _Component);

    function FieldBase() {
      _classCallCheck(this, FieldBase);

      return _possibleConstructorReturn(this, _getPrototypeOf(FieldBase).apply(this, arguments));
    }

    return FieldBase;
  }(_metalComponent["default"]);

  exports.FieldBase = FieldBase;

  _metalSoy["default"].register(FieldBase, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=FieldBase.soy.js.map
});
//# sourceMappingURL=FieldBase.soy.js.map