Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/FieldSet/FieldSet.es", ['module', 'exports', 'require', '../FieldBase/FieldBase.es', './FieldSetRegister.soy', 'dynamic-data-mapping-form-renderer/js/components/PageRenderer/PageRenderer.es', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', './FieldSet.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.FieldSet = void 0;

  require("../FieldBase/FieldBase.es");

  require("./FieldSetRegister.soy");

  require("dynamic-data-mapping-form-renderer/js/components/PageRenderer/PageRenderer.es");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _FieldSet = _interopRequireDefault(require("./FieldSet.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });keys.push.apply(keys, symbols);
    }return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var FieldSet = /*#__PURE__*/function (_Component) {
    _inherits(FieldSet, _Component);

    function FieldSet() {
      _classCallCheck(this, FieldSet);

      return _possibleConstructorReturn(this, _getPrototypeOf(FieldSet).apply(this, arguments));
    }

    _createClass(FieldSet, [{
      key: "prepareNestedRows",
      value: function prepareNestedRows(_ref) {
        var nestedFields = _ref.nestedFields,
            rows = _ref.rows;
        return rows.map(function (row) {
          return _objectSpread({}, row, {
            columns: row.columns.map(function (column) {
              return _objectSpread({}, column, {
                fields: column.fields.map(function (fieldName) {
                  return nestedFields.find(function (nestedField) {
                    return nestedField.fieldName === fieldName;
                  });
                })
              });
            })
          });
        });
      }
    }, {
      key: "prepareStateForRender",
      value: function prepareStateForRender(state) {
        return _objectSpread({}, state, {
          nestedRows: this.prepareNestedRows(state)
        });
      }
    }, {
      key: "willReceiveState",
      value: function willReceiveState(changes) {
        if (changes.nestedFields || changes.rows) {
          this.forceUpdate();
        }
      }
    }, {
      key: "_handleFieldBlurred",
      value: function _handleFieldBlurred(event) {
        this.emit('fieldBlurred', event);
      }
    }, {
      key: "_handleFieldEdited",
      value: function _handleFieldEdited(event) {
        this.emit('fieldEdited', event);
      }
    }, {
      key: "_handleFieldFocused",
      value: function _handleFieldFocused(event) {
        this.emit('fieldFocused', event);
      }
    }, {
      key: "_setRows",
      value: function _setRows(rows) {
        if (typeof rows === 'string') {
          try {
            return JSON.parse(rows);
          } catch (e) {
            return [];
          }
        }

        return rows;
      }
    }]);

    return FieldSet;
  }(_metalComponent["default"]);

  exports.FieldSet = FieldSet;
  FieldSet.STATE = {
    /**
     * @default undefined
     * @instance
     * @memberof FieldSet
     * @type {?(string|undefined)}
     */
    errorMessage: _metalState.Config.string(),

    /**
     * @default false
     * @instance
     * @memberof FieldSet
     * @type {?bool}
     */
    evaluable: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof FieldSet
     * @type {?(string|undefined)}
     */
    fieldName: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof FieldSet
     * @type {?(string|undefined)}
     */
    label: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof FieldSet
     * @type {?(string|undefined)}
     */
    name: _metalState.Config.string().required(),

    /**
     * @default []
     * @instance
     * @memberof FieldSet
     * @type {?(Array)}
     */
    nestedFields: _metalState.Config.array().value([]),

    /**
     * @default []
     * @instance
     * @memberof FieldSet
     * @type {?(Array)}
     */
    nestedRows: _metalState.Config.array().internal().value([]),

    /**
     * @default '000000'
     * @instance
     * @memberof FieldSet
     * @type {?(string|undefined)}
     */
    predefinedValue: _metalState.Config.string().value('000000'),

    /**
     * @default false
     * @instance
     * @memberof FieldSet
     * @type {?bool}
     */
    readOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof FieldSet
     * @type {?(bool|undefined)}
     */
    repeatable: _metalState.Config.bool().value(false),

    /**
     * @default false
     * @instance
     * @memberof FieldSet
     * @type {?(bool|undefined)}
     */
    required: _metalState.Config.bool().value(false),

    /**
     * @default []
     * @instance
     * @memberof FieldSet
     * @type {?(Array|string)}
     */
    rows: _metalState.Config.oneOfType([_metalState.Config.array(), _metalState.Config.string()]).setter('_setRows').value([]),

    /**
     * @default true
     * @instance
     * @memberof FieldSet
     * @type {?(bool|undefined)}
     */
    showLabel: _metalState.Config.bool().value(true),

    /**
     * @default undefined
     * @instance
     * @memberof FieldSet
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof FieldSet
     * @type {?(string|undefined)}
     */
    tip: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof FieldSet
     * @type {?(string|undefined)}
     */
    value: _metalState.Config.string()
  };

  _metalSoy["default"].register(FieldSet, _FieldSet["default"]);

  var _default = FieldSet;
  exports["default"] = _default;
  //# sourceMappingURL=FieldSet.es.js.map
});
//# sourceMappingURL=FieldSet.es.js.map