Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Grid/Grid.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.Grid = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from Grid.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace Grid.
     * @public
     */

    goog.module('Grid.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');

    var $templateAlias1 = _metalSoy["default"].getTemplate('FieldBase.incrementaldom', 'render');
    /**
     * @param {{
     *  columns: !Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>,
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  rows: !Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>,
     *  value: (?),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  columnText: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  rowText: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  type: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  visible: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>} */

      var columns = soy.asserts.assertType(goog.isArray(opt_data.columns), 'columns', opt_data.columns, '!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>} */

      var rows = soy.asserts.assertType(goog.isArray(opt_data.rows), 'rows', opt_data.rows, '!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>');
      /** @type {?} */

      var value = opt_data.value;
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleFieldChanged = opt_data._handleFieldChanged;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var columnText = soy.asserts.assertType(opt_data.columnText == null || goog.isString(opt_data.columnText) || opt_data.columnText instanceof goog.soy.data.SanitizedContent, 'columnText', opt_data.columnText, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var displayErrors = soy.asserts.assertType(opt_data.displayErrors == null || goog.isBoolean(opt_data.displayErrors) || opt_data.displayErrors === 1 || opt_data.displayErrors === 0, 'displayErrors', opt_data.displayErrors, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var errorMessage = soy.asserts.assertType(opt_data.errorMessage == null || goog.isString(opt_data.errorMessage) || opt_data.errorMessage instanceof goog.soy.data.SanitizedContent, 'errorMessage', opt_data.errorMessage, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var id = soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var label = soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var placeholder = soy.asserts.assertType(opt_data.placeholder == null || goog.isString(opt_data.placeholder) || opt_data.placeholder instanceof goog.soy.data.SanitizedContent, 'placeholder', opt_data.placeholder, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var repeatable = soy.asserts.assertType(opt_data.repeatable == null || goog.isBoolean(opt_data.repeatable) || opt_data.repeatable === 1 || opt_data.repeatable === 0, 'repeatable', opt_data.repeatable, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var required = soy.asserts.assertType(opt_data.required == null || goog.isBoolean(opt_data.required) || opt_data.required === 1 || opt_data.required === 0, 'required', opt_data.required, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var rowText = soy.asserts.assertType(opt_data.rowText == null || goog.isString(opt_data.rowText) || opt_data.rowText instanceof goog.soy.data.SanitizedContent, 'rowText', opt_data.rowText, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var showLabel = soy.asserts.assertType(opt_data.showLabel == null || goog.isBoolean(opt_data.showLabel) || opt_data.showLabel === 1 || opt_data.showLabel === 0, 'showLabel', opt_data.showLabel, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var spritemap = soy.asserts.assertType(opt_data.spritemap == null || goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tip = soy.asserts.assertType(opt_data.tip == null || goog.isString(opt_data.tip) || opt_data.tip instanceof goog.soy.data.SanitizedContent, 'tip', opt_data.tip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var type = soy.asserts.assertType(opt_data.type == null || goog.isString(opt_data.type) || opt_data.type instanceof goog.soy.data.SanitizedContent, 'type', opt_data.type, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var valid = soy.asserts.assertType(opt_data.valid == null || goog.isBoolean(opt_data.valid) || opt_data.valid === 1 || opt_data.valid === 0, 'valid', opt_data.valid, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var visible = soy.asserts.assertType(opt_data.visible == null || goog.isBoolean(opt_data.visible) || opt_data.visible === 1 || opt_data.visible === 0, 'visible', opt_data.visible, 'boolean|null|undefined');

      var param2329 = function param2329() {
        $content({
          _handleFieldBlurred: _handleFieldBlurred,
          _handleFieldChanged: _handleFieldChanged,
          _handleFieldFocused: _handleFieldFocused,
          columns: columns,
          columnText: columnText,
          disabled: readOnly,
          id: id,
          name: name,
          placeholder: placeholder,
          rows: rows,
          rowText: rowText,
          value: value
        }, null, opt_ijData);
      };

      $templateAlias1({
        contentRenderer: param2329,
        displayErrors: displayErrors,
        errorMessage: errorMessage,
        id: id,
        label: label,
        name: name,
        repeatable: repeatable,
        required: required,
        showLabel: showLabel,
        spritemap: spritemap,
        tip: tip,
        type: type,
        valid: valid,
        visible: visible
      }, null, opt_ijData);
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  columns: !Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>,
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  rows: !Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>,
     *  value: (?),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  columnText: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  rowText: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  type: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  visible: (boolean|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'Grid.render';
    }
    /**
     * @param {{
     *  columns: !Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>,
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  rows: !Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>,
     *  value: (?),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  columnText: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  disabled: (boolean|null|undefined),
     *  readOnly: (boolean|null|undefined),
     *  rowText: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $content(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>} */

      var columns = soy.asserts.assertType(goog.isArray(opt_data.columns), 'columns', opt_data.columns, '!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');

      /** @type {!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>} */

      var rows = soy.asserts.assertType(goog.isArray(opt_data.rows), 'rows', opt_data.rows, '!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>');
      /** @type {?} */

      var value = opt_data.value;
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleFieldChanged = opt_data._handleFieldChanged;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var columnText = soy.asserts.assertType(opt_data.columnText == null || goog.isString(opt_data.columnText) || opt_data.columnText instanceof goog.soy.data.SanitizedContent, 'columnText', opt_data.columnText, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var disabled = soy.asserts.assertType(opt_data.disabled == null || goog.isBoolean(opt_data.disabled) || opt_data.disabled === 1 || opt_data.disabled === 0, 'disabled', opt_data.disabled, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var rowText = soy.asserts.assertType(opt_data.rowText == null || goog.isString(opt_data.rowText) || opt_data.rowText instanceof goog.soy.data.SanitizedContent, 'rowText', opt_data.rowText, '!goog.soy.data.SanitizedContent|null|string|undefined');
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'liferay-ddm-form-field-grid table-responsive');
      incrementalDom.elementOpenEnd();

      if (!readOnly) {
        $hidden_grid(opt_data, null, opt_ijData);
      }

      incrementalDom.elementOpenStart('table');
      incrementalDom.attr('class', 'table table-autofit table-list table-striped');
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpen('thead');
      incrementalDom.elementOpen('tr');
      incrementalDom.elementOpen('td');
      incrementalDom.elementClose('td');
      var column2389List = columns;
      var column2389ListLen = column2389List.length;

      for (var column2389Index = 0; column2389Index < column2389ListLen; column2389Index++) {
        var column2389Data = column2389List[column2389Index];

        if (column2389Data.value) {
          incrementalDom.elementOpen('th');
          soyIdom.print(column2389Data.label);
          incrementalDom.elementClose('th');
        }
      }

      incrementalDom.elementClose('tr');
      incrementalDom.elementClose('thead');
      incrementalDom.elementOpen('tbody');
      var row2442List = rows;
      var row2442ListLen = row2442List.length;

      for (var row2442Index = 0; row2442Index < row2442ListLen; row2442Index++) {
        var row2442Data = row2442List[row2442Index];

        if (row2442Data.value) {
          incrementalDom.elementOpenStart('tr');
          incrementalDom.attr('name', row2442Data.value);
          incrementalDom.elementOpenEnd();
          incrementalDom.elementOpen('td');
          soyIdom.print(row2442Data.label);
          incrementalDom.elementClose('td');
          var column2438List = columns;
          var column2438ListLen = column2438List.length;

          for (var column2438Index = 0; column2438Index < column2438ListLen; column2438Index++) {
            var column2438Data = column2438List[column2438Index];

            if (column2438Data.value) {
              incrementalDom.elementOpen('td');

              var inputAttributes__soy2404 = function inputAttributes__soy2404() {
                incrementalDom.attr('aria-label', rowText + ': ' + row2442Data.label + ', ' + columnText + ': ' + column2438Data.label);

                if (column2438Data.value == value[row2442Data.value]) {
                  incrementalDom.attr('checked', '');
                }

                incrementalDom.attr('class', 'form-builder-grid-field');
                incrementalDom.attr('data-onblur', _handleFieldBlurred);
                incrementalDom.attr('data-onchange', _handleFieldChanged);
                incrementalDom.attr('data-onfocus', _handleFieldFocused);
                incrementalDom.attr('data-row-index', column2438Index);

                if (disabled) {
                  incrementalDom.attr('disabled', '');
                }

                incrementalDom.attr('name', row2442Data.value);
                incrementalDom.attr('type', 'radio');
                incrementalDom.attr('value', column2438Data.value);
              };

              incrementalDom.elementOpenStart('input');
              inputAttributes__soy2404();
              incrementalDom.elementOpenEnd();
              incrementalDom.elementClose('input');
              incrementalDom.elementClose('td');
            }
          }

          incrementalDom.elementClose('tr');
        }
      }

      incrementalDom.elementClose('tbody');
      incrementalDom.elementClose('table');
      incrementalDom.elementClose('div');
    }

    exports.content = $content;
    /**
     * @typedef {{
     *  columns: !Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>,
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  rows: !Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>,
     *  value: (?),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  columnText: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  disabled: (boolean|null|undefined),
     *  readOnly: (boolean|null|undefined),
     *  rowText: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }}
     */

    $content.Params;

    if (goog.DEBUG) {
      $content.soyTemplateName = 'Grid.content';
    }
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  rows: !Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>,
     *  value: (?)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $hidden_grid(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>} */

      var rows = soy.asserts.assertType(goog.isArray(opt_data.rows), 'rows', opt_data.rows, '!Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>');
      /** @type {?} */

      var value = opt_data.value;
      var row2461List = rows;
      var row2461ListLen = row2461List.length;

      for (var row2461Index = 0; row2461Index < row2461ListLen; row2461Index++) {
        var row2461Data = row2461List[row2461Index];
        var inputValue__soy2451 = value[row2461Data.value] ? row2461Data.value + ';' + value[row2461Data.value] : '';
        incrementalDom.elementOpenStart('input');
        incrementalDom.attr('aria-hidden', 'true');
        incrementalDom.attr('class', 'form-control');
        incrementalDom.attr('name', name);
        incrementalDom.attr('type', 'hidden');

        if (inputValue__soy2451) {
          incrementalDom.attr('value', inputValue__soy2451);
        }

        incrementalDom.elementOpenEnd();
        incrementalDom.elementClose('input');
      }
    }

    exports.hidden_grid = $hidden_grid;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  rows: !Array<{label: (!goog.soy.data.SanitizedContent|string), value: (?)}>,
     *  value: (?)
     * }}
     */

    $hidden_grid.Params;

    if (goog.DEBUG) {
      $hidden_grid.soyTemplateName = 'Grid.hidden_grid';
    }

    exports.render.params = ["columns", "name", "rows", "value", "_handleFieldBlurred", "_handleFieldChanged", "_handleFieldFocused", "columnText", "displayErrors", "errorMessage", "id", "label", "placeholder", "readOnly", "repeatable", "required", "rowText", "showLabel", "spritemap", "tip", "type", "valid", "visible"];
    exports.render.types = {
      "columns": "list<[label: string, value: ?]>",
      "name": "string",
      "rows": "list<[label: string, value: ?]>",
      "value": "?",
      "_handleFieldBlurred": "any",
      "_handleFieldChanged": "any",
      "_handleFieldFocused": "any",
      "columnText": "string",
      "displayErrors": "bool",
      "errorMessage": "string",
      "id": "string",
      "label": "string",
      "placeholder": "string",
      "readOnly": "bool",
      "repeatable": "bool",
      "required": "bool",
      "rowText": "string",
      "showLabel": "bool",
      "spritemap": "string",
      "tip": "string",
      "type": "string",
      "valid": "bool",
      "visible": "bool"
    };
    exports.content.params = ["columns", "name", "rows", "value", "_handleFieldBlurred", "_handleFieldChanged", "_handleFieldFocused", "columnText", "disabled", "readOnly", "rowText"];
    exports.content.types = {
      "columns": "list<[label: string, value: ?]>",
      "name": "string",
      "rows": "list<[label: string, value: ?]>",
      "value": "?",
      "_handleFieldBlurred": "any",
      "_handleFieldChanged": "any",
      "_handleFieldFocused": "any",
      "columnText": "string",
      "disabled": "bool",
      "readOnly": "bool",
      "rowText": "string"
    };
    exports.hidden_grid.params = ["name", "rows", "value"];
    exports.hidden_grid.types = {
      "name": "string",
      "rows": "list<[label: string, value: ?]>",
      "value": "?"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var Grid = /*#__PURE__*/function (_Component) {
    _inherits(Grid, _Component);

    function Grid() {
      _classCallCheck(this, Grid);

      return _possibleConstructorReturn(this, _getPrototypeOf(Grid).apply(this, arguments));
    }

    return Grid;
  }(_metalComponent["default"]);

  exports.Grid = Grid;

  _metalSoy["default"].register(Grid, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=Grid.soy.js.map
});
//# sourceMappingURL=Grid.soy.js.map