Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/KeyValue/KeyValue.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.KeyValue = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from KeyValue.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace KeyValue.
     * @public
     */

    goog.module('KeyValue.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    goog.require('goog.string');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy.asserts');

    goog.require('soy.idom');

    var $templateAlias1 = _metalSoy["default"].getTemplate('FieldBase.incrementaldom', 'render');

    var $templateAlias2 = _metalSoy["default"].getTemplate('Text.incrementaldom', 'render');
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleKeywordInputBlurred: (*|null|undefined),
     *  _handleKeywordInputChanged: (*|null|undefined),
     *  _handleValueInputBlurred: (*|null|undefined),
     *  _handleValueInputEdited: (*|null|undefined),
     *  _handleValueInputFocused: (*|null|undefined),
     *  _keyword: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  _value: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  keywordReadOnly: (boolean|null|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  visible: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {*|null|undefined} */

      var _handleKeywordInputBlurred = opt_data._handleKeywordInputBlurred;
      /** @type {*|null|undefined} */

      var _handleKeywordInputChanged = opt_data._handleKeywordInputChanged;
      /** @type {*|null|undefined} */

      var _handleValueInputBlurred = opt_data._handleValueInputBlurred;
      /** @type {*|null|undefined} */

      var _handleValueInputEdited = opt_data._handleValueInputEdited;
      /** @type {*|null|undefined} */

      var _handleValueInputFocused = opt_data._handleValueInputFocused;
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var _keyword = soy.asserts.assertType(opt_data._keyword == null || goog.isString(opt_data._keyword) || opt_data._keyword instanceof goog.soy.data.SanitizedContent, '_keyword', opt_data._keyword, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var _value = soy.asserts.assertType(opt_data._value == null || goog.isString(opt_data._value) || opt_data._value instanceof goog.soy.data.SanitizedContent, '_value', opt_data._value, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var displayErrors = soy.asserts.assertType(opt_data.displayErrors == null || goog.isBoolean(opt_data.displayErrors) || opt_data.displayErrors === 1 || opt_data.displayErrors === 0, 'displayErrors', opt_data.displayErrors, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var errorMessage = soy.asserts.assertType(opt_data.errorMessage == null || goog.isString(opt_data.errorMessage) || opt_data.errorMessage instanceof goog.soy.data.SanitizedContent, 'errorMessage', opt_data.errorMessage, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var id = soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var keywordReadOnly = soy.asserts.assertType(opt_data.keywordReadOnly == null || goog.isBoolean(opt_data.keywordReadOnly) || opt_data.keywordReadOnly === 1 || opt_data.keywordReadOnly === 0, 'keywordReadOnly', opt_data.keywordReadOnly, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var label = soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var placeholder = soy.asserts.assertType(opt_data.placeholder == null || goog.isString(opt_data.placeholder) || opt_data.placeholder instanceof goog.soy.data.SanitizedContent, 'placeholder', opt_data.placeholder, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var repeatable = soy.asserts.assertType(opt_data.repeatable == null || goog.isBoolean(opt_data.repeatable) || opt_data.repeatable === 1 || opt_data.repeatable === 0, 'repeatable', opt_data.repeatable, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var required = soy.asserts.assertType(opt_data.required == null || goog.isBoolean(opt_data.required) || opt_data.required === 1 || opt_data.required === 0, 'required', opt_data.required, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showLabel = soy.asserts.assertType(opt_data.showLabel == null || goog.isBoolean(opt_data.showLabel) || opt_data.showLabel === 1 || opt_data.showLabel === 0, 'showLabel', opt_data.showLabel, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var spritemap = soy.asserts.assertType(opt_data.spritemap == null || goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tip = soy.asserts.assertType(opt_data.tip == null || goog.isString(opt_data.tip) || opt_data.tip instanceof goog.soy.data.SanitizedContent, 'tip', opt_data.tip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var valid = soy.asserts.assertType(opt_data.valid == null || goog.isBoolean(opt_data.valid) || opt_data.valid === 1 || opt_data.valid === 0, 'valid', opt_data.valid, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var visible = soy.asserts.assertType(opt_data.visible == null || goog.isBoolean(opt_data.visible) || opt_data.visible === 1 || opt_data.visible === 0, 'visible', opt_data.visible, 'boolean|null|undefined');

      var param2605 = function param2605() {
        $content({
          _handleKeywordInputBlurred: _handleKeywordInputBlurred,
          _handleKeywordInputChanged: _handleKeywordInputChanged,
          _handleValueInputBlurred: _handleValueInputBlurred,
          _handleValueInputEdited: _handleValueInputEdited,
          _handleValueInputFocused: _handleValueInputFocused,
          id: id,
          keyword: _keyword,
          keywordReadOnly: keywordReadOnly,
          name: name,
          placeholder: placeholder,
          readOnly: readOnly,
          required: required,
          showLabel: showLabel,
          spritemap: spritemap,
          value: _value
        }, null, opt_ijData);
      };

      $templateAlias1({
        contentRenderer: param2605,
        displayErrors: displayErrors,
        errorMessage: errorMessage,
        id: id,
        label: label,
        name: name,
        repeatable: repeatable,
        required: required,
        showLabel: showLabel,
        spritemap: spritemap,
        tip: tip,
        valid: valid,
        visible: visible
      }, null, opt_ijData);
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleKeywordInputBlurred: (*|null|undefined),
     *  _handleKeywordInputChanged: (*|null|undefined),
     *  _handleValueInputBlurred: (*|null|undefined),
     *  _handleValueInputEdited: (*|null|undefined),
     *  _handleValueInputFocused: (*|null|undefined),
     *  _keyword: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  _value: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  keywordReadOnly: (boolean|null|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  visible: (boolean|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'KeyValue.render';
    }
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleKeywordInputBlurred: (*|null|undefined),
     *  _handleKeywordInputChanged: (*|null|undefined),
     *  _handleValueInputBlurred: (*|null|undefined),
     *  _handleValueInputEdited: (*|null|undefined),
     *  _handleValueInputFocused: (*|null|undefined),
     *  keyword: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  keywordReadOnly: (boolean|null|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  value: (?)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $content(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {*|null|undefined} */

      var _handleKeywordInputBlurred = opt_data._handleKeywordInputBlurred;
      /** @type {*|null|undefined} */

      var _handleKeywordInputChanged = opt_data._handleKeywordInputChanged;
      /** @type {*|null|undefined} */

      var _handleValueInputBlurred = opt_data._handleValueInputBlurred;
      /** @type {*|null|undefined} */

      var _handleValueInputEdited = opt_data._handleValueInputEdited;
      /** @type {*|null|undefined} */

      var _handleValueInputFocused = opt_data._handleValueInputFocused;
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var keyword = soy.asserts.assertType(opt_data.keyword == null || goog.isString(opt_data.keyword) || opt_data.keyword instanceof goog.soy.data.SanitizedContent, 'keyword', opt_data.keyword, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var keywordReadOnly = soy.asserts.assertType(opt_data.keywordReadOnly == null || goog.isBoolean(opt_data.keywordReadOnly) || opt_data.keywordReadOnly === 1 || opt_data.keywordReadOnly === 0, 'keywordReadOnly', opt_data.keywordReadOnly, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var placeholder = soy.asserts.assertType(opt_data.placeholder == null || goog.isString(opt_data.placeholder) || opt_data.placeholder instanceof goog.soy.data.SanitizedContent, 'placeholder', opt_data.placeholder, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var required = soy.asserts.assertType(opt_data.required == null || goog.isBoolean(opt_data.required) || opt_data.required === 1 || opt_data.required === 0, 'required', opt_data.required, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showLabel = soy.asserts.assertType(opt_data.showLabel == null || goog.isBoolean(opt_data.showLabel) || opt_data.showLabel === 1 || opt_data.showLabel === 0, 'showLabel', opt_data.showLabel, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var spritemap = soy.asserts.assertType(opt_data.spritemap == null || goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {?} */

      var value = opt_data.value;
      $templateAlias2({
        events: {
          fieldBlurred: _handleValueInputBlurred,
          fieldEdited: _handleValueInputEdited,
          fieldFocused: _handleValueInputFocused
        },
        name: 'keyValueLabel' + name,
        placeholder: placeholder,
        readOnly: readOnly,
        ref: 'keyValueLabel' + name,
        required: required,
        showLabel: showLabel,
        spritemap: spritemap,
        value: value
      }, null, opt_ijData);
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'active form-text key-value-editor');
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpenStart('label');
      incrementalDom.attr('class', 'control-label key-value-label');
      incrementalDom.elementOpenEnd();
      /** @desc  */

      var MSG_EXTERNAL_353058633740163780 = Liferay.Language.get('field-name');
      incrementalDom.text(goog.string.unescapeEntities(MSG_EXTERNAL_353058633740163780));
      incrementalDom.text(':');
      incrementalDom.elementClose('label');
      incrementalDom.elementOpenStart('input');
      incrementalDom.attr('class', 'key-value-input');
      incrementalDom.attr('data-onblur', _handleKeywordInputBlurred);
      incrementalDom.attr('data-oninput', _handleKeywordInputChanged);

      if (keywordReadOnly) {
        incrementalDom.attr('readOnly', '');
      }

      incrementalDom.attr('type', 'text');
      incrementalDom.attr('value', keyword);
      incrementalDom.elementOpenEnd();
      incrementalDom.elementClose('input');
      incrementalDom.elementClose('div');
    }

    exports.content = $content;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleKeywordInputBlurred: (*|null|undefined),
     *  _handleKeywordInputChanged: (*|null|undefined),
     *  _handleValueInputBlurred: (*|null|undefined),
     *  _handleValueInputEdited: (*|null|undefined),
     *  _handleValueInputFocused: (*|null|undefined),
     *  keyword: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  keywordReadOnly: (boolean|null|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  value: (?)
     * }}
     */

    $content.Params;

    if (goog.DEBUG) {
      $content.soyTemplateName = 'KeyValue.content';
    }

    exports.render.params = ["name", "_handleKeywordInputBlurred", "_handleKeywordInputChanged", "_handleValueInputBlurred", "_handleValueInputEdited", "_handleValueInputFocused", "_keyword", "_value", "displayErrors", "errorMessage", "id", "keywordReadOnly", "label", "placeholder", "readOnly", "repeatable", "required", "showLabel", "spritemap", "tip", "valid", "visible"];
    exports.render.types = {
      "name": "string",
      "_handleKeywordInputBlurred": "any",
      "_handleKeywordInputChanged": "any",
      "_handleValueInputBlurred": "any",
      "_handleValueInputEdited": "any",
      "_handleValueInputFocused": "any",
      "_keyword": "string",
      "_value": "string",
      "displayErrors": "bool",
      "errorMessage": "string",
      "id": "string",
      "keywordReadOnly": "bool",
      "label": "string",
      "placeholder": "string",
      "readOnly": "bool",
      "repeatable": "bool",
      "required": "bool",
      "showLabel": "bool",
      "spritemap": "string",
      "tip": "string",
      "valid": "bool",
      "visible": "bool"
    };
    exports.content.params = ["name", "_handleKeywordInputBlurred", "_handleKeywordInputChanged", "_handleValueInputBlurred", "_handleValueInputEdited", "_handleValueInputFocused", "keyword", "keywordReadOnly", "placeholder", "readOnly", "required", "showLabel", "spritemap", "value"];
    exports.content.types = {
      "name": "string",
      "_handleKeywordInputBlurred": "any",
      "_handleKeywordInputChanged": "any",
      "_handleValueInputBlurred": "any",
      "_handleValueInputEdited": "any",
      "_handleValueInputFocused": "any",
      "keyword": "string",
      "keywordReadOnly": "bool",
      "placeholder": "string",
      "readOnly": "bool",
      "required": "bool",
      "showLabel": "bool",
      "spritemap": "string",
      "value": "?"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var KeyValue = /*#__PURE__*/function (_Component) {
    _inherits(KeyValue, _Component);

    function KeyValue() {
      _classCallCheck(this, KeyValue);

      return _possibleConstructorReturn(this, _getPrototypeOf(KeyValue).apply(this, arguments));
    }

    return KeyValue;
  }(_metalComponent["default"]);

  exports.KeyValue = KeyValue;

  _metalSoy["default"].register(KeyValue, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=KeyValue.soy.js.map
});
//# sourceMappingURL=KeyValue.soy.js.map