Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Numeric/Numeric.es", ['module', 'exports', 'require', '../FieldBase/FieldBase.es', './NumericRegister.soy', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', 'dynamic-data-mapping-form-field-type$text-mask-addons/dist/createNumberMask', 'dynamic-data-mapping-form-field-type$vanilla-text-mask', './Numeric.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("../FieldBase/FieldBase.es");

  require("./NumericRegister.soy");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _createNumberMask = _interopRequireDefault(require("dynamic-data-mapping-form-field-type$text-mask-addons/dist/createNumberMask"));

  var _vanillaTextMask = _interopRequireDefault(require("dynamic-data-mapping-form-field-type$vanilla-text-mask"));

  var _Numeric = _interopRequireDefault(require("./Numeric.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });keys.push.apply(keys, symbols);
    }return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var Numeric = /*#__PURE__*/function (_Component) {
    _inherits(Numeric, _Component);

    function Numeric() {
      _classCallCheck(this, Numeric);

      return _possibleConstructorReturn(this, _getPrototypeOf(Numeric).apply(this, arguments));
    }

    _createClass(Numeric, [{
      key: "applyMask",
      value: function applyMask() {
        var dataType = this.dataType,
            element = this.element,
            symbols = this.symbols;
        var inputElement = element.querySelector('input');
        var value = inputElement.value;

        if (dataType === 'integer' && value) {
          inputElement.value = Math.round(value.replace(symbols.decimalSymbol, '.'));
        }

        var mask = (0, _createNumberMask["default"])(this.getMaskConfig(dataType));
        this.maskInstance = (0, _vanillaTextMask["default"])({
          inputElement: inputElement,
          mask: mask
        });
        this.setState({
          value: inputElement.value
        });
      }
    }, {
      key: "disposed",
      value: function disposed() {
        this.disposeMask();
      }
    }, {
      key: "disposeMask",
      value: function disposeMask() {
        if (this.maskInstance) {
          this.maskInstance.destroy();
        }
      }
    }, {
      key: "getMaskConfig",
      value: function getMaskConfig(dataType) {
        var symbols = this.symbols;
        var config = {
          allowLeadingZeroes: true,
          includeThousandsSeparator: false,
          prefix: ''
        };

        if (dataType === 'double') {
          config = _objectSpread({}, config, {
            allowDecimal: true,
            decimalLimit: null,
            decimalSymbol: symbols.decimalSymbol
          });
        }

        return config;
      }
    }, {
      key: "syncDataType",
      value: function syncDataType() {
        var visible = this.visible;
        this.syncVisible(visible);
      }
    }, {
      key: "syncVisible",
      value: function syncVisible(visible) {
        if (visible) {
          this.applyMask();
        } else {
          this.disposeMask();
        }
      }
    }, {
      key: "willReceiveState",
      value: function willReceiveState(changes) {
        if (changes.value) {
          this.setState({
            _value: changes.value.newVal
          });
        }
      }
    }, {
      key: "_handleFieldBlurred",
      value: function _handleFieldBlurred(event) {
        this.emit('fieldBlurred', {
          fieldInstance: this,
          originalEvent: event,
          value: event.target.value
        });
      }
    }, {
      key: "_handleFieldChanged",
      value: function _handleFieldChanged(event) {
        var _this = this;

        var value = event.target.value;

        if (value.substr(-1) === this.symbols.decimalSymbol) {
          return;
        }

        this.setState({
          value: value
        }, function () {
          return _this.emit('fieldEdited', {
            fieldInstance: _this,
            originalEvent: event,
            value: value
          });
        });
      }
    }, {
      key: "_handleFieldFocused",
      value: function _handleFieldFocused(event) {
        this.emit('fieldFocused', {
          fieldInstance: this,
          originalEvent: event,
          value: event.target.value
        });
      }
    }, {
      key: "_internalValueFn",
      value: function _internalValueFn() {
        var value = this.value;
        return value;
      }
    }]);

    return Numeric;
  }(_metalComponent["default"]);

  Numeric.STATE = {
    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    _value: _metalState.Config.oneOfType([_metalState.Config.number(), _metalState.Config.string()]).internal().valueFn('_internalValueFn'),

    /**
     * @default 'integer'
     * @instance
     * @memberof Numeric
     * @type {string}
     */
    dataType: _metalState.Config.string().value('integer'),

    /**
     * @default false
     * @instance
     * @memberof Numeric
     * @type {?bool}
     */
    evaluable: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof Numeric
     * @type {?(string|undefined)}
     */
    fieldName: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Numeric
     * @type {?(string|undefined)}
     */
    id: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Numeric
     * @type {?(string|undefined)}
     */
    label: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Numeric
     * @type {?(string|undefined)}
     */
    name: _metalState.Config.string().required(),

    /**
     * @default undefined
     * @instance
     * @memberof Numeric
     * @type {?(string|undefined)}
     */
    placeholder: _metalState.Config.string(),

    /**
     * @instance
     * @memberof Numeric
     * @type {?(string)}
     */
    predefinedValue: _metalState.Config.oneOfType([_metalState.Config.number(), _metalState.Config.string()]),

    /**
     * @default false
     * @instance
     * @memberof Numeric
     * @type {?bool}
     */
    readOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(bool|undefined)}
     */
    repeatable: _metalState.Config.bool(),

    /**
     * @default false
     * @instance
     * @memberof Numeric
     * @type {?(bool|undefined)}
     */
    required: _metalState.Config.bool().value(false),

    /**
     * @default true
     * @instance
     * @memberof Numeric
     * @type {?(bool|undefined)}
     */
    showLabel: _metalState.Config.bool().value(true),

    /**
     * @default undefined
     * @instance
     * @memberof Numeric
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default object
     * @instance
     * @memberof Numeric
     * @type {object}
     */
    symbols: _metalState.Config.shapeOf({
      decimalSymbol: _metalState.Config.string(),
      thousandsSeparator: _metalState.Config.string()
    }).value({
      decimalSymbol: '.',
      thousandsSeparator: ','
    }),

    /**
     * @default undefined
     * @instance
     * @memberof Numeric
     * @type {?(string|undefined)}
     */
    tip: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(string|undefined)}
     */
    tooltip: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    type: _metalState.Config.string().value('numeric'),

    /**
     * @default undefined
     * @instance
     * @memberof Numeric
     * @type {?(string|undefined)}
     */
    value: _metalState.Config.oneOfType([_metalState.Config.number(), _metalState.Config.string()])
  };

  _metalSoy["default"].register(Numeric, _Numeric["default"]);

  var _default = Numeric;
  exports["default"] = _default;
  //# sourceMappingURL=Numeric.es.js.map
});
//# sourceMappingURL=Numeric.es.js.map