Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Radio/Radio.es", ['module', 'exports', 'require', '../FieldBase/FieldBase.es', './RadioRegister.soy', 'frontend-taglib-clay$clay-radio', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', '../util/setters.es', '../util/strings.es', './Radio.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("../FieldBase/FieldBase.es");

  require("./RadioRegister.soy");

  require("frontend-taglib-clay$clay-radio");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _setters = require("../util/setters.es");

  var _strings = require("../util/strings.es");

  var _Radio = _interopRequireDefault(require("./Radio.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });keys.push.apply(keys, symbols);
    }return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  /**
   * Radio.
   * @extends Component
   */
  var Radio = /*#__PURE__*/function (_Component) {
    _inherits(Radio, _Component);

    function Radio() {
      _classCallCheck(this, Radio);

      return _possibleConstructorReturn(this, _getPrototypeOf(Radio).apply(this, arguments));
    }

    _createClass(Radio, [{
      key: "prepareStateForRender",
      value: function prepareStateForRender(state) {
        var options = state.options,
            predefinedValue = state.predefinedValue;

        var predefinedValueArray = this._getArrayValue(predefinedValue);

        var escapedOptions = options.map(function (option) {
          return _objectSpread({}, option, {
            label: (0, _strings.htmlEscape)(option.label)
          });
        });
        return _objectSpread({}, state, {
          options: escapedOptions,
          predefinedValue: predefinedValueArray[0] || ''
        });
      }
    }, {
      key: "_getArrayValue",
      value: function _getArrayValue(value) {
        var newValue = value || '';

        if (!Array.isArray(newValue)) {
          newValue = [newValue];
        }

        return newValue;
      }
    }, {
      key: "_handleFieldBlurred",
      value: function _handleFieldBlurred() {
        this.emit('fieldBlurred', {
          fieldInstance: this,
          originalEvent: window.event,
          value: window.event.target.value
        });
      }
    }, {
      key: "_handleFieldFocused",
      value: function _handleFieldFocused(event) {
        this.emit('fieldFocused', {
          fieldInstance: this,
          originalEvent: event
        });
      }
    }, {
      key: "_handleValueChanged",
      value: function _handleValueChanged(event) {
        this.emit('fieldEdited', {
          fieldInstance: this,
          originalEvent: event,
          value: event.target.value
        });
      }
    }]);

    return Radio;
  }(_metalComponent["default"]);

  Radio.STATE = {
    /**
     * @default 'string'
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    dataType: _metalState.Config.string().value('string'),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?bool}
     */
    evaluable: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof Radio
     * @type {?(string|undefined)}
     */
    fieldName: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Radio
     * @type {?(string|undefined)}
     */
    inline: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof Radio
     * @type {?(string|undefined)}
     */
    label: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Radio
     * @type {?(string|undefined)}
     */
    options: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
      label: _metalState.Config.string(),
      name: _metalState.Config.string(),
      value: _metalState.Config.string()
    })).value([{
      label: 'Option 1'
    }, {
      label: 'Option 2'
    }]),

    /**
     * @default Choose an Option
     * @instance
     * @memberof Radio
     * @type {?string}
     */
    predefinedValue: _metalState.Config.oneOfType([_metalState.Config.array(), _metalState.Config.object(), _metalState.Config.string()]).setter(_setters.setJSONArrayValue).value([]),

    /**
     * @default false
     * @instance
     * @memberof Radio
     * @type {?bool}
     */
    readOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @instance
     * @memberof FieldBase
     * @type {?(bool|undefined)}
     */
    repeatable: _metalState.Config.bool(),

    /**
     * @default false
     * @instance
     * @memberof Radio
     * @type {?bool}
     */
    required: _metalState.Config.bool().value(false),

    /**
     * @default true
     * @instance
     * @memberof Radio
     * @type {?bool}
     */
    showLabel: _metalState.Config.bool().value(true),

    /**
     * @default undefined
     * @instance
     * @memberof Radio
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Radio
     * @type {?(string|undefined)}
     */
    tip: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof Text
     * @type {?(string|undefined)}
     */
    type: _metalState.Config.string().value('radio'),

    /**
     * @default undefined
     * @instance
     * @memberof Radio
     * @type {?(string|undefined)}
     */
    value: _metalState.Config.string()
  };

  _metalSoy["default"].register(Radio, _Radio["default"]);

  var _default = Radio;
  exports["default"] = _default;
  //# sourceMappingURL=Radio.es.js.map
});
//# sourceMappingURL=Radio.es.js.map