Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Select/Select.es", ['module', 'exports', 'require', '../FieldBase/FieldBase.es', '../Text/Text.es', './SelectRegister.soy', './SingleSelectedOption.soy', 'frontend-taglib-clay$clay-dropdown', 'frontend-taglib-clay$clay-icon', 'frontend-taglib-clay$clay-label', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-dom', 'frontend-js-metal-web$metal-events', 'frontend-js-metal-web$metal-soy', 'frontend-js-metal-web$metal-state', '../util/setters.es', './Select.soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  require("../FieldBase/FieldBase.es");

  require("../Text/Text.es");

  require("./SelectRegister.soy");

  require("./SingleSelectedOption.soy");

  require("frontend-taglib-clay$clay-dropdown");

  require("frontend-taglib-clay$clay-icon");

  require("frontend-taglib-clay$clay-label");

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalDom = _interopRequireDefault(require("frontend-js-metal-web$metal-dom"));

  var _metalEvents = require("frontend-js-metal-web$metal-events");

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _setters = require("../util/setters.es");

  var _Select = _interopRequireDefault(require("./Select.soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });keys.push.apply(keys, symbols);
    }return keys;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }return target;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
    } else {
      obj[key] = value;
    }return obj;
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
  }

  function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
        arr2[i] = arr[i];
      }return arr2;
    }
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _get(target, property, receiver) {
    if (typeof Reflect !== "undefined" && Reflect.get) {
      _get = Reflect.get;
    } else {
      _get = function _get(target, property, receiver) {
        var base = _superPropBase(target, property);if (!base) return;var desc = Object.getOwnPropertyDescriptor(base, property);if (desc.get) {
          return desc.get.call(receiver);
        }return desc.value;
      };
    }return _get(target, property, receiver || target);
  }

  function _superPropBase(object, property) {
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
      object = _getPrototypeOf(object);if (object === null) break;
    }return object;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var Select = /*#__PURE__*/function (_Component) {
    _inherits(Select, _Component);

    function Select() {
      _classCallCheck(this, Select);

      return _possibleConstructorReturn(this, _getPrototypeOf(Select).apply(this, arguments));
    }

    _createClass(Select, [{
      key: "addValue",
      value: function addValue(value) {
        var currentValue = this._getArrayValue(this.value);

        var newValue = _toConsumableArray(currentValue);

        if (value) {
          newValue.push(value);
        }

        return newValue;
      }
    }, {
      key: "attached",
      value: function attached() {
        this._eventHandler = new _metalEvents.EventHandler();

        this._eventHandler.add(_metalDom["default"].on(document, 'click', this._handleDocumentClicked.bind(this)));
      }
    }, {
      key: "deleteValue",
      value: function deleteValue(value) {
        var currentValue = this._getArrayValue(this.value);

        return currentValue.filter(function (v) {
          return v !== value;
        });
      }
    }, {
      key: "disposeInternal",
      value: function disposeInternal() {
        _get(_getPrototypeOf(Select.prototype), "disposeInternal", this).call(this);

        this._eventHandler.removeAllListeners();
      }
    }, {
      key: "prepareStateForRender",
      value: function prepareStateForRender(state) {
        var _this = this;

        var predefinedValue = state.predefinedValue,
            value = state.value;
        var fixedOptions = this.fixedOptions,
            multiple = this.multiple,
            options = this.options,
            showEmptyOption = this.showEmptyOption;

        var predefinedValueArray = this._getArrayValue(predefinedValue);

        var valueArray = this._getArrayValue(value);

        valueArray = this._isEmptyArray(valueArray) ? predefinedValueArray : valueArray;
        valueArray = valueArray.filter(function (value, index) {
          return multiple ? true : index === 0;
        });

        var newOptions = _toConsumableArray(options).map(function (option, index) {
          return _objectSpread({}, _this._prepareOption(option, valueArray), {
            separator: fixedOptions.length > 0 && index === options.length - 1
          });
        }).concat(fixedOptions.map(function (option) {
          return _this._prepareOption(option, valueArray);
        })).filter(function (_ref) {
          var value = _ref.value;
          return value !== '';
        });

        if (!multiple && showEmptyOption) {
          var emptyOption = {
            label: Liferay.Language.get('choose-an-option'),
            value: ''
          };
          newOptions = [emptyOption].concat(_toConsumableArray(newOptions));
        }

        return _objectSpread({}, state, {
          options: newOptions,
          value: valueArray.filter(function (value) {
            return newOptions.some(function (option) {
              return value === option.value;
            });
          })
        });
      }
    }, {
      key: "setValue",
      value: function setValue(value) {
        var newValue = [];

        if (value) {
          newValue.push(value);
        }

        return newValue;
      }
    }, {
      key: "_getArrayValue",
      value: function _getArrayValue(value) {
        var newValue = value || '';

        if (!Array.isArray(newValue)) {
          newValue = [newValue];
        }

        return newValue;
      }
    }, {
      key: "_handleDocumentClicked",
      value: function _handleDocumentClicked(_ref2) {
        var target = _ref2.target;
        var base = this.refs.base;
        var dropdown = base.refs.dropdown;

        if (dropdown) {
          var menu = dropdown.refs.portal.refs.menu;
          var expanded = this.expanded;

          if (expanded && !this.element.contains(target) && !dropdown.element.contains(target) && !menu.contains(target)) {
            this.setState({
              expanded: false
            });
          }
        }
      }
    }, {
      key: "_handleExpandedChanged",
      value: function _handleExpandedChanged(_ref3) {
        var newVal = _ref3.newVal;

        if (newVal) {
          this.emit('fieldFocused', {
            fieldInstance: this,
            originalEvent: window.event
          });
        } else {
          this.emit('fieldBlurred', {
            fieldInstance: this,
            originalEvent: window.event
          });
        }

        this.expanded = newVal;
      }
    }, {
      key: "_handleItemClicked",
      value: function _handleItemClicked(_ref4) {
        var _this2 = this;

        var data = _ref4.data,
            preventDefault = _ref4.preventDefault;
        var multiple = this.multiple;

        var currentValue = this._getArrayValue(this.value);

        var itemValue = data.item.value;
        var newValue;

        if (multiple) {
          if (currentValue.includes(itemValue)) {
            newValue = this.deleteValue(itemValue);

            if (document.activeElement) {
              document.activeElement.blur();
            }
          } else {
            newValue = this.addValue(itemValue);
          }
        } else {
          newValue = this.setValue(itemValue);
        }

        preventDefault();
        var selectElement = document.getElementById(this.name);

        if (selectElement && selectElement.parentElement) {
          selectElement = selectElement.parentElement;
          selectElement.focus();
        }

        this.setState({
          expanded: multiple,
          value: newValue
        }, function () {
          return _this2.emit('fieldEdited', {
            fieldInstance: _this2,
            value: newValue
          });
        });
      }
    }, {
      key: "_handleLabelClosed",
      value: function _handleLabelClosed(_ref5) {
        var _this3 = this;

        var preventDefault = _ref5.preventDefault,
            stopPropagation = _ref5.stopPropagation,
            target = _ref5.target;
        var value = target.data.value;
        preventDefault();
        stopPropagation();
        var newValue = this.deleteValue(value);
        this.setState({
          value: newValue
        }, function () {
          return _this3.emit('fieldEdited', {
            fieldInstance: _this3,
            value: newValue
          });
        });
      }
    }, {
      key: "_isEmptyArray",
      value: function _isEmptyArray(array) {
        return array.some(function (value) {
          return value !== '';
        }) === false;
      }
    }, {
      key: "_prepareOption",
      value: function _prepareOption(option, valueArray) {
        var multiple = this.multiple;
        var included = valueArray.includes(option.value);
        return _objectSpread({}, option, {
          active: !multiple && included,
          checked: multiple && included,
          label: Liferay.Util.escape(option.label),
          type: multiple ? 'checkbox' : 'item'
        });
      }
    }]);

    return Select;
  }(_metalComponent["default"]);

  Select.STATE = {
    /**
     * @default 'string'
     * @memberof Select
     * @type {?(string|undefined)}
     */
    dataSourceType: _metalState.Config.string(),

    /**
     * @default 'string'
     * @memberof Select
     * @type {?(string|undefined)}
     */
    dataType: _metalState.Config.string().value('string'),

    /**
     * @default false
     * @memberof Select
     * @type {?(boolean|undefined)}
     */
    evaluable: _metalState.Config.bool().value(false),

    /**
     * @default false
     * @memberof Select
     * @type {?bool}
     */
    expanded: _metalState.Config.bool().internal().value(false),

    /**
     * @default undefined
     * @memberof Text
     * @type {?(string|undefined)}
     */
    fieldName: _metalState.Config.string(),

    /**
     * @default []
     * @memberof Select
     * @type {?array<object>}
     */
    fixedOptions: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
      active: _metalState.Config.bool().value(false),
      disabled: _metalState.Config.bool().value(false),
      id: _metalState.Config.string(),
      inline: _metalState.Config.bool().value(false),
      label: _metalState.Config.string(),
      name: _metalState.Config.string(),
      showLabel: _metalState.Config.bool().value(true),
      value: _metalState.Config.string()
    })).value([]),

    /**
     * @default undefined
     * @memberof Select
     * @type {?(string|undefined)}
     */
    label: _metalState.Config.string(),

    /**
     * @default undefined
     * @memberof Select
     * @type {?(string|undefined)}
     */
    multiple: _metalState.Config.bool(),

    /**
     * @default []
     * @memberof Select
     * @type {?array<object>}
     */
    options: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
      active: _metalState.Config.bool().value(false),
      disabled: _metalState.Config.bool().value(false),
      id: _metalState.Config.string(),
      inline: _metalState.Config.bool().value(false),
      label: _metalState.Config.string(),
      name: _metalState.Config.string(),
      showLabel: _metalState.Config.bool().value(true),
      value: _metalState.Config.string()
    })).value([]),

    /**
     * @default Choose an Option
     * @memberof Select
     * @type {?string}
     */
    placeholder: _metalState.Config.string(),

    /**
     * @default undefined
     * @memberof Select
     * @type {?string}
     */
    predefinedValue: _metalState.Config.oneOfType([_metalState.Config.array(), _metalState.Config.object(), _metalState.Config.string()]).setter(_setters.setJSONArrayValue).value([]),

    /**
     * @default false
     * @memberof Select
     * @type {?bool}
     */
    readOnly: _metalState.Config.bool().value(false),

    /**
     * @default undefined
     * @memberof FieldBase
     * @type {?(bool|undefined)}
     */
    repeatable: _metalState.Config.bool(),

    /**
     * @default false
     * @memberof Select
     * @type {?bool}
     */
    required: _metalState.Config.bool().value(false),

    /**
     * @default true
     * @memberof Select
     * @type {?bool}
     */
    showEmptyOption: _metalState.Config.bool().value(true),

    /**
     * @default false
     * @memberof Select
     * @type {?bool}
     */
    showLabel: _metalState.Config.bool().value(true),

    /**
     * @default undefined
     * @memberof Select
     * @type {?(string|undefined)}
     */
    spritemap: _metalState.Config.string(),

    /**
     * @default undefined
     * @memberof FieldBase
     * @type {?(string|undefined)}
     */
    tip: _metalState.Config.string(),

    /**
     * @default undefined
     * @memberof Text
     * @type {?(string|undefined)}
     */
    type: _metalState.Config.string().value('select'),

    /**
     * @default undefined
     * @memberof Select
     * @type {?(string|undefined)}
     */
    value: _metalState.Config.oneOfType([_metalState.Config.array(), _metalState.Config.object(), _metalState.Config.string()]).setter(_setters.setJSONArrayValue)
  };

  _metalSoy["default"].register(Select, _Select["default"]);

  var _default = Select;
  exports["default"] = _default;
  //# sourceMappingURL=Select.es.js.map
});
//# sourceMappingURL=Select.es.js.map