Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Select/Select.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.Select = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from Select.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace Select.
     * @public
     */

    goog.module('Select.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    goog.require('goog.string');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');

    var $templateAlias5 = _metalSoy["default"].getTemplate('ClayDropdownBase.incrementaldom', 'render');

    var $templateAlias4 = _metalSoy["default"].getTemplate('ClayIcon.incrementaldom', 'render');

    var $templateAlias2 = _metalSoy["default"].getTemplate('ClayLabel.incrementaldom', 'render');

    var $templateAlias1 = _metalSoy["default"].getTemplate('FieldBase.incrementaldom', 'render');

    var $templateAlias3 = _metalSoy["default"].getTemplate('SingleSelectedOption.incrementaldom', 'render');
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  value: (?),
     *  _handleExpandedChanged: (*|null|undefined),
     *  _handleItemClicked: (*|null|undefined),
     *  _handleLabelClosed: (*|null|undefined),
     *  dataSourceType: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  expanded: (boolean|null|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  multiple: (boolean|null|undefined),
     *  options: (!Array<?>|null|undefined),
     *  predefinedValue: (?),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  visible: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var spritemap = soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      /** @type {?} */

      var value = opt_data.value;
      /** @type {*|null|undefined} */

      var _handleExpandedChanged = opt_data._handleExpandedChanged;
      /** @type {*|null|undefined} */

      var _handleItemClicked = opt_data._handleItemClicked;
      /** @type {*|null|undefined} */

      var _handleLabelClosed = opt_data._handleLabelClosed;
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var dataSourceType = soy.asserts.assertType(opt_data.dataSourceType == null || goog.isString(opt_data.dataSourceType) || opt_data.dataSourceType instanceof goog.soy.data.SanitizedContent, 'dataSourceType', opt_data.dataSourceType, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var displayErrors = soy.asserts.assertType(opt_data.displayErrors == null || goog.isBoolean(opt_data.displayErrors) || opt_data.displayErrors === 1 || opt_data.displayErrors === 0, 'displayErrors', opt_data.displayErrors, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var errorMessage = soy.asserts.assertType(opt_data.errorMessage == null || goog.isString(opt_data.errorMessage) || opt_data.errorMessage instanceof goog.soy.data.SanitizedContent, 'errorMessage', opt_data.errorMessage, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var expanded = soy.asserts.assertType(opt_data.expanded == null || goog.isBoolean(opt_data.expanded) || opt_data.expanded === 1 || opt_data.expanded === 0, 'expanded', opt_data.expanded, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var id = soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var label = soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var multiple = soy.asserts.assertType(opt_data.multiple == null || goog.isBoolean(opt_data.multiple) || opt_data.multiple === 1 || opt_data.multiple === 0, 'multiple', opt_data.multiple, 'boolean|null|undefined');
      /** @type {!Array<?>|null|undefined} */

      var options = soy.asserts.assertType(opt_data.options == null || goog.isArray(opt_data.options), 'options', opt_data.options, '!Array<?>|null|undefined');
      /** @type {?} */

      var predefinedValue = opt_data.predefinedValue;
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var repeatable = soy.asserts.assertType(opt_data.repeatable == null || goog.isBoolean(opt_data.repeatable) || opt_data.repeatable === 1 || opt_data.repeatable === 0, 'repeatable', opt_data.repeatable, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var required = soy.asserts.assertType(opt_data.required == null || goog.isBoolean(opt_data.required) || opt_data.required === 1 || opt_data.required === 0, 'required', opt_data.required, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showLabel = soy.asserts.assertType(opt_data.showLabel == null || goog.isBoolean(opt_data.showLabel) || opt_data.showLabel === 1 || opt_data.showLabel === 0, 'showLabel', opt_data.showLabel, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tip = soy.asserts.assertType(opt_data.tip == null || goog.isString(opt_data.tip) || opt_data.tip instanceof goog.soy.data.SanitizedContent, 'tip', opt_data.tip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var valid = soy.asserts.assertType(opt_data.valid == null || goog.isBoolean(opt_data.valid) || opt_data.valid === 1 || opt_data.valid === 0, 'valid', opt_data.valid, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var visible = soy.asserts.assertType(opt_data.visible == null || goog.isBoolean(opt_data.visible) || opt_data.visible === 1 || opt_data.visible === 0, 'visible', opt_data.visible, 'boolean|null|undefined');
      var displayValues__soy3400 = value.length > 0 ? value : predefinedValue && predefinedValue.length > 0 ? predefinedValue : [];

      var param3403 = function param3403() {
        $content({
          _handleExpandedChanged: _handleExpandedChanged,
          _handleItemClicked: _handleItemClicked,
          _handleLabelClosed: _handleLabelClosed,
          dataSourceType: dataSourceType,
          displayValues: displayValues__soy3400,
          expanded: expanded,
          id: id,
          multiple: multiple,
          name: name,
          options: options,
          readOnly: readOnly,
          spritemap: spritemap,
          value: value
        }, null, opt_ijData);
      };

      $templateAlias1({
        contentRenderer: param3403,
        displayErrors: displayErrors,
        errorMessage: errorMessage,
        label: label,
        name: name,
        readOnly: readOnly,
        ref: 'base',
        repeatable: repeatable,
        required: required,
        showLabel: showLabel,
        spritemap: spritemap,
        tip: tip,
        valid: valid,
        visible: visible
      }, null, opt_ijData);
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  value: (?),
     *  _handleExpandedChanged: (*|null|undefined),
     *  _handleItemClicked: (*|null|undefined),
     *  _handleLabelClosed: (*|null|undefined),
     *  dataSourceType: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  expanded: (boolean|null|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  multiple: (boolean|null|undefined),
     *  options: (!Array<?>|null|undefined),
     *  predefinedValue: (?),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  visible: (boolean|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'Select.render';
    }
    /**
     * @param {{
     *  displayValues: (?),
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  value: !Array<!goog.soy.data.SanitizedContent|string>,
     *  _handleExpandedChanged: (*|null|undefined),
     *  _handleItemClicked: (*|null|undefined),
     *  _handleLabelClosed: (*|null|undefined),
     *  expanded: (boolean|null|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  multiple: (boolean|null|undefined),
     *  options: (!Array<?>|null|undefined),
     *  readOnly: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $content(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {?} */

      opt_data.displayValues;
      soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');

      /** @type {!goog.soy.data.SanitizedContent|string} */

      var spritemap = soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      /** @type {!Array<!goog.soy.data.SanitizedContent|string>} */

      var value = soy.asserts.assertType(goog.isArray(opt_data.value), 'value', opt_data.value, '!Array<!goog.soy.data.SanitizedContent|string>');
      /** @type {*|null|undefined} */

      var _handleExpandedChanged = opt_data._handleExpandedChanged;
      /** @type {*|null|undefined} */

      var _handleItemClicked = opt_data._handleItemClicked;
      /** @type {*|null|undefined} */

      var _handleLabelClosed = opt_data._handleLabelClosed;
      /** @type {boolean|null|undefined} */

      var expanded = soy.asserts.assertType(opt_data.expanded == null || goog.isBoolean(opt_data.expanded) || opt_data.expanded === 1 || opt_data.expanded === 0, 'expanded', opt_data.expanded, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var id = soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var multiple = soy.asserts.assertType(opt_data.multiple == null || goog.isBoolean(opt_data.multiple) || opt_data.multiple === 1 || opt_data.multiple === 0, 'multiple', opt_data.multiple, 'boolean|null|undefined');
      /** @type {!Array<?>|null|undefined} */

      var options = soy.asserts.assertType(opt_data.options == null || goog.isArray(opt_data.options), 'options', opt_data.options, '!Array<?>|null|undefined');
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');

      if (options) {
        var trigger__soy3451 = function trigger__soy3451() {
          if (!readOnly) {
            $hidden_select(opt_data, null, opt_ijData);
          }

          incrementalDom.elementOpenStart('div');
          incrementalDom.attr('class', 'form-builder-select-field input-group-container');
          incrementalDom.elementOpenEnd();
          var classes__soy3463 = '';
          classes__soy3463 += 'form-control results-chosen select-field-trigger';
          classes__soy3463 += multiple ? ' multiple-label-list' : '';

          var attributes__soy3470 = function attributes__soy3470() {
            incrementalDom.attr('class', classes__soy3463);

            if (id) {
              incrementalDom.attr('id', id);
            }

            if (readOnly) {
              incrementalDom.attr('disabled', '');
            }
          };

          incrementalDom.elementOpenStart('div');
          attributes__soy3470();
          incrementalDom.elementOpenEnd();
          var currentValue3529List = value;
          var currentValue3529ListLen = currentValue3529List.length;

          if (currentValue3529ListLen > 0) {
            for (var currentValue3529Index = 0; currentValue3529Index < currentValue3529ListLen; currentValue3529Index++) {
              var currentValue3529Data = currentValue3529List[currentValue3529Index];
              var option3511List = options;
              var option3511ListLen = option3511List.length;

              for (var option3511Index = 0; option3511Index < option3511ListLen; option3511Index++) {
                var option3511Data = option3511List[option3511Index];

                if (currentValue3529Data == option3511Data.value) {
                  if (multiple) {
                    incrementalDom.elementOpen('div');
                    $templateAlias2({
                      closeable: !readOnly,
                      elementClasses: 'ddm-select-option-label',
                      data: {
                        value: option3511Data.value
                      },
                      events: {
                        close: _handleLabelClosed
                      },
                      label: option3511Data.label,
                      spritemap: spritemap,
                      truncate: true
                    }, null, opt_ijData);
                    incrementalDom.elementClose('div');
                  } else {
                    $templateAlias3({
                      label: option3511Data.label
                    }, null, opt_ijData);
                  }
                }
              }
            }
          } else {
            incrementalDom.elementOpenStart('div');
            incrementalDom.attr('class', 'option-selected option-selected-placeholder');
            incrementalDom.elementOpenEnd();

            if (multiple) {
              /** @desc  */
              var MSG_EXTERNAL_5218691681679081610 = Liferay.Language.get('choose-options');
              incrementalDom.text(goog.string.unescapeEntities(MSG_EXTERNAL_5218691681679081610));
            } else {
              /** @desc  */
              var MSG_EXTERNAL_1961977818876868209 = Liferay.Language.get('choose-an-option');
              incrementalDom.text(goog.string.unescapeEntities(MSG_EXTERNAL_1961977818876868209));
            }

            incrementalDom.elementClose('div');
          }

          incrementalDom.elementOpenStart('div');
          incrementalDom.attr('class', 'select-arrow-down-container');
          incrementalDom.elementOpenEnd();

          if (spritemap) {
            $templateAlias4({
              spritemap: spritemap,
              symbol: 'caret-double'
            }, null, opt_ijData);
          }

          incrementalDom.elementClose('div');
          incrementalDom.elementClose('div');
          incrementalDom.elementClose('div');
        };

        $templateAlias5({
          disabled: readOnly,
          events: {
            expandedChanged: _handleExpandedChanged,
            itemClicked: _handleItemClicked
          },
          elementClasses: 'ddm-btn-full ddm-select-dropdown',
          expanded: expanded,
          items: options,
          label: trigger__soy3451,
          ref: 'dropdown',
          searchable: options.length > 6 ? true : false,
          spritemap: spritemap,
          useSearchableWithForm: false
        }, null, opt_ijData);
      }
    }

    exports.content = $content;
    /**
     * @typedef {{
     *  displayValues: (?),
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  value: !Array<!goog.soy.data.SanitizedContent|string>,
     *  _handleExpandedChanged: (*|null|undefined),
     *  _handleItemClicked: (*|null|undefined),
     *  _handleLabelClosed: (*|null|undefined),
     *  expanded: (boolean|null|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  multiple: (boolean|null|undefined),
     *  options: (!Array<?>|null|undefined),
     *  readOnly: (boolean|null|undefined)
     * }}
     */

    $content.Params;

    if (goog.DEBUG) {
      $content.soyTemplateName = 'Select.content';
    }
    /**
     * @param {{
     *  displayValues: (?),
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  options: !Array<?>,
     *  multiple: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $hidden_select(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {?} */

      var displayValues = opt_data.displayValues;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {!Array<?>} */

      var options = soy.asserts.assertType(goog.isArray(opt_data.options), 'options', opt_data.options, '!Array<?>');
      /** @type {boolean|null|undefined} */

      var multiple = soy.asserts.assertType(opt_data.multiple == null || goog.isBoolean(opt_data.multiple) || opt_data.multiple === 1 || opt_data.multiple === 0, 'multiple', opt_data.multiple, 'boolean|null|undefined');
      incrementalDom.elementOpenStart('select');
      incrementalDom.attr('aria-hidden', 'true');
      incrementalDom.attr('class', 'form-control hide');
      incrementalDom.attr('id', name);
      incrementalDom.attr('name', name);

      if (multiple) {
        incrementalDom.attr('multiple', '');
        incrementalDom.attr('size', options.length);
      }

      incrementalDom.elementOpenEnd();
      var currentValue3577List = displayValues;
      var currentValue3577ListLen = currentValue3577List.length;

      for (var currentValue3577Index = 0; currentValue3577Index < currentValue3577ListLen; currentValue3577Index++) {
        var currentValue3577Data = currentValue3577List[currentValue3577Index];
        incrementalDom.elementOpenStart('option');
        incrementalDom.attr('selected', 'selected');
        incrementalDom.attr('value', currentValue3577Data);
        incrementalDom.elementOpenEnd();
        soyIdom.print(currentValue3577Data);
        incrementalDom.elementClose('option');
      }

      incrementalDom.elementClose('select');
    }

    exports.hidden_select = $hidden_select;
    /**
     * @typedef {{
     *  displayValues: (?),
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  options: !Array<?>,
     *  multiple: (boolean|null|undefined)
     * }}
     */

    $hidden_select.Params;

    if (goog.DEBUG) {
      $hidden_select.soyTemplateName = 'Select.hidden_select';
    }

    exports.render.params = ["name", "spritemap", "value", "_handleExpandedChanged", "_handleItemClicked", "_handleLabelClosed", "dataSourceType", "displayErrors", "errorMessage", "expanded", "id", "label", "multiple", "options", "predefinedValue", "readOnly", "repeatable", "required", "showLabel", "tip", "valid", "visible"];
    exports.render.types = {
      "name": "string",
      "spritemap": "string",
      "value": "?",
      "_handleExpandedChanged": "any",
      "_handleItemClicked": "any",
      "_handleLabelClosed": "any",
      "dataSourceType": "string",
      "displayErrors": "bool",
      "errorMessage": "string",
      "expanded": "bool",
      "id": "string",
      "label": "string",
      "multiple": "bool",
      "options": "list<?>",
      "predefinedValue": "?",
      "readOnly": "bool",
      "repeatable": "bool",
      "required": "bool",
      "showLabel": "bool",
      "tip": "string",
      "valid": "bool",
      "visible": "bool"
    };
    exports.content.params = ["displayValues", "name", "spritemap", "value", "_handleExpandedChanged", "_handleItemClicked", "_handleLabelClosed", "expanded", "id", "multiple", "options", "readOnly"];
    exports.content.types = {
      "displayValues": "?",
      "name": "string",
      "spritemap": "string",
      "value": "list<string>",
      "_handleExpandedChanged": "any",
      "_handleItemClicked": "any",
      "_handleLabelClosed": "any",
      "expanded": "bool",
      "id": "string",
      "multiple": "bool",
      "options": "list<?>",
      "readOnly": "bool"
    };
    exports.hidden_select.params = ["displayValues", "name", "options", "multiple"];
    exports.hidden_select.types = {
      "displayValues": "?",
      "name": "string",
      "options": "list<?>",
      "multiple": "bool"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var Select = /*#__PURE__*/function (_Component) {
    _inherits(Select, _Component);

    function Select() {
      _classCallCheck(this, Select);

      return _possibleConstructorReturn(this, _getPrototypeOf(Select).apply(this, arguments));
    }

    return Select;
  }(_metalComponent["default"]);

  exports.Select = Select;

  _metalSoy["default"].register(Select, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=Select.soy.js.map
});
//# sourceMappingURL=Select.soy.js.map