Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Text/Text.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.Text = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from Text.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace Text.
     * @public
     */

    goog.module('Text.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');

    var $templateAlias2 = _metalSoy["default"].getTemplate('ClayAutocomplete.incrementaldom', 'render');

    var $templateAlias1 = _metalSoy["default"].getTemplate('FieldBase.incrementaldom', 'render');
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  _handleAutocompleteSelected: (*|null|undefined),
     *  _handleAutocompleteFieldFocused: (*|null|undefined),
     *  _handleAutocompleteFieldBlurred: (*|null|undefined),
     *  _handleAutocompleteFieldChanged: (*|null|undefined),
     *  _handleAutocompleteFilteredItemsChanged: (*|null|undefined),
     *  autocompleteEnabled: (boolean|null|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  displayStyle: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  filteredItems: (!Array<?>|null|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  options: (!Array<?>|null|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tooltip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  type: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  value: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  visible: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {*|null|undefined} */

      opt_data._handleFieldBlurred;
      opt_data._handleFieldChanged;
      opt_data._handleFieldFocused;
      opt_data._handleAutocompleteSelected;
      opt_data._handleAutocompleteFieldFocused;
      opt_data._handleAutocompleteFieldBlurred;
      opt_data._handleAutocompleteFieldChanged;
      opt_data._handleAutocompleteFilteredItemsChanged;
      soy.asserts.assertType(opt_data.autocompleteEnabled == null || goog.isBoolean(opt_data.autocompleteEnabled) || opt_data.autocompleteEnabled === 1 || opt_data.autocompleteEnabled === 0, 'autocompleteEnabled', opt_data.autocompleteEnabled, 'boolean|null|undefined');

      /** @type {boolean|null|undefined} */

      var displayErrors = soy.asserts.assertType(opt_data.displayErrors == null || goog.isBoolean(opt_data.displayErrors) || opt_data.displayErrors === 1 || opt_data.displayErrors === 0, 'displayErrors', opt_data.displayErrors, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      soy.asserts.assertType(opt_data.displayStyle == null || goog.isString(opt_data.displayStyle) || opt_data.displayStyle instanceof goog.soy.data.SanitizedContent, 'displayStyle', opt_data.displayStyle, '!goog.soy.data.SanitizedContent|null|string|undefined');

      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var errorMessage = soy.asserts.assertType(opt_data.errorMessage == null || goog.isString(opt_data.errorMessage) || opt_data.errorMessage instanceof goog.soy.data.SanitizedContent, 'errorMessage', opt_data.errorMessage, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!Array<?>|null|undefined} */

      soy.asserts.assertType(opt_data.filteredItems == null || goog.isArray(opt_data.filteredItems), 'filteredItems', opt_data.filteredItems, '!Array<?>|null|undefined');

      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var id = soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var label = soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!Array<?>|null|undefined} */

      soy.asserts.assertType(opt_data.options == null || goog.isArray(opt_data.options), 'options', opt_data.options, '!Array<?>|null|undefined');
      soy.asserts.assertType(opt_data.placeholder == null || goog.isString(opt_data.placeholder) || opt_data.placeholder instanceof goog.soy.data.SanitizedContent, 'placeholder', opt_data.placeholder, '!goog.soy.data.SanitizedContent|null|string|undefined');

      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var repeatable = soy.asserts.assertType(opt_data.repeatable == null || goog.isBoolean(opt_data.repeatable) || opt_data.repeatable === 1 || opt_data.repeatable === 0, 'repeatable', opt_data.repeatable, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var required = soy.asserts.assertType(opt_data.required == null || goog.isBoolean(opt_data.required) || opt_data.required === 1 || opt_data.required === 0, 'required', opt_data.required, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var showLabel = soy.asserts.assertType(opt_data.showLabel == null || goog.isBoolean(opt_data.showLabel) || opt_data.showLabel === 1 || opt_data.showLabel === 0, 'showLabel', opt_data.showLabel, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var spritemap = soy.asserts.assertType(opt_data.spritemap == null || goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tip = soy.asserts.assertType(opt_data.tip == null || goog.isString(opt_data.tip) || opt_data.tip instanceof goog.soy.data.SanitizedContent, 'tip', opt_data.tip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var tooltip = soy.asserts.assertType(opt_data.tooltip == null || goog.isString(opt_data.tooltip) || opt_data.tooltip instanceof goog.soy.data.SanitizedContent, 'tooltip', opt_data.tooltip, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var type = soy.asserts.assertType(opt_data.type == null || goog.isString(opt_data.type) || opt_data.type instanceof goog.soy.data.SanitizedContent, 'type', opt_data.type, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      soy.asserts.assertType(opt_data.value == null || goog.isString(opt_data.value) || opt_data.value instanceof goog.soy.data.SanitizedContent, 'value', opt_data.value, '!goog.soy.data.SanitizedContent|null|string|undefined');

      /** @type {boolean|null|undefined} */

      var valid = soy.asserts.assertType(opt_data.valid == null || goog.isBoolean(opt_data.valid) || opt_data.valid === 1 || opt_data.valid === 0, 'valid', opt_data.valid, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var visible = soy.asserts.assertType(opt_data.visible == null || goog.isBoolean(opt_data.visible) || opt_data.visible === 1 || opt_data.visible === 0, 'visible', opt_data.visible, 'boolean|null|undefined');

      var param3708 = function param3708() {
        $content(opt_data, null, opt_ijData);
      };

      $templateAlias1({
        contentRenderer: param3708,
        displayErrors: displayErrors,
        errorMessage: errorMessage,
        id: id,
        label: label,
        name: name,
        readOnly: readOnly,
        repeatable: repeatable,
        required: required,
        showLabel: showLabel,
        spritemap: spritemap,
        tip: tip,
        tooltip: tooltip,
        type: type,
        valid: valid,
        visible: visible
      }, null, opt_ijData);
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  _handleAutocompleteSelected: (*|null|undefined),
     *  _handleAutocompleteFieldFocused: (*|null|undefined),
     *  _handleAutocompleteFieldBlurred: (*|null|undefined),
     *  _handleAutocompleteFieldChanged: (*|null|undefined),
     *  _handleAutocompleteFilteredItemsChanged: (*|null|undefined),
     *  autocompleteEnabled: (boolean|null|undefined),
     *  displayErrors: (boolean|null|undefined),
     *  displayStyle: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  filteredItems: (!Array<?>|null|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  options: (!Array<?>|null|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  repeatable: (boolean|null|undefined),
     *  required: (boolean|null|undefined),
     *  showLabel: (boolean|null|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  tooltip: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  type: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  value: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  valid: (boolean|null|undefined),
     *  visible: (boolean|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'Text.render';
    }
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  _handleAutocompleteSelected: (*|null|undefined),
     *  _handleAutocompleteFieldFocused: (*|null|undefined),
     *  _handleAutocompleteFieldBlurred: (*|null|undefined),
     *  _handleAutocompleteFieldChanged: (*|null|undefined),
     *  _handleAutocompleteFilteredItemsChanged: (*|null|undefined),
     *  autocompleteEnabled: (boolean|null|undefined),
     *  displayStyle: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  filteredItems: (!Array<?>|null|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  options: (!Array<?>|null|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  value: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $content(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleFieldChanged = opt_data._handleFieldChanged;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;
      /** @type {*|null|undefined} */

      var _handleAutocompleteSelected = opt_data._handleAutocompleteSelected;
      /** @type {*|null|undefined} */

      var _handleAutocompleteFieldFocused = opt_data._handleAutocompleteFieldFocused;
      /** @type {*|null|undefined} */

      var _handleAutocompleteFieldBlurred = opt_data._handleAutocompleteFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleAutocompleteFieldChanged = opt_data._handleAutocompleteFieldChanged;
      /** @type {*|null|undefined} */

      var _handleAutocompleteFilteredItemsChanged = opt_data._handleAutocompleteFilteredItemsChanged;
      /** @type {boolean|null|undefined} */

      var autocompleteEnabled = soy.asserts.assertType(opt_data.autocompleteEnabled == null || goog.isBoolean(opt_data.autocompleteEnabled) || opt_data.autocompleteEnabled === 1 || opt_data.autocompleteEnabled === 0, 'autocompleteEnabled', opt_data.autocompleteEnabled, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var displayStyle = soy.asserts.assertType(opt_data.displayStyle == null || goog.isString(opt_data.displayStyle) || opt_data.displayStyle instanceof goog.soy.data.SanitizedContent, 'displayStyle', opt_data.displayStyle, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!Array<?>|null|undefined} */

      var filteredItems = soy.asserts.assertType(opt_data.filteredItems == null || goog.isArray(opt_data.filteredItems), 'filteredItems', opt_data.filteredItems, '!Array<?>|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var id = soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!Array<?>|null|undefined} */

      var options = soy.asserts.assertType(opt_data.options == null || goog.isArray(opt_data.options), 'options', opt_data.options, '!Array<?>|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var placeholder = soy.asserts.assertType(opt_data.placeholder == null || goog.isString(opt_data.placeholder) || opt_data.placeholder instanceof goog.soy.data.SanitizedContent, 'placeholder', opt_data.placeholder, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var value = soy.asserts.assertType(opt_data.value == null || goog.isString(opt_data.value) || opt_data.value instanceof goog.soy.data.SanitizedContent, 'value', opt_data.value, '!goog.soy.data.SanitizedContent|null|string|undefined');
      var inputValue__soy3764 = value != null && value != '' ? value : '';

      var attributes__soy3766 = function attributes__soy3766() {
        incrementalDom.attr('class', 'ddm-field-text form-control');
        incrementalDom.attr('name', name);
        incrementalDom.attr('type', 'text');
        incrementalDom.attr('data-oninput', _handleFieldChanged);
        incrementalDom.attr('data-onfocus', _handleFieldFocused);

        if (id) {
          incrementalDom.attr('id', id);
        } else {
          incrementalDom.attr('id', name);
        }

        if (placeholder) {
          incrementalDom.attr('placeholder', placeholder);
        }

        incrementalDom.attr('type', 'text');
        incrementalDom.attr('data-onblur', _handleFieldBlurred);

        if (readOnly) {
          incrementalDom.attr('disabled', 'disabled');
        }

        if (displayStyle == 'singleline') {
          incrementalDom.attr('value', inputValue__soy3764);
        }
      };

      if (displayStyle == 'multiline') {
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'input-group');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('textarea');
        attributes__soy3766();
        incrementalDom.elementOpenEnd();
        soyIdom.print(inputValue__soy3764);
        incrementalDom.elementClose('textarea');
        incrementalDom.elementClose('div');
      } else if (displayStyle == 'singleline' && readOnly || !autocompleteEnabled) {
        incrementalDom.elementOpenStart('input');
        attributes__soy3766();
        incrementalDom.elementOpenEnd();
        incrementalDom.elementClose('input');
      } else if (autocompleteEnabled && options != null) {
        if (options.length == 0) {
          incrementalDom.elementOpenStart('input');
          attributes__soy3766();
          incrementalDom.elementOpenEnd();
          incrementalDom.elementClose('input');
        } else {
          $templateAlias2({
            dataSource: options,
            events: {
              itemSelected: _handleAutocompleteSelected,
              inputOnFocus: _handleAutocompleteFieldFocused,
              inputOnBlur: _handleAutocompleteFieldBlurred,
              inputChange: _handleAutocompleteFieldChanged,
              filteredItemsChanged: _handleAutocompleteFilteredItemsChanged
            },
            filteredItems: filteredItems,
            ref: 'autocomplete',
            inputValue: value,
            inputName: name
          }, null, opt_ijData);
        }
      }
    }

    exports.content = $content;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldChanged: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  _handleAutocompleteSelected: (*|null|undefined),
     *  _handleAutocompleteFieldFocused: (*|null|undefined),
     *  _handleAutocompleteFieldBlurred: (*|null|undefined),
     *  _handleAutocompleteFieldChanged: (*|null|undefined),
     *  _handleAutocompleteFilteredItemsChanged: (*|null|undefined),
     *  autocompleteEnabled: (boolean|null|undefined),
     *  displayStyle: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  filteredItems: (!Array<?>|null|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  options: (!Array<?>|null|undefined),
     *  placeholder: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  value: (!goog.soy.data.SanitizedContent|null|string|undefined)
     * }}
     */

    $content.Params;

    if (goog.DEBUG) {
      $content.soyTemplateName = 'Text.content';
    }

    exports.render.params = ["name", "_handleFieldBlurred", "_handleFieldChanged", "_handleFieldFocused", "_handleAutocompleteSelected", "_handleAutocompleteFieldFocused", "_handleAutocompleteFieldBlurred", "_handleAutocompleteFieldChanged", "_handleAutocompleteFilteredItemsChanged", "autocompleteEnabled", "displayErrors", "displayStyle", "errorMessage", "filteredItems", "id", "label", "options", "placeholder", "readOnly", "repeatable", "required", "showLabel", "spritemap", "tip", "tooltip", "type", "value", "valid", "visible"];
    exports.render.types = {
      "name": "string",
      "_handleFieldBlurred": "any",
      "_handleFieldChanged": "any",
      "_handleFieldFocused": "any",
      "_handleAutocompleteSelected": "any",
      "_handleAutocompleteFieldFocused": "any",
      "_handleAutocompleteFieldBlurred": "any",
      "_handleAutocompleteFieldChanged": "any",
      "_handleAutocompleteFilteredItemsChanged": "any",
      "autocompleteEnabled": "bool",
      "displayErrors": "bool",
      "displayStyle": "string",
      "errorMessage": "string",
      "filteredItems": "list<?>",
      "id": "string",
      "label": "string",
      "options": "list<?>",
      "placeholder": "string",
      "readOnly": "bool",
      "repeatable": "bool",
      "required": "bool",
      "showLabel": "bool",
      "spritemap": "string",
      "tip": "string",
      "tooltip": "string",
      "type": "string",
      "value": "string",
      "valid": "bool",
      "visible": "bool"
    };
    exports.content.params = ["name", "_handleFieldBlurred", "_handleFieldChanged", "_handleFieldFocused", "_handleAutocompleteSelected", "_handleAutocompleteFieldFocused", "_handleAutocompleteFieldBlurred", "_handleAutocompleteFieldChanged", "_handleAutocompleteFilteredItemsChanged", "autocompleteEnabled", "displayStyle", "filteredItems", "id", "options", "placeholder", "readOnly", "value"];
    exports.content.types = {
      "name": "string",
      "_handleFieldBlurred": "any",
      "_handleFieldChanged": "any",
      "_handleFieldFocused": "any",
      "_handleAutocompleteSelected": "any",
      "_handleAutocompleteFieldFocused": "any",
      "_handleAutocompleteFieldBlurred": "any",
      "_handleAutocompleteFieldChanged": "any",
      "_handleAutocompleteFilteredItemsChanged": "any",
      "autocompleteEnabled": "bool",
      "displayStyle": "string",
      "filteredItems": "list<?>",
      "id": "string",
      "options": "list<?>",
      "placeholder": "string",
      "readOnly": "bool",
      "value": "string"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var Text = /*#__PURE__*/function (_Component) {
    _inherits(Text, _Component);

    function Text() {
      _classCallCheck(this, Text);

      return _possibleConstructorReturn(this, _getPrototypeOf(Text).apply(this, arguments));
    }

    return Text;
  }(_metalComponent["default"]);

  exports.Text = Text;

  _metalSoy["default"].register(Text, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=Text.soy.js.map
});
//# sourceMappingURL=Text.soy.js.map