Liferay.Loader.define("dynamic-data-mapping-form-field-type@4.0.110/Validation/Validation.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.Validation = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from Validation.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace Validation.
     * @public
     */

    goog.module('Validation.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy.asserts');

    goog.require('soy.idom');

    var $templateAlias1 = _metalSoy["default"].getTemplate('Checkbox.incrementaldom', 'render');

    var $templateAlias4 = _metalSoy["default"].getTemplate('Numeric.incrementaldom', 'render');

    var $templateAlias2 = _metalSoy["default"].getTemplate('Select.incrementaldom', 'render');

    var $templateAlias3 = _metalSoy["default"].getTemplate('Text.incrementaldom', 'render');
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _updateValue: (*|null|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  dataType: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  enableValidation: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  localizationMode: (boolean|null|undefined),
     *  parameter: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  selectedValidation: (null|undefined|{name: (!goog.soy.data.SanitizedContent|string), parameterMessage: (!goog.soy.data.SanitizedContent|string)}),
     *  validations: (!Array<{checked: boolean, disabled: boolean, id: (!goog.soy.data.SanitizedContent|string), inline: boolean, label: (!goog.soy.data.SanitizedContent|string), name: (!goog.soy.data.SanitizedContent|string), showLabel: boolean, value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      opt_data._updateValue;
      soy.asserts.assertType(opt_data.id == null || goog.isString(opt_data.id) || opt_data.id instanceof goog.soy.data.SanitizedContent, 'id', opt_data.id, '!goog.soy.data.SanitizedContent|null|string|undefined');
      soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      soy.asserts.assertType(opt_data.dataType == null || goog.isString(opt_data.dataType) || opt_data.dataType instanceof goog.soy.data.SanitizedContent, 'dataType', opt_data.dataType, '!goog.soy.data.SanitizedContent|null|string|undefined');
      soy.asserts.assertType(opt_data.enableValidation == null || goog.isBoolean(opt_data.enableValidation) || opt_data.enableValidation === 1 || opt_data.enableValidation === 0, 'enableValidation', opt_data.enableValidation, 'boolean|null|undefined');
      soy.asserts.assertType(opt_data.errorMessage == null || goog.isString(opt_data.errorMessage) || opt_data.errorMessage instanceof goog.soy.data.SanitizedContent, 'errorMessage', opt_data.errorMessage, '!goog.soy.data.SanitizedContent|null|string|undefined');
      soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      soy.asserts.assertType(opt_data.localizationMode == null || goog.isBoolean(opt_data.localizationMode) || opt_data.localizationMode === 1 || opt_data.localizationMode === 0, 'localizationMode', opt_data.localizationMode, 'boolean|null|undefined');
      soy.asserts.assertType(opt_data.parameter == null || goog.isString(opt_data.parameter) || opt_data.parameter instanceof goog.soy.data.SanitizedContent, 'parameter', opt_data.parameter, '!goog.soy.data.SanitizedContent|null|string|undefined');
      soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      soy.asserts.assertType(opt_data.selectedValidation == null || goog.isObject(opt_data.selectedValidation), 'selectedValidation', opt_data.selectedValidation, 'null|undefined|{name: (!goog.soy.data.SanitizedContent|string), parameterMessage: (!goog.soy.data.SanitizedContent|string)}');
      soy.asserts.assertType(opt_data.validations == null || goog.isArray(opt_data.validations), 'validations', opt_data.validations, '!Array<{checked: boolean, disabled: boolean, id: (!goog.soy.data.SanitizedContent|string), inline: boolean, label: (!goog.soy.data.SanitizedContent|string), name: (!goog.soy.data.SanitizedContent|string), showLabel: boolean, value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined');

      $content(opt_data, null, opt_ijData);
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _updateValue: (*|null|undefined),
     *  id: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  dataType: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  enableValidation: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  localizationMode: (boolean|null|undefined),
     *  parameter: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  selectedValidation: (null|undefined|{name: (!goog.soy.data.SanitizedContent|string), parameterMessage: (!goog.soy.data.SanitizedContent|string)}),
     *  validations: (!Array<{checked: boolean, disabled: boolean, id: (!goog.soy.data.SanitizedContent|string), inline: boolean, label: (!goog.soy.data.SanitizedContent|string), name: (!goog.soy.data.SanitizedContent|string), showLabel: boolean, value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'Validation.render';
    }
    /**
     * @param {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _updateValue: (*|null|undefined),
     *  dataType: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  enableValidation: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  localizationMode: (boolean|null|undefined),
     *  parameter: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  selectedValidation: (null|undefined|{name: (!goog.soy.data.SanitizedContent|string), parameterMessage: (!goog.soy.data.SanitizedContent|string)}),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  validations: (!Array<{checked: boolean, disabled: boolean, id: (!goog.soy.data.SanitizedContent|string), inline: boolean, label: (!goog.soy.data.SanitizedContent|string), name: (!goog.soy.data.SanitizedContent|string), showLabel: boolean, value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $content(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var name = soy.asserts.assertType(goog.isString(opt_data.name) || opt_data.name instanceof goog.soy.data.SanitizedContent, 'name', opt_data.name, '!goog.soy.data.SanitizedContent|string');
      /** @type {*|null|undefined} */

      var _updateValue = opt_data._updateValue;
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var dataType = soy.asserts.assertType(opt_data.dataType == null || goog.isString(opt_data.dataType) || opt_data.dataType instanceof goog.soy.data.SanitizedContent, 'dataType', opt_data.dataType, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var enableValidation = soy.asserts.assertType(opt_data.enableValidation == null || goog.isBoolean(opt_data.enableValidation) || opt_data.enableValidation === 1 || opt_data.enableValidation === 0, 'enableValidation', opt_data.enableValidation, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var errorMessage = soy.asserts.assertType(opt_data.errorMessage == null || goog.isString(opt_data.errorMessage) || opt_data.errorMessage instanceof goog.soy.data.SanitizedContent, 'errorMessage', opt_data.errorMessage, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var label = soy.asserts.assertType(opt_data.label == null || goog.isString(opt_data.label) || opt_data.label instanceof goog.soy.data.SanitizedContent, 'label', opt_data.label, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var localizationMode = soy.asserts.assertType(opt_data.localizationMode == null || goog.isBoolean(opt_data.localizationMode) || opt_data.localizationMode === 1 || opt_data.localizationMode === 0, 'localizationMode', opt_data.localizationMode, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var parameter = soy.asserts.assertType(opt_data.parameter == null || goog.isString(opt_data.parameter) || opt_data.parameter instanceof goog.soy.data.SanitizedContent, 'parameter', opt_data.parameter, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {null|undefined|{name: (!goog.soy.data.SanitizedContent|string), parameterMessage: (!goog.soy.data.SanitizedContent|string)}} */

      var selectedValidation = soy.asserts.assertType(opt_data.selectedValidation == null || goog.isObject(opt_data.selectedValidation), 'selectedValidation', opt_data.selectedValidation, 'null|undefined|{name: (!goog.soy.data.SanitizedContent|string), parameterMessage: (!goog.soy.data.SanitizedContent|string)}');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var spritemap = soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      /** @type {!Array<{checked: boolean, disabled: boolean, id: (!goog.soy.data.SanitizedContent|string), inline: boolean, label: (!goog.soy.data.SanitizedContent|string), name: (!goog.soy.data.SanitizedContent|string), showLabel: boolean, value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined} */

      var validations = soy.asserts.assertType(opt_data.validations == null || goog.isArray(opt_data.validations), 'validations', opt_data.validations, '!Array<{checked: boolean, disabled: boolean, id: (!goog.soy.data.SanitizedContent|string), inline: boolean, label: (!goog.soy.data.SanitizedContent|string), name: (!goog.soy.data.SanitizedContent|string), showLabel: boolean, value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined');
      var msg_21573__soy21574 = '';
      /** @desc  */

      var MSG_EXTERNAL_1961977818876868209 = Liferay.Language.get('choose-an-option');
      msg_21573__soy21574 += MSG_EXTERNAL_1961977818876868209;
      var msg_21570__soy21571 = '';
      /** @desc  */

      var MSG_EXTERNAL_7693346009089745609 = Liferay.Language.get('if-input');
      msg_21570__soy21571 += MSG_EXTERNAL_7693346009089745609;
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'form-group lfr-ddm-form-field-validation');
      incrementalDom.elementOpenEnd();
      $templateAlias1({
        events: {
          fieldEdited: _updateValue
        },
        label: label,
        name: 'enableValidation',
        readOnly: readOnly,
        ref: 'enableValidation',
        showAsSwitcher: true,
        spritemap: spritemap,
        value: enableValidation
      }, null, opt_ijData);
      $templateAlias2({
        disableEmptyOption: true,
        events: {
          fieldEdited: _updateValue
        },
        label: '' + msg_21570__soy21571,
        name: 'selectedValidation',
        options: validations,
        placeholder: '' + msg_21573__soy21574,
        readOnly: readOnly || localizationMode,
        ref: 'selectedValidation',
        spritemap: spritemap,
        value: [selectedValidation == null ? null : selectedValidation.name],
        visible: enableValidation
      }, null, opt_ijData);

      if ((selectedValidation == null ? null : selectedValidation.parameterMessage) && dataType == 'string') {
        var msg_21576__soy21577 = '';
        /** @desc  */

        var MSG_EXTERNAL_7340415168811638531 = Liferay.Language.get('the-value');
        msg_21576__soy21577 += MSG_EXTERNAL_7340415168811638531;
        $templateAlias3({
          dataType: dataType,
          events: {
            fieldEdited: _updateValue
          },
          label: '' + msg_21576__soy21577,
          name: name + '_parameter',
          placeholder: selectedValidation == null ? null : selectedValidation.parameterMessage,
          readOnly: readOnly,
          ref: 'parameter',
          required: false,
          spritemap: spritemap,
          value: parameter,
          visible: enableValidation
        }, null, opt_ijData);
      } else if (selectedValidation == null ? null : selectedValidation.parameterMessage) {
        var msg_21579__soy21580 = '';
        /** @desc  */

        var MSG_EXTERNAL_7340415168811638531$$1 = Liferay.Language.get('the-value');
        msg_21579__soy21580 += MSG_EXTERNAL_7340415168811638531$$1;
        $templateAlias4({
          dataType: dataType,
          events: {
            fieldEdited: _updateValue
          },
          label: '' + msg_21579__soy21580,
          name: name + '_parameter',
          placeholder: selectedValidation == null ? null : selectedValidation.parameterMessage,
          readOnly: readOnly,
          ref: 'parameter',
          required: false,
          spritemap: spritemap,
          value: parameter,
          visible: enableValidation
        }, null, opt_ijData);
      }

      if (enableValidation) {
        var msg_21585__soy21586 = '';
        /** @desc  */

        var MSG_EXTERNAL_7458872780915473726 = Liferay.Language.get('show-error-message');
        msg_21585__soy21586 += MSG_EXTERNAL_7458872780915473726;
        var msg_21582__soy21583 = '';
        /** @desc  */

        var MSG_EXTERNAL_7458872780915473726$$1 = Liferay.Language.get('show-error-message');
        msg_21582__soy21583 += MSG_EXTERNAL_7458872780915473726$$1;
        $templateAlias3({
          dataType: 'string',
          events: {
            fieldEdited: _updateValue
          },
          label: '' + msg_21582__soy21583,
          name: name + '_errorMessage',
          placeholder: '' + msg_21585__soy21586,
          readOnly: readOnly,
          ref: 'errorMessage',
          required: false,
          spritemap: spritemap,
          value: errorMessage,
          visible: enableValidation
        }, null, opt_ijData);
      }

      incrementalDom.elementClose('div');
    }

    exports.content = $content;
    /**
     * @typedef {{
     *  name: (!goog.soy.data.SanitizedContent|string),
     *  _updateValue: (*|null|undefined),
     *  dataType: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  enableValidation: (boolean|null|undefined),
     *  errorMessage: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  label: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  localizationMode: (boolean|null|undefined),
     *  parameter: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  selectedValidation: (null|undefined|{name: (!goog.soy.data.SanitizedContent|string), parameterMessage: (!goog.soy.data.SanitizedContent|string)}),
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  validations: (!Array<{checked: boolean, disabled: boolean, id: (!goog.soy.data.SanitizedContent|string), inline: boolean, label: (!goog.soy.data.SanitizedContent|string), name: (!goog.soy.data.SanitizedContent|string), showLabel: boolean, value: (!goog.soy.data.SanitizedContent|string)}>|null|undefined)
     * }}
     */

    $content.Params;

    if (goog.DEBUG) {
      $content.soyTemplateName = 'Validation.content';
    }

    exports.render.params = ["name", "_updateValue", "id", "spritemap", "dataType", "enableValidation", "errorMessage", "label", "localizationMode", "parameter", "readOnly", "selectedValidation", "validations"];
    exports.render.types = {
      "name": "string",
      "_updateValue": "any",
      "id": "string",
      "spritemap": "string",
      "dataType": "string",
      "enableValidation": "bool",
      "errorMessage": "string",
      "label": "string",
      "localizationMode": "bool",
      "parameter": "string",
      "readOnly": "bool",
      "selectedValidation": "[name: string, parameterMessage: string]",
      "validations": "list<[\n\t\tchecked: bool,\n\t\tdisabled: bool,\n\t\tid: string,\n\t\tinline: bool,\n\t\tlabel: string,\n\t\tname: string,\n\t\tshowLabel: bool,\n\t\tvalue: string\n\t]>"
    };
    exports.content.params = ["name", "_updateValue", "dataType", "enableValidation", "errorMessage", "label", "localizationMode", "parameter", "readOnly", "selectedValidation", "spritemap", "validations"];
    exports.content.types = {
      "name": "string",
      "_updateValue": "any",
      "dataType": "string",
      "enableValidation": "bool",
      "errorMessage": "string",
      "label": "string",
      "localizationMode": "bool",
      "parameter": "string",
      "readOnly": "bool",
      "selectedValidation": "[name: string, parameterMessage: string]",
      "spritemap": "string",
      "validations": "list<[\n\t\tchecked: bool,\n\t\tdisabled: bool,\n\t\tid: string,\n\t\tinline: bool,\n\t\tlabel: string,\n\t\tname: string,\n\t\tshowLabel: bool,\n\t\tvalue: string\n\t]>"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var Validation = /*#__PURE__*/function (_Component) {
    _inherits(Validation, _Component);

    function Validation() {
      _classCallCheck(this, Validation);

      return _possibleConstructorReturn(this, _getPrototypeOf(Validation).apply(this, arguments));
    }

    return Validation;
  }(_metalComponent["default"]);

  exports.Validation = Validation;

  _metalSoy["default"].register(Validation, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=Validation.soy.js.map
});
//# sourceMappingURL=Validation.soy.js.map