Liferay.Loader.define("dynamic-data-mapping-form-builder@2.0.87/js/components/FormBuilder/props.es", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-state', '../../util/config.es'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = void 0;

  var _metalState = require("frontend-js-metal-web$metal-state");

  var _config = require("../../util/config.es");

  /**
   * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
   *
   * This library is free software; you can redistribute it and/or modify it under
   * the terms of the GNU Lesser General Public License as published by the Free
   * Software Foundation; either version 2.1 of the License, or (at your option)
   * any later version.
   *
   * This library is distributed in the hope that it will be useful, but WITHOUT
   * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
   * details.
   */
  var _default = {
    /**
     * @default
     * @instance
     * @memberof FormBuilder
     * @type {?number}
     */
    activePage: _metalState.Config.number().value(0),

    /**
     * @default undefined
     * @instance
     * @memberof FormBuilder
     * @type {?string}
     */
    defaultLanguageId: _metalState.Config.string(),

    /**
     * @default undefined
     * @instance
     * @memberof FormBuilder
     * @type {?string}
     */
    editingLanguageId: _metalState.Config.string(),

    /**
     * @default []
     * @instance
     * @memberof FormBuilder
     * @type {?(array|undefined)}
     */
    fieldActions: _metalState.Config.array().value([]),

    /**
     * @default undefined
     * @instance
     * @memberof FormBuilder
     * @type {?string}
     */
    fieldSetDefinitionURL: _metalState.Config.string(),

    /**
     * @default []
     * @instance
     * @memberof FormBuilder
     * @type {?(array|undefined)}
     */
    fieldSets: _metalState.Config.array().value([]),

    /**
     * @default []
     * @instance
     * @memberof FormBuilder
     * @type {?(array|undefined)}
     */
    fieldTypes: _metalState.Config.array().value([]),

    /**
     * @default {}
     * @instance
     * @memberof FormBuilder
     * @type {?object}
     */
    focusedField: _config.focusedFieldStructure.value({}),

    /**
     * @default []
     * @instance
     * @memberof FormBuilder
     * @type {?array<object>}
     */
    pages: _metalState.Config.arrayOf(_config.pageStructure).value([]),

    /**
     * @instance
     * @memberof FormBuilder
     * @type {string}
     */
    paginationMode: _metalState.Config.string().required(),

    /**
     * @instance
     * @memberof FormBuilder
     * @type {string}
     */
    portletNamespace: _metalState.Config.string().required(),

    /**
     * @default undefined
     * @instance
     * @memberof FormRenderer
     * @type {!string}
     */
    spritemap: _metalState.Config.string().required(),

    /**
     * @instance
     * @memberof FormBuilder
     * @type {object}
     */
    successPageSettings: _metalState.Config.shapeOf({
      body: _metalState.Config.object(),
      enabled: _metalState.Config.bool(),
      title: _metalState.Config.object()
    }).value({}),

    /**
     * @default undefined
     * @instance
     * @memberof FormBuilder
     * @type {?string}
     */
    view: _metalState.Config.string()
  };
  exports["default"] = _default;
  //# sourceMappingURL=props.es.js.map
});
//# sourceMappingURL=props.es.js.map