Liferay.Loader.define("dynamic-data-mapping-form-builder@2.0.87/js/components/LayoutProvider/handlers/fieldBlurredHandler.es", ['module', 'exports', 'require', './fieldEditedHandler.es'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.handleFieldBlurred = void 0;

  var _fieldEditedHandler = require("./fieldEditedHandler.es");

  /**
   * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
   *
   * This library is free software; you can redistribute it and/or modify it under
   * the terms of the GNU Lesser General Public License as published by the Free
   * Software Foundation; either version 2.1 of the License, or (at your option)
   * any later version.
   *
   * This library is distributed in the hope that it will be useful, but WITHOUT
   * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
   * details.
   */
  var handleFieldBlurred = function handleFieldBlurred(state, event) {
    var propertyName = event.propertyName,
        propertyValue = event.propertyValue;
    var newState = {
      pages: state.pages
    };

    if (propertyName === 'name' && propertyValue === '') {
      newState = (0, _fieldEditedHandler.updateField)(state, propertyName, propertyValue);
    }

    return newState;
  };

  exports.handleFieldBlurred = handleFieldBlurred;
  var _default = handleFieldBlurred;
  exports["default"] = _default;
  //# sourceMappingURL=fieldBlurredHandler.es.js.map
});
//# sourceMappingURL=fieldBlurredHandler.es.js.map