Liferay.Loader.define("dynamic-data-mapping-form-renderer@4.0.70/js/components/PageRenderer/PageRenderer.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.PageRenderer = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from PageRenderer.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace PageRenderer.
     * @hassoydeltemplate {PageRenderer.PageHeader.idom}
     * @hassoydeltemplate {PageRenderer.RegisterFieldType.idom}
     * @hassoydelcall {PageRenderer.PageHeader.idom}
     * @hassoydelcall {PageRenderer.RegisterFieldType.idom}
     * @hassoydelcall {PageRenderer.container.idom}
     * @public
     */

    goog.module('PageRenderer.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    goog.require('goog.string');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');

    var $templateAlias1 = _metalSoy["default"].getTemplate('ClayIcon.incrementaldom', 'render');
    /**
     * @param {{
     *  pages: (?),
     *  showSubmitButton: boolean,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  submitLabel: (!goog.soy.data.SanitizedContent|string),
     *  total: number,
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleFieldEdited: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  activePage: (null|number|undefined),
     *  editable: (boolean|null|undefined),
     *  editingLanguageId: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  empty: (boolean|null|undefined),
     *  page: (?),
     *  pageIndex: (null|number|undefined),
     *  paginationMode: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  strings: (!Object<!goog.soy.data.SanitizedContent|string,!goog.soy.data.SanitizedContent|string>|null|undefined),
     *  hasFieldRequired: (boolean|null|undefined),
     *  indicatesRequiredFields: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  isAdminPortletNamespace: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      var $$temp;
      /** @type {?} */

      var pages = opt_data.pages;
      /** @type {boolean} */

      var showSubmitButton = soy.asserts.assertType(goog.isBoolean(opt_data.showSubmitButton) || opt_data.showSubmitButton === 1 || opt_data.showSubmitButton === 0, 'showSubmitButton', opt_data.showSubmitButton, 'boolean');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var spritemap = soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var submitLabel = soy.asserts.assertType(goog.isString(opt_data.submitLabel) || opt_data.submitLabel instanceof goog.soy.data.SanitizedContent, 'submitLabel', opt_data.submitLabel, '!goog.soy.data.SanitizedContent|string');
      /** @type {number} */

      var total = soy.asserts.assertType(goog.isNumber(opt_data.total), 'total', opt_data.total, 'number');
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleFieldClicked = opt_data._handleFieldClicked;
      /** @type {*|null|undefined} */

      var _handleFieldEdited = opt_data._handleFieldEdited;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;
      /** @type {null|number|undefined} */

      var activePage = soy.asserts.assertType(opt_data.activePage == null || goog.isNumber(opt_data.activePage), 'activePage', opt_data.activePage, 'null|number|undefined');
      /** @type {boolean|null|undefined} */

      var editable = soy.asserts.assertType(opt_data.editable == null || goog.isBoolean(opt_data.editable) || opt_data.editable === 1 || opt_data.editable === 0, 'editable', opt_data.editable, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var editingLanguageId = soy.asserts.assertType(opt_data.editingLanguageId == null || goog.isString(opt_data.editingLanguageId) || opt_data.editingLanguageId instanceof goog.soy.data.SanitizedContent, 'editingLanguageId', opt_data.editingLanguageId, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var empty = soy.asserts.assertType(opt_data.empty == null || goog.isBoolean(opt_data.empty) || opt_data.empty === 1 || opt_data.empty === 0, 'empty', opt_data.empty, 'boolean|null|undefined');
      /** @type {?} */

      var page = opt_data.page;
      /** @type {null|number|undefined} */

      var pageIndex = soy.asserts.assertType(opt_data.pageIndex == null || goog.isNumber(opt_data.pageIndex), 'pageIndex', opt_data.pageIndex, 'null|number|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var paginationMode = soy.asserts.assertType(opt_data.paginationMode == null || goog.isString(opt_data.paginationMode) || opt_data.paginationMode instanceof goog.soy.data.SanitizedContent, 'paginationMode', opt_data.paginationMode, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {!Object<!goog.soy.data.SanitizedContent|string,!goog.soy.data.SanitizedContent|string>|null|undefined} */

      var strings = soy.asserts.assertType(opt_data.strings == null || goog.isObject(opt_data.strings), 'strings', opt_data.strings, '!Object<!goog.soy.data.SanitizedContent|string,!goog.soy.data.SanitizedContent|string>|null|undefined');
      /** @type {boolean|null|undefined} */

      var hasFieldRequired = soy.asserts.assertType(opt_data.hasFieldRequired == null || goog.isBoolean(opt_data.hasFieldRequired) || opt_data.hasFieldRequired === 1 || opt_data.hasFieldRequired === 0, 'hasFieldRequired', opt_data.hasFieldRequired, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var indicatesRequiredFields = soy.asserts.assertType(opt_data.indicatesRequiredFields == null || goog.isString(opt_data.indicatesRequiredFields) || opt_data.indicatesRequiredFields instanceof goog.soy.data.SanitizedContent, 'indicatesRequiredFields', opt_data.indicatesRequiredFields, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var isAdminPortletNamespace = soy.asserts.assertType(opt_data.isAdminPortletNamespace == null || goog.isBoolean(opt_data.isAdminPortletNamespace) || opt_data.isAdminPortletNamespace === 1 || opt_data.isAdminPortletNamespace === 0, 'isAdminPortletNamespace', opt_data.isAdminPortletNamespace, 'boolean|null|undefined');
      var contentRenderer__soy123 = '';
      var $tmp = null;

      if (page.contentRenderer != null && page.contentRenderer != '') {
        $tmp = page.contentRenderer;
      } else if (paginationMode == null || paginationMode == '') {
        $tmp = pages.length > 1 ? 'wizard' : 'single_page';
      } else if (paginationMode != null && paginationMode == 'single-page') {
        $tmp = 'single_page';
      } else {
        $tmp = paginationMode;
      }

      contentRenderer__soy123 += $tmp;
      soy.$$getDelegateFn(soy.$$getDelTemplateId('PageRenderer.container.idom'), contentRenderer__soy123, false)({
        _handleFieldBlurred: _handleFieldBlurred,
        _handleFieldClicked: _handleFieldClicked,
        _handleFieldEdited: _handleFieldEdited,
        _handleFieldFocused: _handleFieldFocused,
        activePage: ($$temp = activePage) == null ? 0 : $$temp,
        contentRenderer: contentRenderer__soy123,
        editable: editable,
        editingLanguageId: editingLanguageId,
        empty: empty,
        page: page,
        pageIndex: ($$temp = pageIndex) == null ? 0 : $$temp,
        pages: pages,
        paginationMode: paginationMode,
        readOnly: readOnly,
        showSubmitButton: showSubmitButton,
        spritemap: spritemap,
        strings: strings,
        submitLabel: submitLabel,
        total: total,
        hasFieldRequired: hasFieldRequired,
        indicatesRequiredFields: indicatesRequiredFields,
        isAdminPortletNamespace: isAdminPortletNamespace
      }, null, opt_ijData);
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  pages: (?),
     *  showSubmitButton: boolean,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  submitLabel: (!goog.soy.data.SanitizedContent|string),
     *  total: number,
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleFieldEdited: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  activePage: (null|number|undefined),
     *  editable: (boolean|null|undefined),
     *  editingLanguageId: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  empty: (boolean|null|undefined),
     *  page: (?),
     *  pageIndex: (null|number|undefined),
     *  paginationMode: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  readOnly: (boolean|null|undefined),
     *  strings: (!Object<!goog.soy.data.SanitizedContent|string,!goog.soy.data.SanitizedContent|string>|null|undefined),
     *  hasFieldRequired: (boolean|null|undefined),
     *  indicatesRequiredFields: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  isAdminPortletNamespace: (boolean|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'PageRenderer.render';
    }
    /**
     * @param {{
     *  activePage: number,
     *  pageIndex: number,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  total: number,
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleFieldEdited: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  editable: (boolean|null|undefined),
     *  empty: (boolean|null|undefined),
     *  page: (?),
     *  hasFieldRequired: (boolean|null|undefined),
     *  indicatesRequiredFields: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  isAdminPortletNamespace: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $page(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      var $$temp;
      /** @type {number} */

      var activePage = soy.asserts.assertType(goog.isNumber(opt_data.activePage), 'activePage', opt_data.activePage, 'number');
      /** @type {number} */

      var pageIndex = soy.asserts.assertType(goog.isNumber(opt_data.pageIndex), 'pageIndex', opt_data.pageIndex, 'number');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var spritemap = soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      /** @type {number} */

      var total = soy.asserts.assertType(goog.isNumber(opt_data.total), 'total', opt_data.total, 'number');
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleFieldClicked = opt_data._handleFieldClicked;
      /** @type {*|null|undefined} */

      var _handleFieldEdited = opt_data._handleFieldEdited;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;
      /** @type {boolean|null|undefined} */

      var editable = soy.asserts.assertType(opt_data.editable == null || goog.isBoolean(opt_data.editable) || opt_data.editable === 1 || opt_data.editable === 0, 'editable', opt_data.editable, 'boolean|null|undefined');
      /** @type {boolean|null|undefined} */

      var empty = soy.asserts.assertType(opt_data.empty == null || goog.isBoolean(opt_data.empty) || opt_data.empty === 1 || opt_data.empty === 0, 'empty', opt_data.empty, 'boolean|null|undefined');
      /** @type {?} */

      var page = opt_data.page;
      /** @type {boolean|null|undefined} */

      var hasFieldRequired = soy.asserts.assertType(opt_data.hasFieldRequired == null || goog.isBoolean(opt_data.hasFieldRequired) || opt_data.hasFieldRequired === 1 || opt_data.hasFieldRequired === 0, 'hasFieldRequired', opt_data.hasFieldRequired, 'boolean|null|undefined');
      /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

      var indicatesRequiredFields = soy.asserts.assertType(opt_data.indicatesRequiredFields == null || goog.isString(opt_data.indicatesRequiredFields) || opt_data.indicatesRequiredFields instanceof goog.soy.data.SanitizedContent, 'indicatesRequiredFields', opt_data.indicatesRequiredFields, '!goog.soy.data.SanitizedContent|null|string|undefined');
      /** @type {boolean|null|undefined} */

      var isAdminPortletNamespace = soy.asserts.assertType(opt_data.isAdminPortletNamespace == null || goog.isBoolean(opt_data.isAdminPortletNamespace) || opt_data.isAdminPortletNamespace === 1 || opt_data.isAdminPortletNamespace === 0, 'isAdminPortletNamespace', opt_data.isAdminPortletNamespace, 'boolean|null|undefined');
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'active ddm-form-page lfr-ddm-form-page');
      incrementalDom.elementOpenEnd();
      var headerRenderer__soy187 = ($$temp = page.headerRenderer) == null ? '' : $$temp;

      if (activePage == pageIndex) {
        soy.$$getDelegateFn(soy.$$getDelTemplateId('PageRenderer.PageHeader.idom'), headerRenderer__soy187, false)(soy.$$assignDefaults({
          description: ($$temp = page.description) == null ? '' : $$temp,
          pageIndex: pageIndex,
          title: ($$temp = page.title) == null ? '' : $$temp,
          total: total
        }, page), null, opt_ijData);
      }

      if (empty && editable && activePage == pageIndex) {
        var attributes__soy202 = function attributes__soy202() {
          incrementalDom.attr('class', 'col col-ddm col-empty col-md-12 last-col lfr-initial-col mt-5 mb-4');
          incrementalDom.attr('data-ddm-field-column', '0');
          incrementalDom.attr('data-ddm-field-page', pageIndex);
          incrementalDom.attr('data-ddm-field-row', '0');
        };

        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'row');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('div');
        attributes__soy202();
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'ddm-empty-page ddm-target');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('p');
        incrementalDom.attr('class', 'ddm-empty-page-message');
        incrementalDom.elementOpenEnd();
        /** @desc  */

        var MSG_EXTERNAL_3366078975712358322 = Liferay.Language.get('drag-from-sidebar-and-drop-here');
        incrementalDom.text(goog.string.unescapeEntities(MSG_EXTERNAL_3366078975712358322));
        incrementalDom.elementClose('p');
        incrementalDom.elementClose('div');
        incrementalDom.elementClose('div');
        incrementalDom.elementClose('div');
      } else {
        if (hasFieldRequired && !isAdminPortletNamespace) {
          incrementalDom.elementOpenStart('p');
          incrementalDom.attr('aria-hidden', 'true');
          incrementalDom.attr('class', 'text-secondary row');
          incrementalDom.elementOpenEnd();
          incrementalDom.elementOpenStart('span');
          incrementalDom.attr('class', 'c-mx-1 c-mr-1 reference-mark');
          incrementalDom.elementOpenEnd();
          $templateAlias1({
            spritemap: spritemap,
            symbol: 'asterisk'
          }, null, opt_ijData);
          incrementalDom.elementClose('span');
          soyIdom.print(indicatesRequiredFields);
          incrementalDom.elementClose('p');
        }

        $rows({
          _handleFieldBlurred: _handleFieldBlurred,
          _handleFieldClicked: _handleFieldClicked,
          _handleFieldEdited: _handleFieldEdited,
          _handleFieldFocused: _handleFieldFocused,
          activePage: activePage,
          editable: editable,
          pageIndex: pageIndex,
          rows: page.rows,
          spritemap: spritemap
        }, null, opt_ijData);
      }

      incrementalDom.elementClose('div');
    }

    exports.page = $page;
    /**
     * @typedef {{
     *  activePage: number,
     *  pageIndex: number,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  total: number,
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleFieldEdited: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  editable: (boolean|null|undefined),
     *  empty: (boolean|null|undefined),
     *  page: (?),
     *  hasFieldRequired: (boolean|null|undefined),
     *  indicatesRequiredFields: (!goog.soy.data.SanitizedContent|null|string|undefined),
     *  isAdminPortletNamespace: (boolean|null|undefined)
     * }}
     */

    $page.Params;

    if (goog.DEBUG) {
      $page.soyTemplateName = 'PageRenderer.page';
    }
    /**
     * @param {{
     *  activePage: number,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  editable: (boolean|null|undefined),
     *  pageIndex: (null|number|undefined),
     *  rows: (!Array<?>|null|undefined),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleFieldEdited: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $rows(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {number} */

      var activePage = soy.asserts.assertType(goog.isNumber(opt_data.activePage), 'activePage', opt_data.activePage, 'number');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var spritemap = soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      /** @type {boolean|null|undefined} */

      var editable = soy.asserts.assertType(opt_data.editable == null || goog.isBoolean(opt_data.editable) || opt_data.editable === 1 || opt_data.editable === 0, 'editable', opt_data.editable, 'boolean|null|undefined');
      /** @type {null|number|undefined} */

      var pageIndex = soy.asserts.assertType(opt_data.pageIndex == null || goog.isNumber(opt_data.pageIndex), 'pageIndex', opt_data.pageIndex, 'null|number|undefined');
      /** @type {!Array<?>|null|undefined} */

      var rows = soy.asserts.assertType(opt_data.rows == null || goog.isArray(opt_data.rows), 'rows', opt_data.rows, '!Array<?>|null|undefined');
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleFieldClicked = opt_data._handleFieldClicked;
      /** @type {*|null|undefined} */

      var _handleFieldEdited = opt_data._handleFieldEdited;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;

      if (rows) {
        var row284List = rows;
        var row284ListLen = row284List.length;

        for (var row284Index = 0; row284Index < row284ListLen; row284Index++) {
          var row284Data = row284List[row284Index];

          if (row284Index == 0 && editable && activePage == pageIndex) {
            $placeholder({
              isRow: true,
              pageIndex: pageIndex,
              rowIndex: 0,
              size: 12
            }, null, opt_ijData);
          }

          $row({
            _handleFieldBlurred: _handleFieldBlurred,
            _handleFieldClicked: _handleFieldClicked,
            _handleFieldEdited: _handleFieldEdited,
            _handleFieldFocused: _handleFieldFocused,
            activePage: activePage,
            editable: editable,
            pageIndex: pageIndex,
            row: row284Data,
            rowIndex: row284Index,
            spritemap: spritemap
          }, null, opt_ijData);

          if (editable && activePage == pageIndex) {
            $placeholder({
              isRow: true,
              pageIndex: pageIndex,
              rowIndex: row284Index + 1,
              size: 12
            }, null, opt_ijData);
          }
        }
      }
    }

    exports.rows = $rows;
    /**
     * @typedef {{
     *  activePage: number,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  editable: (boolean|null|undefined),
     *  pageIndex: (null|number|undefined),
     *  rows: (!Array<?>|null|undefined),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleFieldEdited: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined)
     * }}
     */

    $rows.Params;

    if (goog.DEBUG) {
      $rows.soyTemplateName = 'PageRenderer.rows';
    }
    /**
     * @param {{
     *  activePage: number,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleFieldEdited: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  editable: (boolean|null|undefined),
     *  pageIndex: (null|number|undefined),
     *  row: (?),
     *  rowIndex: (null|number|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $row(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {number} */

      var activePage = soy.asserts.assertType(goog.isNumber(opt_data.activePage), 'activePage', opt_data.activePage, 'number');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var spritemap = soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleFieldClicked = opt_data._handleFieldClicked;
      /** @type {*|null|undefined} */

      var _handleFieldEdited = opt_data._handleFieldEdited;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;
      /** @type {boolean|null|undefined} */

      var editable = soy.asserts.assertType(opt_data.editable == null || goog.isBoolean(opt_data.editable) || opt_data.editable === 1 || opt_data.editable === 0, 'editable', opt_data.editable, 'boolean|null|undefined');
      /** @type {null|number|undefined} */

      var pageIndex = soy.asserts.assertType(opt_data.pageIndex == null || goog.isNumber(opt_data.pageIndex), 'pageIndex', opt_data.pageIndex, 'null|number|undefined');
      /** @type {?} */

      var row = opt_data.row;
      /** @type {null|number|undefined} */

      var rowIndex = soy.asserts.assertType(opt_data.rowIndex == null || goog.isNumber(opt_data.rowIndex), 'rowIndex', opt_data.rowIndex, 'null|number|undefined');
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'position-relative row');
      incrementalDom.elementOpenEnd();
      var column315List = row.columns;
      var column315ListLen = column315List.length;

      for (var column315Index = 0; column315Index < column315ListLen; column315Index++) {
        var column315Data = column315List[column315Index];
        $column({
          _handleFieldBlurred: _handleFieldBlurred,
          _handleFieldClicked: _handleFieldClicked,
          _handleFieldEdited: _handleFieldEdited,
          _handleFieldFocused: _handleFieldFocused,
          activePage: activePage,
          column: column315Data,
          columnIndex: column315Index,
          editable: editable,
          pageIndex: pageIndex,
          rowIndex: rowIndex,
          spritemap: spritemap
        }, null, opt_ijData);
      }

      incrementalDom.elementClose('div');
    }

    exports.row = $row;
    /**
     * @typedef {{
     *  activePage: number,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleFieldEdited: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  editable: (boolean|null|undefined),
     *  pageIndex: (null|number|undefined),
     *  row: (?),
     *  rowIndex: (null|number|undefined)
     * }}
     */

    $row.Params;

    if (goog.DEBUG) {
      $row.soyTemplateName = 'PageRenderer.row';
    }
    /**
     * @param {{
     *  activePage: number,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleFieldEdited: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  column: (?),
     *  columnIndex: (null|number|undefined),
     *  editable: (boolean|null|undefined),
     *  pageIndex: (null|number|undefined),
     *  rowIndex: (null|number|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $column(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {number} */

      var activePage = soy.asserts.assertType(goog.isNumber(opt_data.activePage), 'activePage', opt_data.activePage, 'number');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var spritemap = soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      /** @type {*|null|undefined} */

      var _handleFieldBlurred = opt_data._handleFieldBlurred;
      /** @type {*|null|undefined} */

      var _handleFieldClicked = opt_data._handleFieldClicked;
      /** @type {*|null|undefined} */

      var _handleFieldEdited = opt_data._handleFieldEdited;
      /** @type {*|null|undefined} */

      var _handleFieldFocused = opt_data._handleFieldFocused;
      /** @type {?} */

      var column = opt_data.column;
      /** @type {null|number|undefined} */

      var columnIndex = soy.asserts.assertType(opt_data.columnIndex == null || goog.isNumber(opt_data.columnIndex), 'columnIndex', opt_data.columnIndex, 'null|number|undefined');
      /** @type {boolean|null|undefined} */

      var editable = soy.asserts.assertType(opt_data.editable == null || goog.isBoolean(opt_data.editable) || opt_data.editable === 1 || opt_data.editable === 0, 'editable', opt_data.editable, 'boolean|null|undefined');
      /** @type {null|number|undefined} */

      var pageIndex = soy.asserts.assertType(opt_data.pageIndex == null || goog.isNumber(opt_data.pageIndex), 'pageIndex', opt_data.pageIndex, 'null|number|undefined');
      /** @type {null|number|undefined} */

      var rowIndex = soy.asserts.assertType(opt_data.rowIndex == null || goog.isNumber(opt_data.rowIndex), 'rowIndex', opt_data.rowIndex, 'null|number|undefined');

      if (column.fields.length != 0) {
        var content__soy334 = function content__soy334() {
          var field349List = column.fields;
          var field349ListLen = field349List.length;

          for (var field349Index = 0; field349Index < field349ListLen; field349Index++) {
            var field349Data = field349List[field349Index];
            var fieldType__soy337 = field349Data.type;
            incrementalDom.elementOpenStart('div');
            incrementalDom.attr('class', 'ddm-field');
            incrementalDom.attr('data-field-name', field349Data.fieldName);
            incrementalDom.elementOpenEnd();
            soy.$$getDelegateFn(soy.$$getDelTemplateId('PageRenderer.RegisterFieldType.idom'), fieldType__soy337, true)(soy.$$assignDefaults({
              activePage: activePage,
              editable: editable,
              events: {
                fieldBlurred: _handleFieldBlurred,
                fieldClicked: _handleFieldClicked,
                fieldEdited: _handleFieldEdited,
                fieldFocused: _handleFieldFocused
              },
              pageIndex: pageIndex,
              ref: field349Data.type + field349Data.fieldName + field349Data.name + field349Data.label + rowIndex + columnIndex + pageIndex,
              spritemap: spritemap
            }, field349Data), null, opt_ijData);
            incrementalDom.elementClose('div');
          }
        };

        var indexes__soy353 = function indexes__soy353() {
          incrementalDom.attr('data-ddm-field-row', rowIndex);
          incrementalDom.attr('data-ddm-field-page', pageIndex);
          incrementalDom.attr('data-ddm-field-column', columnIndex);
        };

        var attributes__soy362 = function attributes__soy362() {
          incrementalDom.attr('class', 'col-md-' + column.size + ' col-ddm');
          indexes__soy353();
        };

        incrementalDom.elementOpenStart('div');
        attributes__soy362();
        incrementalDom.elementOpenEnd();

        if (editable && column.fields.length > 0) {
          var selected__soy374 = column.fields[0].selected;
          incrementalDom.elementOpenStart('div');
          incrementalDom.attr('class', 'ddm-field-container ddm-target h-100 ' + (selected__soy374 ? 'selected' : ''));
          incrementalDom.attr('data-field-name', column.fields[0].fieldName);
          incrementalDom.elementOpenEnd();
          incrementalDom.elementOpenStart('div');
          incrementalDom.attr('class', 'ddm-resize-handle ddm-resize-handle-left');
          indexes__soy353();
          incrementalDom.elementOpenEnd();
          incrementalDom.elementClose('div');

          var attributesDrag__soy384 = function attributesDrag__soy384() {
            incrementalDom.attr('class', 'ddm-drag');
          };

          incrementalDom.elementOpenStart('div');
          attributesDrag__soy384();
          incrementalDom.elementOpenEnd();
          content__soy334();
          incrementalDom.elementClose('div');
          incrementalDom.elementOpenStart('div');
          incrementalDom.attr('class', 'ddm-resize-handle ddm-resize-handle-right');
          indexes__soy353();
          incrementalDom.elementOpenEnd();
          incrementalDom.elementClose('div');
          incrementalDom.elementClose('div');
        } else {
          content__soy334();
        }

        incrementalDom.elementClose('div');
      } else if (editable && activePage == pageIndex) {
        $placeholder({
          columnIndex: columnIndex,
          pageIndex: pageIndex,
          rowIndex: rowIndex,
          size: column.size
        }, null, opt_ijData);
      }
    }

    exports.column = $column;
    /**
     * @typedef {{
     *  activePage: number,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  _handleFieldBlurred: (*|null|undefined),
     *  _handleFieldClicked: (*|null|undefined),
     *  _handleFieldEdited: (*|null|undefined),
     *  _handleFieldFocused: (*|null|undefined),
     *  column: (?),
     *  columnIndex: (null|number|undefined),
     *  editable: (boolean|null|undefined),
     *  pageIndex: (null|number|undefined),
     *  rowIndex: (null|number|undefined)
     * }}
     */

    $column.Params;

    if (goog.DEBUG) {
      $column.soyTemplateName = 'PageRenderer.column';
    }
    /**
     * @param {{
     *  size: number,
     *  columnIndex: (null|number|undefined),
     *  isRow: (boolean|null|undefined),
     *  pageIndex: (null|number|undefined),
     *  rowIndex: (null|number|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $placeholder(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {number} */

      var size = soy.asserts.assertType(goog.isNumber(opt_data.size), 'size', opt_data.size, 'number');
      /** @type {null|number|undefined} */

      var columnIndex = soy.asserts.assertType(opt_data.columnIndex == null || goog.isNumber(opt_data.columnIndex), 'columnIndex', opt_data.columnIndex, 'null|number|undefined');
      /** @type {boolean|null|undefined} */

      var isRow = soy.asserts.assertType(opt_data.isRow == null || goog.isBoolean(opt_data.isRow) || opt_data.isRow === 1 || opt_data.isRow === 0, 'isRow', opt_data.isRow, 'boolean|null|undefined');
      /** @type {null|number|undefined} */

      var pageIndex = soy.asserts.assertType(opt_data.pageIndex == null || goog.isNumber(opt_data.pageIndex), 'pageIndex', opt_data.pageIndex, 'null|number|undefined');
      /** @type {null|number|undefined} */

      var rowIndex = soy.asserts.assertType(opt_data.rowIndex == null || goog.isNumber(opt_data.rowIndex), 'rowIndex', opt_data.rowIndex, 'null|number|undefined');

      var attributes__soy414 = function attributes__soy414() {
        incrementalDom.attr('class', 'col col-ddm col-empty col-md-' + size);

        if (rowIndex != 'undefined') {
          incrementalDom.attr('data-ddm-field-row', rowIndex);
        }

        if (pageIndex != 'undefined') {
          incrementalDom.attr('data-ddm-field-page', pageIndex);
        }

        if (columnIndex != 'undefined') {
          incrementalDom.attr('data-ddm-field-column', columnIndex);
        }
      };

      var content__soy437 = function content__soy437() {
        incrementalDom.elementOpenStart('div');
        attributes__soy414();
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'ddm-target');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementClose('div');
        incrementalDom.elementClose('div');
      };

      if (isRow) {
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'placeholder row');
        incrementalDom.elementOpenEnd();
        content__soy437();
        incrementalDom.elementClose('div');
      } else {
        content__soy437();
      }
    }

    exports.placeholder = $placeholder;
    /**
     * @typedef {{
     *  size: number,
     *  columnIndex: (null|number|undefined),
     *  isRow: (boolean|null|undefined),
     *  pageIndex: (null|number|undefined),
     *  rowIndex: (null|number|undefined)
     * }}
     */

    $placeholder.Params;

    if (goog.DEBUG) {
      $placeholder.soyTemplateName = 'PageRenderer.placeholder';
    }
    /**
     * @param {{
     *  editable: (boolean|null|undefined),
     *  field: (?)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function __deltemplate_s452_e5792ebc(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      opt_data = opt_data || {};
      /** @type {boolean|null|undefined} */

      var editable = soy.asserts.assertType(opt_data.editable == null || goog.isBoolean(opt_data.editable) || opt_data.editable === 1 || opt_data.editable === 0, 'editable', opt_data.editable, 'boolean|null|undefined');
      /** @type {?} */

      opt_data.field;


      if (editable) {
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'ddm-field-not-found');
        incrementalDom.elementOpenEnd();
        incrementalDom.text('Field doesn\'t exist.');
        incrementalDom.elementClose('div');
      }
    }

    exports.__deltemplate_s452_e5792ebc = __deltemplate_s452_e5792ebc;
    /**
     * @typedef {{
     *  editable: (boolean|null|undefined),
     *  field: (?)
     * }}
     */

    __deltemplate_s452_e5792ebc.Params;

    if (goog.DEBUG) {
      __deltemplate_s452_e5792ebc.soyTemplateName = 'PageRenderer.__deltemplate_s452_e5792ebc';
    }

    soy.$$registerDelegateFn(soy.$$getDelTemplateId('PageRenderer.RegisterFieldType.idom'), '', 0, __deltemplate_s452_e5792ebc);
    /**
     * @param {{
     *  description: (!goog.soy.data.SanitizedContent|string),
     *  pageIndex: number,
     *  title: (!goog.soy.data.SanitizedContent|string),
     *  total: number
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function __deltemplate_s460_b2357b30(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var description = soy.asserts.assertType(goog.isString(opt_data.description) || opt_data.description instanceof goog.soy.data.SanitizedContent, 'description', opt_data.description, '!goog.soy.data.SanitizedContent|string');
      /** @type {number} */

      soy.asserts.assertType(goog.isNumber(opt_data.pageIndex), 'pageIndex', opt_data.pageIndex, 'number');

      /** @type {!goog.soy.data.SanitizedContent|string} */

      var title = soy.asserts.assertType(goog.isString(opt_data.title) || opt_data.title instanceof goog.soy.data.SanitizedContent, 'title', opt_data.title, '!goog.soy.data.SanitizedContent|string');
      /** @type {number} */

      soy.asserts.assertType(goog.isNumber(opt_data.total), 'total', opt_data.total, 'number');


      var pageTitleAttributes__soy466 = function pageTitleAttributes__soy466() {
        incrementalDom.attr('class', 'lfr-ddm-form-page-title');
      };

      if (title) {
        incrementalDom.elementOpenStart('h2');
        pageTitleAttributes__soy466();
        incrementalDom.elementOpenEnd();
        soyIdom.print(title);
        incrementalDom.elementClose('h2');
      }

      var pageDescriptionAttributes__soy477 = function pageDescriptionAttributes__soy477() {
        incrementalDom.attr('class', 'lfr-ddm-form-page-description');
      };

      if (description) {
        incrementalDom.elementOpenStart('h3');
        pageDescriptionAttributes__soy477();
        incrementalDom.elementOpenEnd();
        soyIdom.print(description);
        incrementalDom.elementClose('h3');
      }
    }

    exports.__deltemplate_s460_b2357b30 = __deltemplate_s460_b2357b30;
    /**
     * @typedef {{
     *  description: (!goog.soy.data.SanitizedContent|string),
     *  pageIndex: number,
     *  title: (!goog.soy.data.SanitizedContent|string),
     *  total: number
     * }}
     */

    __deltemplate_s460_b2357b30.Params;

    if (goog.DEBUG) {
      __deltemplate_s460_b2357b30.soyTemplateName = 'PageRenderer.__deltemplate_s460_b2357b30';
    }

    soy.$$registerDelegateFn(soy.$$getDelTemplateId('PageRenderer.PageHeader.idom'), '', 0, __deltemplate_s460_b2357b30);
    exports.render.params = ["pages", "showSubmitButton", "spritemap", "submitLabel", "total", "_handleFieldBlurred", "_handleFieldClicked", "_handleFieldEdited", "_handleFieldFocused", "activePage", "editable", "editingLanguageId", "empty", "page", "pageIndex", "paginationMode", "readOnly", "strings", "hasFieldRequired", "indicatesRequiredFields", "isAdminPortletNamespace"];
    exports.render.types = {
      "pages": "?",
      "showSubmitButton": "bool",
      "spritemap": "string",
      "submitLabel": "string",
      "total": "number",
      "_handleFieldBlurred": "any",
      "_handleFieldClicked": "any",
      "_handleFieldEdited": "any",
      "_handleFieldFocused": "any",
      "activePage": "number",
      "editable": "bool",
      "editingLanguageId": "string",
      "empty": "bool",
      "page": "?",
      "pageIndex": "number",
      "paginationMode": "string",
      "readOnly": "bool",
      "strings": "map<string, string>",
      "hasFieldRequired": "bool",
      "indicatesRequiredFields": "string",
      "isAdminPortletNamespace": "bool"
    };
    exports.page.params = ["activePage", "pageIndex", "spritemap", "total", "_handleFieldBlurred", "_handleFieldClicked", "_handleFieldEdited", "_handleFieldFocused", "editable", "empty", "page", "hasFieldRequired", "indicatesRequiredFields", "isAdminPortletNamespace"];
    exports.page.types = {
      "activePage": "number",
      "pageIndex": "number",
      "spritemap": "string",
      "total": "number",
      "_handleFieldBlurred": "any",
      "_handleFieldClicked": "any",
      "_handleFieldEdited": "any",
      "_handleFieldFocused": "any",
      "editable": "bool",
      "empty": "bool",
      "page": "?",
      "hasFieldRequired": "bool",
      "indicatesRequiredFields": "string",
      "isAdminPortletNamespace": "bool"
    };
    exports.rows.params = ["activePage", "spritemap", "editable", "pageIndex", "rows", "_handleFieldBlurred", "_handleFieldClicked", "_handleFieldEdited", "_handleFieldFocused"];
    exports.rows.types = {
      "activePage": "number",
      "spritemap": "string",
      "editable": "bool",
      "pageIndex": "number",
      "rows": "list<?>",
      "_handleFieldBlurred": "any",
      "_handleFieldClicked": "any",
      "_handleFieldEdited": "any",
      "_handleFieldFocused": "any"
    };
    exports.row.params = ["activePage", "spritemap", "_handleFieldBlurred", "_handleFieldClicked", "_handleFieldEdited", "_handleFieldFocused", "editable", "pageIndex", "row", "rowIndex"];
    exports.row.types = {
      "activePage": "number",
      "spritemap": "string",
      "_handleFieldBlurred": "any",
      "_handleFieldClicked": "any",
      "_handleFieldEdited": "any",
      "_handleFieldFocused": "any",
      "editable": "bool",
      "pageIndex": "number",
      "row": "?",
      "rowIndex": "number"
    };
    exports.column.params = ["activePage", "spritemap", "_handleFieldBlurred", "_handleFieldClicked", "_handleFieldEdited", "_handleFieldFocused", "column", "columnIndex", "editable", "pageIndex", "rowIndex"];
    exports.column.types = {
      "activePage": "number",
      "spritemap": "string",
      "_handleFieldBlurred": "any",
      "_handleFieldClicked": "any",
      "_handleFieldEdited": "any",
      "_handleFieldFocused": "any",
      "column": "?",
      "columnIndex": "number",
      "editable": "bool",
      "pageIndex": "number",
      "rowIndex": "number"
    };
    exports.placeholder.params = ["size", "columnIndex", "isRow", "pageIndex", "rowIndex"];
    exports.placeholder.types = {
      "size": "number",
      "columnIndex": "number",
      "isRow": "bool",
      "pageIndex": "number",
      "rowIndex": "number"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var PageRenderer = /*#__PURE__*/function (_Component) {
    _inherits(PageRenderer, _Component);

    function PageRenderer() {
      _classCallCheck(this, PageRenderer);

      return _possibleConstructorReturn(this, _getPrototypeOf(PageRenderer).apply(this, arguments));
    }

    return PageRenderer;
  }(_metalComponent["default"]);

  exports.PageRenderer = PageRenderer;

  _metalSoy["default"].register(PageRenderer, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=PageRenderer.soy.js.map
});
//# sourceMappingURL=PageRenderer.soy.js.map