Liferay.Loader.define("dynamic-data-mapping-form-renderer@4.0.70/js/containers/PaginationControls/PaginationControls.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.DDMFormPaginationControls = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from PaginationControls.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace DDM.Form.PaginationControls.
     * @public
     */

    goog.module('DDM.Form.PaginationControls.incrementaldom');

    goog.require('goog.soy.data.SanitizedContent');

    goog.require('goog.string');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');
    /**
     * @param {{
     *  activePage: number,
     *  showSubmitButton: boolean,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  submitLabel: (!goog.soy.data.SanitizedContent|string),
     *  total: number,
     *  _handleNextClicked: (*|null|undefined),
     *  _handlePreviousClicked: (*|null|undefined),
     *  readOnly: (boolean|null|undefined),
     *  strings: (!Object<!goog.soy.data.SanitizedContent|string,!goog.soy.data.SanitizedContent|string>|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {number} */

      var activePage = soy.asserts.assertType(goog.isNumber(opt_data.activePage), 'activePage', opt_data.activePage, 'number');
      /** @type {boolean} */

      var showSubmitButton = soy.asserts.assertType(goog.isBoolean(opt_data.showSubmitButton) || opt_data.showSubmitButton === 1 || opt_data.showSubmitButton === 0, 'showSubmitButton', opt_data.showSubmitButton, 'boolean');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var spritemap = soy.asserts.assertType(goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|string');
      /** @type {!goog.soy.data.SanitizedContent|string} */

      var submitLabel = soy.asserts.assertType(goog.isString(opt_data.submitLabel) || opt_data.submitLabel instanceof goog.soy.data.SanitizedContent, 'submitLabel', opt_data.submitLabel, '!goog.soy.data.SanitizedContent|string');
      /** @type {number} */

      var total = soy.asserts.assertType(goog.isNumber(opt_data.total), 'total', opt_data.total, 'number');
      /** @type {*|null|undefined} */

      var _handleNextClicked = opt_data._handleNextClicked;
      /** @type {*|null|undefined} */

      var _handlePreviousClicked = opt_data._handlePreviousClicked;
      /** @type {boolean|null|undefined} */

      var readOnly = soy.asserts.assertType(opt_data.readOnly == null || goog.isBoolean(opt_data.readOnly) || opt_data.readOnly === 1 || opt_data.readOnly === 0, 'readOnly', opt_data.readOnly, 'boolean|null|undefined');
      /** @type {!Object<!goog.soy.data.SanitizedContent|string,!goog.soy.data.SanitizedContent|string>|null|undefined} */

      var strings = soy.asserts.assertType(opt_data.strings == null || goog.isObject(opt_data.strings), 'strings', opt_data.strings, '!Object<!goog.soy.data.SanitizedContent|string,!goog.soy.data.SanitizedContent|string>|null|undefined');
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'lfr-ddm-form-pagination-controls');
      incrementalDom.elementOpenEnd();

      if (activePage > 0) {
        incrementalDom.elementOpenStart('button');
        incrementalDom.attr('class', 'btn btn-primary lfr-ddm-form-pagination-prev');
        incrementalDom.attr('data-onclick', _handlePreviousClicked);
        incrementalDom.attr('type', 'button');
        incrementalDom.elementOpenEnd();
        var currentPreviousLabel__soy1394 = strings != null ? strings['previous'] : '';

        if (currentPreviousLabel__soy1394 != '') {
          incrementalDom.elementOpenStart('svg');
          incrementalDom.attr('class', 'lexicon-icon');
          incrementalDom.elementOpenEnd();
          incrementalDom.elementOpenStart('use');
          incrementalDom.attr('xlink:href', spritemap + '#angle-left');
          incrementalDom.elementOpenEnd();
          incrementalDom.elementClose('use');
          incrementalDom.elementClose('svg');
          incrementalDom.text(' ');
          soyIdom.print(currentPreviousLabel__soy1394);
        } else {
          incrementalDom.elementOpenStart('svg');
          incrementalDom.attr('class', 'lexicon-icon');
          incrementalDom.elementOpenEnd();
          incrementalDom.elementOpenStart('use');
          incrementalDom.attr('xlink:href', spritemap + '#angle-left');
          incrementalDom.elementOpenEnd();
          incrementalDom.elementClose('use');
          incrementalDom.elementClose('svg');
          incrementalDom.text(' ');
          /** @desc  */

          var MSG_EXTERNAL_6095534740119293938 = Liferay.Language.get('previous');
          incrementalDom.text(goog.string.unescapeEntities(MSG_EXTERNAL_6095534740119293938));
        }

        incrementalDom.elementClose('button');
      }

      if (activePage < total - 1) {
        incrementalDom.elementOpenStart('button');
        incrementalDom.attr('class', 'btn btn-primary lfr-ddm-form-pagination-next pull-right');
        incrementalDom.attr('data-onclick', _handleNextClicked);
        incrementalDom.attr('type', 'button');
        incrementalDom.elementOpenEnd();
        var currentNextLabel__soy1418 = strings != null ? strings['next'] : '';

        if (currentNextLabel__soy1418 != '') {
          soyIdom.print(currentNextLabel__soy1418);
          incrementalDom.text(' ');
          incrementalDom.elementOpenStart('svg');
          incrementalDom.attr('class', 'lexicon-icon');
          incrementalDom.elementOpenEnd();
          incrementalDom.elementOpenStart('use');
          incrementalDom.attr('xlink:href', spritemap + '#angle-right');
          incrementalDom.elementOpenEnd();
          incrementalDom.elementClose('use');
          incrementalDom.elementClose('svg');
        } else {
          /** @desc  */
          var MSG_EXTERNAL_5736512712252459867 = Liferay.Language.get('next');
          incrementalDom.text(goog.string.unescapeEntities(MSG_EXTERNAL_5736512712252459867));
          incrementalDom.text(' ');
          incrementalDom.elementOpenStart('svg');
          incrementalDom.attr('class', 'lexicon-icon');
          incrementalDom.elementOpenEnd();
          incrementalDom.elementOpenStart('use');
          incrementalDom.attr('xlink:href', spritemap + '#angle-right');
          incrementalDom.elementOpenEnd();
          incrementalDom.elementClose('use');
          incrementalDom.elementClose('svg');
        }

        incrementalDom.elementClose('button');
      }

      if (activePage == total - 1 && !readOnly && showSubmitButton) {
        incrementalDom.elementOpenStart('button');
        incrementalDom.attr('class', 'btn btn-primary lfr-ddm-form-submit pull-right');
        incrementalDom.attr('type', 'submit');
        incrementalDom.elementOpenEnd();
        soyIdom.print(submitLabel);
        incrementalDom.elementClose('button');
      }

      incrementalDom.elementClose('div');
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  activePage: number,
     *  showSubmitButton: boolean,
     *  spritemap: (!goog.soy.data.SanitizedContent|string),
     *  submitLabel: (!goog.soy.data.SanitizedContent|string),
     *  total: number,
     *  _handleNextClicked: (*|null|undefined),
     *  _handlePreviousClicked: (*|null|undefined),
     *  readOnly: (boolean|null|undefined),
     *  strings: (!Object<!goog.soy.data.SanitizedContent|string,!goog.soy.data.SanitizedContent|string>|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'DDM.Form.PaginationControls.render';
    }

    exports.render.params = ["activePage", "showSubmitButton", "spritemap", "submitLabel", "total", "_handleNextClicked", "_handlePreviousClicked", "readOnly", "strings"];
    exports.render.types = {
      "activePage": "number",
      "showSubmitButton": "bool",
      "spritemap": "string",
      "submitLabel": "string",
      "total": "number",
      "_handleNextClicked": "any",
      "_handlePreviousClicked": "any",
      "readOnly": "bool",
      "strings": "map<string, string>"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var DDMFormPaginationControls = /*#__PURE__*/function (_Component) {
    _inherits(DDMFormPaginationControls, _Component);

    function DDMFormPaginationControls() {
      _classCallCheck(this, DDMFormPaginationControls);

      return _possibleConstructorReturn(this, _getPrototypeOf(DDMFormPaginationControls).apply(this, arguments));
    }

    return DDMFormPaginationControls;
  }(_metalComponent["default"]);

  exports.DDMFormPaginationControls = DDMFormPaginationControls;

  _metalSoy["default"].register(DDMFormPaginationControls, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=PaginationControls.soy.js.map
});
//# sourceMappingURL=PaginationControls.soy.js.map