Liferay.Loader.define("dynamic-data-mapping-form-renderer@4.0.70/js/containers/Wizard/Wizard.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports["default"] = exports.templates = exports.DDMFormWizard = void 0;

  var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

  var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : { "default": obj };
  }

  function _typeof(obj) {
    "@babel/helpers - typeof";
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function _typeof(obj) {
        return typeof obj;
      };
    } else {
      _typeof = function _typeof(obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }return _typeof(obj);
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (_typeof(call) === "object" || typeof call === "function")) {
      return call;
    }return _assertThisInitialized(self);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }return self;
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };return _getPrototypeOf(o);
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;return o;
    };return _setPrototypeOf(o, p);
  }

  var templates;
  exports.templates = templates;
  goog.loadModule(function (exports) {
    var soy = goog.require('soy');

    goog.require('soydata');

    // This file was automatically generated from Wizard.soy.
    // Please don't edit this file by hand.

    /**
     * @fileoverview Templates in namespace DDM.Form.Wizard.
     * @hassoydeltemplate {DDM.Form.Pagination.item.idom}
     * @hassoydelcall {DDM.Form.Pagination.item.idom}
     * @public
     */

    goog.module('DDM.Form.Wizard.incrementaldom');

    var incrementalDom = goog.require('incrementaldom');

    goog.require('soy');

    goog.require('soy.asserts');

    var soyIdom = goog.require('soy.idom');
    /**
     * @param {{
     *  activePage: number,
     *  pages: (?),
     *  _handleItemClicked: (*|null|undefined),
     *  editable: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      var $$temp;
      /** @type {number} */

      var activePage = soy.asserts.assertType(goog.isNumber(opt_data.activePage), 'activePage', opt_data.activePage, 'number');
      /** @type {?} */

      var pages = opt_data.pages;
      /** @type {*|null|undefined} */

      var _handleItemClicked = opt_data._handleItemClicked;
      /** @type {boolean|null|undefined} */

      var editable = soy.asserts.assertType(opt_data.editable == null || goog.isBoolean(opt_data.editable) || opt_data.editable === 1 || opt_data.editable === 0, 'editable', opt_data.editable, 'boolean|null|undefined');
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'ddm-form-pagination position-relative wizard-mode');
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpenStart('ol');
      incrementalDom.attr('class', 'dmm-wizard multi-step-indicator-label-top multi-step-nav multi-step-nav-collapse-sm');
      incrementalDom.elementOpenEnd();
      var page1721List = pages;
      var page1721ListLen = page1721List.length;

      for (var page1721Index = 0; page1721Index < page1721ListLen; page1721Index++) {
        var page1721Data = page1721List[page1721Index];
        var itemRenderer__soy1711 = ($$temp = page1721Data.paginationItemRenderer) == null ? 'wizard' : $$temp;
        soy.$$getDelegateFn(soy.$$getDelTemplateId('DDM.Form.Pagination.item.idom'), itemRenderer__soy1711, false)({
          _handleItemClicked: _handleItemClicked,
          activePage: activePage,
          editable: editable,
          page: page1721Data,
          pageIndex: page1721Index,
          total: pages.length
        }, null, opt_ijData);
      }

      incrementalDom.elementClose('ol');
      incrementalDom.elementClose('div');
    }

    exports.render = $render;
    /**
     * @typedef {{
     *  activePage: number,
     *  pages: (?),
     *  _handleItemClicked: (*|null|undefined),
     *  editable: (boolean|null|undefined)
     * }}
     */

    $render.Params;

    if (goog.DEBUG) {
      $render.soyTemplateName = 'DDM.Form.Wizard.render';
    }
    /**
     * @param {{
     *  activePage: number,
     *  page: (?),
     *  pageIndex: number,
     *  total: number,
     *  _handleItemClicked: (*|null|undefined),
     *  editable: (boolean|null|undefined)
     * }} opt_data
     * @param {Object<string, *>=} opt_ijData
     * @param {Object<string, *>=} opt_ijData_deprecated
     * @return {void}
     * @suppress {checkTypes}
     */

    function __deltemplate_s1724_1206c726(opt_data, opt_ijData, opt_ijData_deprecated) {
      opt_ijData = opt_ijData_deprecated || opt_ijData;
      /** @type {number} */

      var activePage = soy.asserts.assertType(goog.isNumber(opt_data.activePage), 'activePage', opt_data.activePage, 'number');
      /** @type {?} */

      var page = opt_data.page;
      /** @type {number} */

      var pageIndex = soy.asserts.assertType(goog.isNumber(opt_data.pageIndex), 'pageIndex', opt_data.pageIndex, 'number');
      /** @type {number} */

      var total = soy.asserts.assertType(goog.isNumber(opt_data.total), 'total', opt_data.total, 'number');
      /** @type {*|null|undefined} */

      var _handleItemClicked = opt_data._handleItemClicked;
      /** @type {boolean|null|undefined} */

      var editable = soy.asserts.assertType(opt_data.editable == null || goog.isBoolean(opt_data.editable) || opt_data.editable === 1 || opt_data.editable === 0, 'editable', opt_data.editable, 'boolean|null|undefined');
      var msg_16612__soy16613 = '';
      /** @desc  */

      var MSG_EXTERNAL_6307512279120904193 = Liferay.Language.get('untitled-page');
      msg_16612__soy16613 += MSG_EXTERNAL_6307512279120904193;
      var step__soy1732 = pageIndex + 1;
      var classes__soy1734 = '';
      classes__soy1734 += 'multi-step-item';
      classes__soy1734 += step__soy1732 != total ? ' multi-step-item-expand' : '';
      classes__soy1734 += pageIndex == activePage ? ' active' : '';

      var itemAttributes__soy1745 = function itemAttributes__soy1745() {
        incrementalDom.attr('class', classes__soy1734);

        if (editable) {
          incrementalDom.attr('data-onclick', _handleItemClicked);
        }

        incrementalDom.attr('data-page-index', pageIndex);
      };

      incrementalDom.elementOpenStart('li');
      itemAttributes__soy1745();
      incrementalDom.elementOpenEnd();
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'multi-step-divider');
      incrementalDom.elementOpenEnd();
      incrementalDom.elementClose('div');
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'multi-step-indicator');
      incrementalDom.elementOpenEnd();
      var defaultPageTitle__soy1760 = '';
      defaultPageTitle__soy1760 += msg_16612__soy16613;
      var title__soy1767 = page.title ? page.title : defaultPageTitle__soy1760;
      incrementalDom.elementOpenStart('div');
      incrementalDom.attr('class', 'multi-step-indicator-label');
      incrementalDom.elementOpenEnd();
      soyIdom.print(title__soy1767);
      incrementalDom.elementClose('div');

      if (editable) {
        incrementalDom.elementOpenStart('a');
        incrementalDom.attr('class', 'multi-step-icon');
        incrementalDom.attr('data-multi-step-icon', step__soy1732);
        incrementalDom.attr('href', 'javascript:;');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementClose('a');
      } else {
        incrementalDom.elementOpenStart('span');
        incrementalDom.attr('class', 'multi-step-icon');
        incrementalDom.attr('data-multi-step-icon', step__soy1732);
        incrementalDom.elementOpenEnd();
        incrementalDom.elementClose('span');
      }

      incrementalDom.elementClose('div');
      incrementalDom.elementClose('li');
    }

    exports.__deltemplate_s1724_1206c726 = __deltemplate_s1724_1206c726;
    /**
     * @typedef {{
     *  activePage: number,
     *  page: (?),
     *  pageIndex: number,
     *  total: number,
     *  _handleItemClicked: (*|null|undefined),
     *  editable: (boolean|null|undefined)
     * }}
     */

    __deltemplate_s1724_1206c726.Params;

    if (goog.DEBUG) {
      __deltemplate_s1724_1206c726.soyTemplateName = 'DDM.Form.Wizard.__deltemplate_s1724_1206c726';
    }

    soy.$$registerDelegateFn(soy.$$getDelTemplateId('DDM.Form.Pagination.item.idom'), 'wizard', 0, __deltemplate_s1724_1206c726);
    exports.render.params = ["activePage", "pages", "_handleItemClicked", "editable"];
    exports.render.types = {
      "activePage": "number",
      "pages": "?",
      "_handleItemClicked": "any",
      "editable": "bool"
    };
    exports.templates = templates = exports;
    return exports;
  });

  var DDMFormWizard = /*#__PURE__*/function (_Component) {
    _inherits(DDMFormWizard, _Component);

    function DDMFormWizard() {
      _classCallCheck(this, DDMFormWizard);

      return _possibleConstructorReturn(this, _getPrototypeOf(DDMFormWizard).apply(this, arguments));
    }

    return DDMFormWizard;
  }(_metalComponent["default"]);

  exports.DDMFormWizard = DDMFormWizard;

  _metalSoy["default"].register(DDMFormWizard, templates);

  var _default = templates;
  /* jshint ignore:end */

  exports["default"] = _default;
  //# sourceMappingURL=Wizard.soy.js.map
});
//# sourceMappingURL=Wizard.soy.js.map