Liferay.Loader.define("dynamic-data-mapping-form-builder@2.0.87/js/util/config.es", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-state'], function (module, exports, require) {
  var define = undefined;
  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ruleStructure = exports.focusedFieldStructure = exports.pageStructure = void 0;

  var _metalState = require("frontend-js-metal-web$metal-state");

  /**
   * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
   *
   * This library is free software; you can redistribute it and/or modify it under
   * the terms of the GNU Lesser General Public License as published by the Free
   * Software Foundation; either version 2.1 of the License, or (at your option)
   * any later version.
   *
   * This library is distributed in the hope that it will be useful, but WITHOUT
   * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
   * details.
   */
  var pageStructure = _metalState.Config.shapeOf({
    description: _metalState.Config.string(),
    rows: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
      columns: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
        fields: _metalState.Config.array(),
        size: _metalState.Config.number()
      }))
    })),
    title: _metalState.Config.string()
  });

  exports.pageStructure = pageStructure;

  var focusedFieldStructure = _metalState.Config.shapeOf({
    columnIndex: _metalState.Config.number(),
    name: _metalState.Config.string().required(),
    pageIndex: _metalState.Config.number(),
    rowIndex: _metalState.Config.number()
  });

  exports.focusedFieldStructure = focusedFieldStructure;

  var ruleStructure = _metalState.Config.shapeOf({
    actions: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
      action: _metalState.Config.string(),
      label: _metalState.Config.string(),
      target: _metalState.Config.string()
    })),
    conditions: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
      operands: _metalState.Config.arrayOf(_metalState.Config.shapeOf({
        label: _metalState.Config.string(),
        repeatable: _metalState.Config.bool(),
        type: _metalState.Config.string(),
        value: _metalState.Config.string()
      })),
      operator: _metalState.Config.string()
    })),
    logicalOperator: _metalState.Config.string()
  });

  exports.ruleStructure = ruleStructure;
  //# sourceMappingURL=config.es.js.map
});
//# sourceMappingURL=config.es.js.map